--------------------------------------------------------------------------------
function LoadConfig()
--------------------------------------------------------------------------------

	if (Configuration.ConfigLog == nil) then
		Configuration["ConfigLog"] = false
	end

	Configuration[Eu].Behaviour = DefaultBeha
	Configuration[Eu].AggroHP   = AggroHP

	SkillsMinSP = Configuration[Eu].SkillsMinSP


	local f_in = io.open("AI/USER_AI/Configurations/User data/Configuration.txt", "r")
	if f_in ~= nil then
		
		GetConfigurationsFromOpenFile(f_in, Configuration.ConfigLog)

		f_in:close()

		SkillsMinSP = Configuration[Eu].SkillsMinSP
	end
end

--------------------------------------------------------------------------------
ConfigUpdateTime = 0
--------------------------------
function UpdateConfig()
--------------------------------------------------------------------------------

	if ConfigUpdateTime == 0 then
		ConfigUpdateTime = GetTick() + 10000
	elseif GetTick() > ConfigUpdateTime then
		ConfigUpdateTime = GetTick() + 10000
	else
		return
	end

	if     HomunType ~= nil then
		if FileExists(File_Beha_H) then
			DefaultBeha = Beha_Attack
		else
			DefaultBeha = Beha_Defend
		end
	elseif MercType ~= nil then
		if FileExists(File_Beha_M) then
			DefaultBeha = Beha_Attack
		else
			DefaultBeha = Beha_Defend
		end
	end

	LoadSkillToType()
	LoadBehavToID_or_Type()

	local f_in = io.open("AI/USER_AI/Configurations/User data/Setup.txt", "r")
	if f_in ~= nil then
		
		GetConfigurationsFromOpenFile(f_in)
		
		f_in:close()
		if FileExists("AI/USER_AI/Configurations/User data/Setup.txt") then
			os.remove("AI/USER_AI/Configurations/User data/Setup.txt")
		end
	else
		ConfigUpdateTime = ConfigUpdateTime + math.random(1, 3) * 1000
	end

	local configurationData = {}
	f_in = io.open("AI/USER_AI/Configurations/User data/Configuration.txt", "r")
	if f_in ~= nil then
		
		local ln, count
		count = 1

		ln = f_in:read()

		while ln ~= nil do
			configurationData[count] = ln
			count = count + 1

			ln = f_in:read()
		end
		
		f_in:close()
	else
		ConfigUpdateTime = ConfigUpdateTime + math.random(1, 3) * 1000
	end

	local f_out = io.open("AI/USER_AI/Configurations/User data/Configuration.txt", "w")
	if f_out ~= nil then
		
		SetConfigurationsToOpenFile(f_out, configurationData)
		
		f_out:close()
	end
end

--------------------------------------------------------------------------------
function SetConfigurationsToOpenFile(f_out, configurationData, Logging)
--------------------------------------------------------------------------------
	if Logging == nil then
		Logging = false
	end

	--  Reescreve o arquivo de configuraes com as opes atuais.

	local start_count = 1

	local find_pos
	local start_found = false

	if Eu == 1 then
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Homunculus:\n")
		f_out:write("------------------------------------------------------------\n")
		f_out:write("1.SkillsMinSP: "..Configuration[1].SkillsMinSP.."\n")
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Bno Catica:\n")
		f_out:write("1.CB.Idle; PChance: "..Configuration[1].CB.Idle.PChance.."; MastMinH: "..Configuration[1].CB.Idle.MastMinH.."; MyMinHP: "..Configuration[1].CB.Idle.MyMinHP.."\n")
		f_out:write("1.CB.Chase; PChance: "..Configuration[1].CB.Chase.PChance.."; MastMinH: "..Configuration[1].CB.Chase.MastMinH.."; MyMinHP: "..Configuration[1].CB.Chase.MyMinHP.."\n")
		f_out:write("1.CB.Attack; PChance: "..Configuration[1].CB.Attack.PChance.."; MastMinH: "..Configuration[1].CB.Attack.MastMinH.."; MyMinHP: "..Configuration[1].CB.Attack.MyMinHP.."\n")
		f_out:write("1.CB.Patrol; PChance: "..Configuration[1].CB.Patrol.PChance.."; MastMinH: "..Configuration[1].CB.Patrol.MastMinH.."; MyMinHP: "..Configuration[1].CB.Patrol.MyMinHP.."\n")
		f_out:write("1.CB.FollowCMD; PChance: "..Configuration[1].CB.FollowCMD.PChance.."; MastMinH: "..Configuration[1].CB.FollowCMD.MastMinH.."; MyMinHP: "..Configuration[1].CB.FollowCMD.MyMinHP.."\n")
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Sede de Sangue:\n")
		f_out:write("1.BL.Attack; PChance_MVP: "..Configuration[1].BL.Attack.PChance_MVP.."; PChance_PVP: "..Configuration[1].BL.Attack.PChance_PVP.."; PChance_LHP: "..Configuration[1].BL.Attack.PChance_LHP.."; PChance_RND: "..Configuration[1].BL.Attack.PChance_RND.."\n")
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Troca de Lugar:\n")
		if Configuration[1].CT.Chase.Active then
			f_out:write("1.CT.Chase; Active: true\n")
		else
			f_out:write("1.CT.Chase; Active: false\n")
		end
		if Configuration[1].CT.Attack.Active then
			f_out:write("1.CT.Attack; Active: true\n")
		else
			f_out:write("1.CT.Attack; Active: false\n")
		end
		if Configuration[1].CT.FollowCMD.Active then
			f_out:write("1.CT.FollowCMD; Active: true\n")
		else
			f_out:write("1.CT.FollowCMD; Active: false\n")
		end
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Fortaleza:\n")
		f_out:write("1.BW.Attack; PChance: "..Configuration[1].BW.Attack.PChance.."\n")
	else
		f_out:write("------------------------------------------------------------\n")
		for i, v in ipairs (configurationData) do
			--Log(i..", "..v, true)

			find_pos = string.find(v, "--  Homunculus:")
			if find_pos ~= nil then
				f_out:write(v.."\n")

				start_found = true
				start_count = i
			end
			if start_found and i > start_count then	
				find_pos = string.find(v, "--  Assistente:")
				if find_pos == nil then
					f_out:write(v.."\n")
				else
					start_count = i
					break
				end
			end
		end
	end

	if Eu == 2 then
		f_out:write("------------------------------------------------------------\n")
		f_out:write("--  Assistente:\n")
		f_out:write("------------------------------------------------------------\n")
		f_out:write("2.SkillsMinSP: "..Configuration[2].SkillsMinSP.."\n")
	else
		start_found = false
		for i, v in ipairs (configurationData) do
			--Log(i..", "..v, true)

			find_pos = string.find(v, "--  Assistente:")
			if find_pos ~= nil then
				f_out:write(v.."\n")

				start_found = true
				start_count = i
			end
			if start_found and i > start_count then	
				find_pos = string.find(v, "--  Desconhece:")
				if find_pos == nil then
					f_out:write(v.."\n")
				else
					start_count = i
					break
				end
			end
		end
	end

	if Eu == 3 then

	else

	end
end

--------------------------------------------------------------------------------
function GetConfigurationsFromOpenFile(f_in, Logging)
--------------------------------------------------------------------------------
	if Logging == nil then
		Logging = false
	end

	local ln, nbr, boolean
	local find_pos, lstfind_pos, nxtfind_pos

	ln = f_in:read()
	while ln ~= nil do

		if Logging then
			Log(ln, true)
		end

		--  Configuraes nicas
		find_pos = string.find(ln, Eu..".SkillsMinSP")
		if find_pos ~= nil then

			if Logging then
				Log("[SkillsMinSP]", true)
			end
	
			find_pos = string.find(ln, ":")
			if find_pos ~= nil then
	
				if Logging then
					Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
				end

				nbr = tonumber(string.sub(ln, find_pos + 1))
				if nbr ~= nil then
					Configuration[Eu].SkillsMinSP = nbr

					if Logging then
						Log("[Configuration["..Eu.."].SkillsMinSP = "..Configuration[Eu].SkillsMinSP..".]", true)
					end

				end
			end
			if Logging then
				Log("\n", true)
			end
		end

		--  Configuraes mltiplas
		find_pos = string.find(ln, Eu..".CB")
		if find_pos ~= nil then

			find_pos = string.find(ln, ".Idle")	
			if find_pos ~= nil then
	
				if Logging then
					Log("[ChaoticBless]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
					if nxtfind_pos ~= nil then

						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end

						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then

							Configuration[Eu].CB.Idle.PChance = nbr

							if Logging then
								Log("[Configuration["..Eu.."].CB.Idle.PChance = "..Configuration[Eu].CB.Idle.PChance..".]", true)
							end

						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
		
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then

						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
		
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then

							Configuration[Eu].CB.Idle.MastMinH = nbr

							if Logging then
								Log("[Configuration["..Eu.."].CB.Idle.MastMinH = "..Configuration[Eu].CB.Idle.MastMinH..".]", true)
							end
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].CB.Idle.MyMinHP = nbr

						if Logging then
							Log("[Configuration["..Eu.."].CB.Idle.MyMinHP = "..Configuration[Eu].CB.Idle.MyMinHP..".]", true)
						end

					end
				end
				if Logging then
					Log("\n", true)
				end
			end

			find_pos = string.find(ln, ".Chase")	
			if find_pos ~= nil then

				if Logging then
					Log("[ChaoticBless]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					nxtfind_pos = string.find(ln, ";", find_pos + 1)
					if nxtfind_pos ~= nil then

						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end

						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then

							Configuration[Eu].CB.Chase.PChance = nbr

							if Logging then
								Log("[Configuration["..Eu.."].CB.Chase.PChance = "..Configuration[Eu].CB.Chase.PChance..".]", true)
							end

						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.

					nxtfind_pos = string.find(ln, ";", find_pos + 1)

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then
		
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end	
		
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then

							Configuration[Eu].CB.Chase.MastMinH = nbr

							if Logging then
								Log("[Configuration["..Eu.."].CB.Chase.MastMinH = "..Configuration[Eu].CB.Chase.MastMinH..".]", true)
							end
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].CB.Chase.MyMinHP = nbr

						if Logging then
							Log("[Configuration["..Eu.."].CB.Chase.MyMinHP = "..Configuration[Eu].CB.Chase.MyMinHP..".]", true)
						end

					end
				end
				if Logging then
					Log("\n", true)
				end
			end

			find_pos = string.find(ln, ".Attack")	
			if find_pos ~= nil then
	
				if Logging then
					Log("[ChaoticBless]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
					if nxtfind_pos ~= nil then
		
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
	
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
		
							Configuration[Eu].CB.Attack.PChance = nbr
	
							if Logging then
								Log("[Configuration["..Eu.."].CB.Attack.PChance = "..Configuration[Eu].CB.Attack.PChance..".]", true)
							end	
	
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
		
					if nxtfind_pos ~= nil then
	
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
			
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
	
							Configuration[Eu].CB.Attack.MastMinH = nbr
	
							if Logging then
								Log("[Configuration["..Eu.."].CB.Attack.MastMinH = "..Configuration[Eu].CB.Attack.MastMinH..".]", true)
							end
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].CB.Attack.MyMinHP = nbr
	
						if Logging then
							Log("[Configuration["..Eu.."].CB.Attack.MyMinHP = "..Configuration[Eu].CB.Attack.MyMinHP..".]", true)
						end
	
					end
				end
				if Logging then
					Log("\n", true)
				end
			end
	
			find_pos = string.find(ln, ".Patrol")	
			if find_pos ~= nil then
	
				if Logging then
					Log("[ChaoticBless]", true)
				end
	
				find_pos = string.find(ln, ":")
				if find_pos ~= nil then
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
					if nxtfind_pos ~= nil then
	
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
	
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
	
							Configuration[Eu].CB.Patrol.PChance = nbr
	
							if Logging then
								Log("[Configuration["..Eu.."].CB.Patrol.PChance = "..Configuration[Eu].CB.Patrol.PChance..".]", true)
							end
		
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					if nxtfind_pos ~= nil then
		
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
			
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
	
							Configuration[Eu].CB.Patrol.MastMinH = nbr
		
							if Logging then
								Log("[Configuration["..Eu.."].CB.Patrol.MastMinH = "..Configuration[Eu].CB.Patrol.MastMinH..".]", true)
							end
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].CB.Patrol.MyMinHP = nbr
		
						if Logging then
							Log("[Configuration["..Eu.."].CB.Patrol.MyMinHP = "..Configuration[Eu].CB.Patrol.MyMinHP..".]", true)
						end
	
					end
				end
				if Logging then
					Log("\n", true)
				end
			end
	
			find_pos = string.find(ln, ".FollowCMD")	
			if find_pos ~= nil then
	
				if Logging then
					Log("[ChaoticBless]", true)
				end
	
				find_pos = string.find(ln, ":")
				if find_pos ~= nil then
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
			
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
					if nxtfind_pos ~= nil then
				
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
		
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
		
							Configuration[Eu].CB.FollowCMD.PChance = nbr
	
							if Logging then
								Log("[Configuration["..Eu.."].CB.FollowCMD.PChance = "..Configuration[Eu].CB.FollowCMD.PChance..".]", true)
							end
		
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					if nxtfind_pos ~= nil then
			
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
				
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
		
							Configuration[Eu].CB.FollowCMD.MastMinH = nbr
		
							if Logging then
								Log("[Configuration["..Eu.."].CB.FollowCMD.MastMinH = "..Configuration[Eu].CB.FollowCMD.MastMinH..".]", true)
							end
						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end
	
				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then --  +1.
	
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
	
					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].CB.FollowCMD.MyMinHP = nbr
	
						if Logging then
							Log("[Configuration["..Eu.."].CB.FollowCMD.MyMinHP = "..Configuration[Eu].CB.FollowCMD.MyMinHP..".]", true)
						end
	
					end
				end
				if Logging then
					Log("\n", true)
				end
			end
		end	
			
		find_pos = string.find(ln, Eu..".BL")
		if find_pos ~= nil then

			find_pos = string.find(ln, ".Attack")
			if find_pos ~= nil then

				if Logging then
					Log("[BloodLust]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					nxtfind_pos = string.find(ln, ";", find_pos + 1)

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then

						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end
	
						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
							Configuration[Eu].BL.Attack.PChance_MVP = nbr

							if Logging then
								Log("[Configuration["..Eu.."].BL.Attack.PChance_MVP = "..Configuration[Eu].BL.Attack.PChance_MVP..".]", true)
							end

						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then

					nxtfind_pos = string.find(ln, ";", find_pos + 1)

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then

					if Logging then
						Log("[configurao termina em: "..nxtfind_pos..".]", true)
					end

					nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
							Configuration[Eu].BL.Attack.PChance_PVP = nbr

							if Logging then
								Log("[Configuration["..Eu.."].BL.Attack.PChance_PVP = "..Configuration[Eu].BL.Attack.PChance_PVP..".]", true)
							end

						end
					end
					lstfind_pos = find_pos
				end
				if lstfind_pos == nil then
					lstfind_pos = 0
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then
	
					nxtfind_pos = string.find(ln, ";", find_pos + 1)
		
					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then
	
						if Logging then
							Log("[configurao termina em: "..nxtfind_pos..".]", true)
						end

						nbr = tonumber(string.sub(ln, find_pos + 1, nxtfind_pos - 1))
						if nbr ~= nil then
							Configuration[Eu].BL.Attack.PChance_LHP = nbr
			
							if Logging then
								Log("[Configuration["..Eu.."].BL.Attack.PChance_LHP = "..Configuration[Eu].BL.Attack.PChance_LHP..".]", true)
							end

						end
					end
					lstfind_pos = find_pos
				end

				find_pos = string.find(ln, ":", lstfind_pos + 1)
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					if nxtfind_pos ~= nil then

						nbr = tonumber(string.sub(ln, find_pos + 1))
						if nbr ~= nil then
							Configuration[Eu].BL.Attack.PChance_RND = nbr

							if Logging then
								Log("[Configuration["..Eu.."].BL.Attack.PChance_RND = "..Configuration[Eu].BL.Attack.PChance_RND..".]", true)
							end

						end
					end
				end
				if Logging then
					Log("\n", true)
				end
			end
		end

		find_pos = string.find(ln, Eu..".CT")
		if find_pos ~= nil then

			find_pos = string.find(ln, ".Chase")
			if find_pos ~= nil then

				if Logging then
					Log("[Castling]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					boolean = string.sub(ln, find_pos + 2)
					if boolean ~= nil then
						if boolean == "true" then
							Configuration[Eu].CT.Chase.Active = true
						else
							Configuration[Eu].CT.Chase.Active = false
						end
					end

					if Logging then
						Log("[Configuration["..Eu.."].CT.Chase.Active ="..boolean..".]", true)
					end
				end
			end
			find_pos = string.find(ln, ".Attack")
			if find_pos ~= nil then

				if Logging then
					Log("[Castling]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					boolean = string.sub(ln, find_pos + 2)
					if boolean ~= nil then
						if boolean == "true" then
							Configuration[Eu].CT.Attack.Active = true
						else
							Configuration[Eu].CT.Attack.Active = false
						end
					end

					if Logging then
						Log("[Configuration["..Eu.."].CT.Attack.Active ="..boolean..".]", true)
					end
				end
			end
			find_pos = string.find(ln, ".FollowCMD")
			if find_pos ~= nil then

				if Logging then
					Log("[Castling]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end
	
					boolean = string.sub(ln, find_pos + 2)
					if boolean ~= nil then
						if boolean == "true" then
							Configuration[Eu].CT.FollowCMD.Active = true
						else
							Configuration[Eu].CT.FollowCMD.Active = false
						end
					end

					if Logging then
						Log("[Configuration["..Eu.."].CT.FollowCMD.Active ="..boolean..".]", true)
					end
				end
			end
		end
		find_pos = string.find(ln, Eu..".BW")
		if find_pos ~= nil then

			find_pos = string.find(ln, ".Attack")
			if find_pos ~= nil then

				if Logging then
					Log("[Bulwark]", true)
				end

				find_pos = string.find(ln, ":")
				if find_pos ~= nil then

					if Logging then
						Log("[procurar configurao: encontrado em: "..find_pos..".]", true)
					end

					nbr = tonumber(string.sub(ln, find_pos + 1))
					if nbr ~= nil then
						Configuration[Eu].BW.Attack.PChance = nbr

						if Logging then
							Log("[Configuration["..Eu.."].BW.Attack.PChance = "..Configuration[Eu].BW.Attack.PChance..".]", true)
						end
					end
				end
			end
		end

		ln = f_in:read()
	end
end
