-- ==========================
--  Arquivos Extras
-- ==========================
File_Beha_H             = "./AI/USER_AI/ID DATA/Beha_Attack.txt"
File_Beha_M             = "./AI/USER_AI/ID DATA/Beha_Attack_M.txt"
-----------------------------
--  Abertura dos arquivos.
-----------------------------
Success = false
Error   = ""
-----------------------------
Success, Error = pcall(dofile, "./AI/USER_AI/ID DATA/Types.lua")
if not Success then
	Log(Error)
	IDType = {}
	ErrorRepair_FileTypes = io.open("./AI/USER_AI/ID DATA/Types.lua", "w")
	if ErrorRepair_FileTypes then
		ErrorRepair_FileTypes:write("IDType = {}\n")
		ErrorRepair_FileTypes:close()
		Success, Error = pcall(dofile, "./AI/USER_AI/ID DATA/Types.lua")
		if not Success then
			IDType = {}
		end
	end
end
-- ==========================
--  Estados
-- ==========================
IDLE_ST	                = 0
FOLLOW_ST	        = 1
CHASE_ST	        = 2
ATTACK_ST	        = 3
MOVE_CMD_ST	        = 4
STOP_CMD_ST	        = 5
ATTACK_OBJECT_CMD_ST	= 6
ATTACK_AREA_CMD_ST	= 7
PATROL_CMD_ST	        = 8
HOLD_CMD_ST	        = 9
SKILL_OBJECT_CMD_ST	= 10
SKILL_AREA_CMD_ST	= 11
FOLLOW_CMD_ST	        = 12
-- ==========================
--  Variveis
-- ==========================
MyState	                = IDLE_ST
MyEnemy	                = 0
MyDestX	                = -1
MyDestY	                = -1
MyPatrolX	        = -1
MyPatrolY	        = -1
ResCmdList	        = List.new()
MyID	                = 0
MySkill	                = 0
MySkillLevel	        = 0
-----------------------------
DefaultBeha             = Beha_Defend
ForceDancing            = false
FirstFollow             = true
-----------------------------
Had_MOTION_detect_count = 0
Had_MOTION_Timer        = 0
Had_MOTION_detect_timer = 0
Had_MOTION_SKILL        = {}
Had_MOTION_PICKUP       = {}
-----------------------------
Unreachable             = {}
Unreachable_Motion      = {}
Unreachable_LastMotion  = {}
Unreachable_IsNPC       = {}
EnemyNotChangingMotion  = false
-----------
CanDoKS                 = 0
-----------
MaxDistance             = 15
OwnerPosChanged         = false
-----------
EmergencyVerify         = 1
ComboByPass             = 0
SkillsTurn              = 1
Timer_ToMove            = 0
-----------
CommandTimeOut          = {}
-----------------------------
-----------------------------------
-- ==========================
--  Processamento de Comandos
-- ==========================
---------------------------------------------------------------------------
MoveTimeOut             = 0
LongRangeShooter        = false
-----------
IsPatrol                = false
IsPatrol_Time           = 0
PatrolDests             = {}
PatrolDests_Index       = 1
-----------
UseIdleMovement         = false
-----------------------------
function OnMOVE_CMD(x, y)
---------------------------------------------------------------------------
	Log("OnMOVE_CMD.")
	if MyEnemy > 0 then
		SaveBehavToID_or_Type(MyEnemy, "Defensive")
	end
	ForceDancing = false
	if LongRangeShooter then
		LongRangeShooter = false
		Log("desativar ataque  distncia.")
	end
	if IsPatrol then
		if GetTick() > IsPatrol_Time then
			IsPatrol = false
		end
	end
	if x == OwnerX and y == OwnerY then
		Log("patrulhar: salvando destinos para patrulhar, pelos prximos 10 segundos.")
		ClearPatrolDests()
		IsPatrol_Time = GetTick() + 10000
		IsPatrol      = true
		-----------------------------------------------------------------------------
		Log("destino de datrulha n ("..PatrolDests_Index.."): ("..MyX.."; "..MyY..").")
		PatrolDests[PatrolDests_Index] = {MyX, MyY}
		PatrolDests_Index = PatrolDests_Index + 1
		-----------------------------------------------------------------------------
		UseIdleMovement = true
		return
	end
	if MoveTimeOut == 0 or x ~= MyDestX or y ~= MyDestY then
		MoveTimeOut = GetTick() + 3000
	end
	for i, v in ipairs(StdGetActors()) do
		if v > 0 and (v ~= OwnerID and v ~= MyID) then
			if not PvPHere and IsPlayer(v) and IsMonster(v) == 1 then
				PvPHere = true
			end
			if     (1 == IsMonster(v) and PvPHere) then
				local ex, ey = GetV(V_POSITION, v)
				if (ex == x) and (ey == y) then
					if v == MyEnemy then
						ForceDancing = true
					end
					MyEnemy = v
					CanDoKS = MyEnemy
					MyState = CHASE_ST
					if MyEnemy > 0 then
						SaveBehavToID_or_Type(MyEnemy, "Aggressive")
					end
					if Friends[v] ~= nil then
						FriendList_Switch(v)
					end
					return
				end
			elseif ((0 == IsMonster(v) and not PvPHere) or IsPlayer(v)) then
				local playerx, playery = GetV(V_POSITION, v)
				if (playerx == x) and (playery == y) then
					local temp_bool = FriendList_Switch(v)
					if temp_bool == 1 then
						return
					end
				end
			elseif (1 == IsMonster(v) or not IsPlayer(v)) then
				local ex, ey = GetV(V_POSITION, v)
				if (ex == x) and (ey == y) then
					if v == MyEnemy then
						ForceDancing = true
					end
					MyEnemy = v
					CanDoKS = MyEnemy
					MyState = CHASE_ST
					if MyEnemy > 0 then
						SaveBehavToID_or_Type(MyEnemy, "Aggressive")
					end
					return
				end
			end
		end
	end
	MyState = MOVE_CMD_ST
	-----------
	MyEnemy = 0
	MySkill = 0
	-----------
	MyDestX = x
	MyDestY = y
	Move(MyID, x, y)
end
---------------------------------------------------------------------------
function ClearVariables()
---------------------------------------------------------------------------
	if 	MyState == CHASE_ST 	then
		TryCount_Chase     = 0
		TryCount_ChaseMove = 0
		CanMove            = true
		Moved              = false
		Timer_ChaseStart   = 0
	-----------------------------------------------
	elseif 	MyState == ATTACK_ST 	then
		FirstDancingMove   = true
		TryCount_Attack    = 0
		Timer_ToAntiBug    = 0
	-----------------------------------------------
	else	--  Limpar tudo:
		--  OnCHASE
		TryCount_Chase     = 0
		TryCount_ChaseMove = 0
		CanMove            = true
		Moved              = false
		Timer_ChaseStart   = 0
		------------------------------------
		--  OnATTACK
		TryCount_Attack    = 0
		Timer_ToAntiBug    = 0	
		------------------------------------
		--  OnFOLLOW
		X_Mark             = 0
		Y_Mark             = 0
		RandomTries        = 0
		TryCount_Follow    = 0
		------------------------------------
		--  Globais
		if MyEnemy == 0 then
			OwnerHit   = 0
		end
	end
end
---------------------------------------------------------------------------
Time_CanTakeDeadDmg = 0
---------------------------
function OnSTOP_CMD()
---------------------------------------------------------------------------
	Log("OnSTOP_CMD.")
	if MyState == CHASE_ST or MyState == ATTACK_ST then
		Time_CanTakeDeadDmg = GetTick() + 1000
	end
	MyState = IDLE_ST
	-----------
	MyDestX, MyDestY = MyX, MyY
	if GetV(V_MOTION, MyID) == MOTION_MOVE then
		Move(MyID, MyDestX, MyDestY)
	end
	-----------
	ClearVariables()
	-----------
	MyEnemy        = 0
	MyEnemy_Strong = 0
	-----------
	MySkill        = 0
	return
end
---------------------------------------------------------------------------
function OnATTACK_OBJECT_CMD(id)
---------------------------------------------------------------------------
	Log("OnATTACK_OBJECT_CMD: atacar ID ("..id..").")
	-----------
	if id == MyEnemy then
		if not ForceDancing then
			ForceDancing = true
		else
			ForceDancing = false
		end
	end
	if id ~= nil then
		if id > 0 then
			SaveBehavToID_or_Type(id, "Aggressive")
		end
	end
	MySkill = 0
	MyEnemy = id
	CanDoKS = MyEnemy
	MyState = CHASE_ST
end
---------------------------------------------------------------------------
function OnATTACK_AREA_CMD(x, y)
---------------------------------------------------------------------------
	Log("OnATTACK_AREA_CMD: atacar rea em volta de ("..x.."; "..y..").")
	-----------
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	CommandTimeOut[MyState] = GetTick() + 5000
	-----------
	MyDestX = x
	MyDestY = y
	-----------
	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION, MyID)) then
		Move(MyID, x, y)	
	end
end
---------------------------------------------------------------------------
PatrolDests_IndexOfUse    = 1
-----------------------------
function OnPATROL_CMD(x, y)
---------------------------------------------------------------------------
	MyPatrolX, MyPatrolY = x, y
	if x ~= MyDestX and y ~= MyDestY then
		MyDestX = x
		MyDestY = y
		Move(MyID, x, y)
	end
	MyState = PATROL_CMD_ST
end
---------------------------------------------------------------------------
function OnHOLD_CMD()
---------------------------------------------------------------------------
	Log("OnHOLD_CMD.")
	-----------
	MyDestX = MyX
	MyDestY = MyY
	MyEnemy = 0
	MyState = HOLD_CMD_ST
end
---------------------------------------------------------------------------
SkillTarget = 0
Done        = 0 --  Para o uso de habilidades que precisam de aproximao.
-----------
ByPass_DelayDetection = 0
-----------------------------
function OnSKILL_OBJECT_CMD(level, skill, id)
---------------------------------------------------------------------------
	if Skills_Homun[skill] ~= nil then
		Log("OnSKILL_OBJECT_CMD: usar habilidade "..Skills_Homun[skill].String.." de nvel "..level.." em "..id..".")
	else
		Log("OnSKILL_OBJECT_CMD: usar habilidade "..skill.." de nvel "..level.." em "..id..".")
	end
	ByPass_DelayDetection = skill
	MySkillLevel = level
	MySkill      = skill
	SkillTarget  = id
	local target_x = -1
	local target_y = -1
	target_x, target_x = GetV(V_POSITION, SkillTarget)
	local need_approach = false
	if target_x >= 0 and (GetDistance(MyX, MyY, target_x, target_y) > GetV(V_SKILLATTACKRANGE, MyID, MySkill)) then
		need_approach = true
		if HomunType ~= nil then
			if Skills_Homun[skill] ~= nil then
				if Skills_Homun[skill].Range ~= nil then
					if GetDistance(MyX, MyY, target_x, target_y) <= Skills_Homun[skill].Range then
						need_approach = false
					end
				end
			end
		elseif MercType ~= nil then
			for i, v in ipairs (SkillSlot) do
				if SkillSlot[i].SkillID == skill and GetDistance(MyX, MyY, target_x, target_y) <= SkillSlot[i].Range then
					need_approach = false
					break
				end
			end
		end
		if need_approach then
			Log("a skill "..skill..", de alcance "..GetV(V_SKILLATTACKRANGE, MyID, MySkill)..", requer aproximao.")
			Done = 0
			SavedMyState = MyState
			MyState = SKILL_OBJECT_CMD_ST
			CommandTimeOut[MyState] = GetTick() + 5000
		end
	end
	if HomunType ~= nil then
		if Skills_Homun[skill] ~= nil then
			if Skills_Homun[skill].SkillID == 8013 or Skills_Homun[skill].SkillID == 8009 then
				if IsMonster(id) or PvPHere then
					SaveSkillToType(level, skill, id)
					if DoSkill(skill, level, id) then
						MySkill = 0
						SkillTarget = 0
					end
				elseif MyEnemy > 0 then
					if DoSkill(skill, level, MyEnemy) then
						MySkill = 0
						SkillTarget = 0
					end
				end
			end
		else
			if DoSkill(skill, level, id) then
				MySkill = 0
				SkillTarget = 0
			end
		end
	elseif MercType ~= nil then
		if DoSkill(skill, level, id) then
			MySkill = 0
			SkillTarget = 0
		end
	else
		if DoSkill(skill, level, id) then
			MySkill = 0
			SkillTarget = 0
		end
	end
end
---------------------------------------------------------------------------
Timer_ToUseSkill      = 0
Timer_Delay           = GetTick() + Time_StartDelay
-----------------------------
MyX_BefSkill, MyY_BefSkill           = -1, -1
PosChangeSkill                       = false
-----------
SPBeforeSkillUse      = 0
MySkill_SPVarDetect   = 0
DoneSkill             = 0
SPVarDetect_Data      = {}
-----------------------------
function DoSkill(skill, level, id, m_skilslot, bypass_delay)
---------------------------------------------------------------------------
	if m_skilslot == nil then
		m_skilslot   = 0
	elseif m_skilslot == true or m_skilslot == false then
		bypass_delay = m_skilslot
		m_skilslot   = 0
	end
	if bypass_delay == nil then
		bypass_delay = false
	end
	if bypass_delay == true and (GetTick() > Timer_Delay) then
		ByPass_DelayDetection = skill
	end
	-----------------------------------
	--  Anti-Erro
	-----------------------------------
	if skill == nil or level == nil or id == nil then
		return DoSkill_Clean(false, false)
	end
	-----------------------------------
	if MySkill_SPVarDetect == 0 then
		SPVarDetect_Data = {}
		SPVarDetect_Data[skill] = {skill, level, id, m_skilslot}
	end
	-----------------------------------
	--  Anti-Lag (Intervalo entre Usos)
	-----------------------------------
	local timeNow = GetTick()
	if Timer_ToUseSkill > 0 and Timer_ToUseSkill > timeNow then
		--Log("GetTick() = "..GetTick()..";")
		--Log("Timer_ToUseSkill = "..Timer_ToUseSkill..";")
		Log("intervalo entre habilidades restante: "..Timer_ToUseSkill - timeNow.." ms.")
	end
	if ByPass_DelayDetection == skill then
		-----------------------------------------------
		--  Comando do usurio.
		-----------------------------------------------
		Timer_ToUseSkill = GetTick() + 500
		-----------
	elseif (MySkill_SPVarDetect ~= 0) then
		-----------------------------------------------
		--  Espere a verificao de se a habilidade anterior foi utilizada.
		-----------------------------------------------
		if GetTick() >= Timer_ToUseSkill - (Timer_ToUseSkill - GetTick()) + 500 and not PosChangeSkill
		and SPVarDetect_Data[MySkill_SPVarDetect] ~= nil then
			skill      = MySkill_SPVarDetect
			level      = SPVarDetect_Data[MySkill_SPVarDetect][2]
			id         = SPVarDetect_Data[MySkill_SPVarDetect][3]
			m_skilslot = SPVarDetect_Data[MySkill_SPVarDetect][4]
			Timer_ToUseSkill = GetTick() + 500
		else
			Log("ainda verificando uso de habilidades.")
			return DoSkill_Clean(false)
		end
	elseif ((DoAgain == true or DonePosChangeSkill == 1) and skill ~= DoAgain_Skill) then
		-----------------------------------------------
		--  Usar somente uma habilidade especfica.
		-----------------------------------------------
		Log("habilidade de troca de posio ou de que precisa de ser usada novamente ainda ativa.")
		return DoSkill_Clean(false)
	elseif (MyEnemy == 0) and (GetV(V_MOTION, OwnerID) == MOTION_STAND) and (GetTick() < Timer_Delay) and (ByPass_DelayDetection ~= skill) then
		-----------------------------------------------
		--  Esperar o delay de proteo inicial acabar.
		-----------------------------------------------
		Log("esperando o delay inicial acabar.")
		return DoSkill_Clean(false)
	elseif GetTick() >= Timer_ToUseSkill then
		-----------------------------------------------
		--  OK.
		-----------------------------------------------
		Timer_ToUseSkill = GetTick() + 500
		-----------
	else
		-----------------------------------------------
		--  Ainda no...
		-----------------------------------------------
		Log("intervalo entre habilidades ainda est ativo.")
		return DoSkill_Clean(false)
	end
	----------------------------------------
	if HomunType ~= nil then
		if Skills_Homun[skill] ~= nil then
			if Skills_Homun[skill].SkillID == 8013 or Skills_Homun[skill].SkillID == 8009 then
				-------------------------------------------------------------------------
				--  No desperdiar SP com alvos no-atacveis com habilidades ofensivas.
				-------------------------------------------------------------------------
				if not IsMonster(id) and not PvPHere then
					-----------------------
					--  No tente de novo..
					-----------------------
					ByPass_DelayDetection = 0
					-----------------------
					return DoSkill_Clean(false, false)
				end
			end
		end
	end
	----------------------------------------
	--  Necessidade de aproximao
	----------------------------------------
	local need_approach = false
	local target_x = -1
	local target_y = -1
	target_x, target_x = GetV(V_POSITION, id)
	if MyState ~= SKILL_OBJECT_CMD_ST then
		if GetDistance2(MyID, id) > SkillAttackRange(MyID, skill, m_skilslot) then
			need_approach = true
			if HomunType ~= nil then
				if Skills_Homun[skill] ~= nil then
					if Skills_Homun[skill].Range ~= nil then
						if GetDistance2(MyID, id) <= Skills_Homun[skill].Range then
							need_approach = false
						end
					end
				end
			elseif MercType ~= nil then
				if SkillSlot[m_skilslot] ~= nil then
					if SkillSlot[m_skilslot].Range ~= nil then
						if GetDistance2(MyID, id) <= SkillSlot[m_skilslot].Range then
							need_approach = false
						end
					end
				else
					for i, v in ipairs (SkillSlot) do
						if SkillSlot[i].SkillID == skill and GetDistance(MyX, MyY, target_x, target_y) <= SkillSlot[i].Range then
							need_approach = false
							break
						end
					end
				end
			end
		end
		if need_approach then
			MySkillLevel = level
			MySkill      = skill
			SkillTarget  = id
			Log("a skill "..skill.." requer aproximao.")
			Done = 0
			SavedMyState = MyState
			MyState = SKILL_OBJECT_CMD_ST
			CommandTimeOut[MyState] = GetTick() + 5000
		end
	end
	----------------------------------------
	if not need_approach then
	if HomunType ~= nil then
		if Skills_Homun[skill] ~= nil then
			if Skills_Homun[skill].Engaged then
				if GetTick() > Skills_Homun[skill].TimeOut then
					Skills_Homun[skill].Engaged = false
				end
				if ByPass_DelayDetection == skill then
					ByPass_DelayDetection = 0
					-----------------------------------
					MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
					SPBeforeSkillUse = GetV(V_SP, MyID)
					MySkill_SPVarDetect = skill
					-----------------------------------
					SkillObject(MyID, level, skill, id)
					-----------------------------------
					Skills_Homun[skill].TimeOut = GetTick() + Skills_Homun[skill].HowLast
					--Skills_Homun[skill].Engaged = true
					-----------------------------------
					if skill == 8005 then 
						OwnerHit       = OwnerHit - 1
						PosChangeSkill = true
					end
					-----------------------------------
					return DoSkill_Clean(true)
				end
			else
				if     Skills_Homun[skill].SkillID == 8008 then
					if 	(level == 1) then
						Skills_Homun[skill].HowLast = 120000
					elseif 	(level == 2) then
						Skills_Homun[skill].HowLast = 360000
					else
						Skills_Homun[skill].HowLast = 600000
					end
				elseif Skills_Homun[skill].SkillID == 8011 then
					Skills_Homun[skill].HowLast = (60 + (level - 1) * 15) * 1000
				elseif Skills_Homun[skill].SkillID == 8010 then
					Skills_Homun[skill].HowLast = (60 + (level - 1) * 15) * 1000
				elseif Skills_Homun[skill].SkillID == 8004 then
					Skills_Homun[skill].HowLast = (120000 * level)
				elseif Skills_Homun[skill].SkillID == 8013 then
					if     (level == 1) then
						Skills_Homun[skill].HowLast = 1000
					elseif (level == 2) then
						Skills_Homun[skill].HowLast = 1200
					elseif (level == 3) then
						Skills_Homun[skill].HowLast = 1400
					elseif (level == 4) then
						Skills_Homun[skill].HowLast = 1600
					else
						Skills_Homun[skill].HowLast = 1800
					end
				end
				ByPass_DelayDetection = 0
				-----------------------------------
				MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
				SPBeforeSkillUse = GetV(V_SP, MyID)
				MySkill_SPVarDetect = skill
				-----------------------------------
				SkillObject(MyID, level, skill, id)
				-----------------------------------
				Skills_Homun[skill].TimeOut = GetTick() + Skills_Homun[skill].HowLast + 1600
				-------------------------------------------------------------------------------------------------------------
				--  Verificar variao de SP depois de um tempo. Salvar a habilidade que foi utilizada e no utilizar outras.
				-------------------------------------------------------------------------------------------------------------
				--Skills_Homun[skill].Engaged = true
				-----------------------------------
				if skill == 8005 then
					OwnerHit       = OwnerHit - 1 
					PosChangeSkill = true
				end
				-----------------------------------
				return DoSkill_Clean(true)
			end
		else
			-----------------------------------
			ByPass_DelayDetection = 0
			-----------------------------------
			MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
			SPBeforeSkillUse = GetV(V_SP, MyID)
			MySkill_SPVarDetect = skill
			-----------------------------------
			SkillObject(MyID, level, skill, id)
			-----------------------------------
			return DoSkill_Clean(true)
		end
	elseif MercType ~= nil then
		if SkillSlot[m_skilslot] ~= nil then
			if SkillSlot[m_skilslot].Engaged then
				if GetTick() > SkillSlot[m_skilslot].TimeOut then
					SkillSlot[m_skilslot].Engaged = false
				end
				if ByPass_DelayDetection == skill then
					-----------------------------------
					ByPass_DelayDetection = 0
					-----------------------------------
					MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
					SPBeforeSkillUse = GetV(V_SP, MyID)
					MySkill_SPVarDetect = m_skilslot
					-----------------------------------
					SkillObject(MyID, level, skill, id)
					-----------------------------------
					SkillSlot[m_skilslot].TimeOut = GetTick() + SkillSlot[m_skilslot].HowLast
					--SkillSlot[m_skilslot].Engaged = true
					return DoSkill_Clean(true)
				end
			else
				ByPass_DelayDetection = 0
				-----------------------------------
				MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
				SPBeforeSkillUse = GetV(V_SP, MyID)
				MySkill_SPVarDetect = m_skilslot
				-----------------------------------
				SkillObject(MyID, level, skill, id)
				-----------------------------------
				SkillSlot[m_skilslot].TimeOut = GetTick() + SkillSlot[m_skilslot].HowLast
				--SkillSlot[m_skilslot].Engaged = true
				return DoSkill_Clean(true)
			end
		else
			ByPass_DelayDetection = 0
			-----------------------------------
			MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
			SPBeforeSkillUse = GetV(V_SP, MyID)
			MySkill_SPVarDetect = skill
			-----------------------------------
			SkillObject(MyID, level, skill, id)
			-----------------------------------
			return DoSkill_Clean(true)
		end
	else
		ByPass_DelayDetection = 0
		-----------------------------------
		MyX_BefSkill, MyY_BefSkill = GetV(V_POSITION, MyID)
		SPBeforeSkillUse = GetV(V_SP, MyID)
		MySkill_SPVarDetect = skill
		-----------------------------------
		SkillObject(MyID, level, skill, id)
		-----------------------------------
		return DoSkill_Clean(true)
	end
	ByPass_DelayDetection = 0
	end
	return DoSkill_Clean(false, false)
end

function SkillAttackRange(myid, skill, m_skilslot)
	if myid ~= nil and skill ~= nil and m_skilslot ~= nil then
		if HomunType ~= nil then
			if Skills_Homun[skill] ~= nil then
				if Skills_Homun[skill].Range ~= nil then
					return Skills_Homun[skill].Range
				end
			end
		end
		return GetV(V_SKILLATTACKRANGE, myid, skill)
	else
		return 1
	end
end

---------------------------------------------------------------------------
DelaySum = 0
---------------
function DoSkill_Clean(result, noMoreDelay)
---------------------------------------------------------------------------
	if result == nil then
		result = false
	end
	if noMoreDelay == nil then
		noMoreDelay = true
	end
	if result == true then
		-----------------------------------
		--  Limpeza
		-----------------------------------
		if DoAgain then
			DoAgain   = false
		end
		DelaySum = 0
		-----------------------------------
		Timer_ToMove = 0 --  Usar movimento de novo, porque usar habilidades faz o homnculo / assistente parar.
	end
	if result == false then
		if not noMoreDelay then
			DelaySum = DelaySum + 1
			if DelaySum >= 3 or Timer_ToUseSkill - GetTick() >= 2000 then
				DelaySum = 0
				Timer_ToUseSkill = 0
			end
			Timer_ToUseSkill = Timer_ToUseSkill + DelaySum * 500
		end
	end
	return result
end
---------------------------------------------------------------------------
MySkillDestX, MySkillDestY = MyDestX, MyDestY
-----------------------------
function OnSKILL_AREA_CMD(level, skill, x, y)
---------------------------------------------------------------------------
	TraceAI ("OnSKILL_AREA_CMD: usar skill "..skill.." em ("..x.."; "..y..").")
	-----------
	SavedMyState = MyState
	MyState = SKILL_AREA_CMD_ST
	CommandTimeOut[MyState] = GetTick() + 5000
	-----------
	MySkillLevel = level
	MySkill = skill
	-----------
	MySkillDestX = x
	MySkillDestY = y
	MyDestX = MySkillDestX
	MyDestY = MySkillDestY
	-----------
	Move(MyID, MyDestX, MyDestY)
end
---------------------------------------------------------------------------
function OnFOLLOW_CMD()
---------------------------------------------------------------------------
	ForceDancing = false
	if DefaultBeha == Beha_Defend then
		DefaultBeha = Beha_Attack
		Log("comportamento de AGRESSIVO ativado.")
		local file_beha
		if     HomunType ~= nil then
			if not FileExists(File_Beha_H) then
				file_beha = io.open(File_Beha_H, "w")
				if file_beha then
					file_beha:write("true\n")
					file_beha:close()
				else
					file_beha = io.open(File_Beha_H, "a+")
					if file_beha then
						file_beha:write("true\n")
						file_beha:close()
					else
						Log("erro ao criar arquivo para salvar comportamento.")
					end
				end
			end
		elseif MercType ~= nil then
			if not FileExists(File_Beha_M) then
				file_beha = io.open(File_Beha_M, "w")
				if file_beha then
					file_beha:write("true\n")
					file_beha:close()
				else
					file_beha = io.open(File_Beha_M, "a+")
					if file_beha then
						file_beha:write("true\n")
						file_beha:close()
					else
						Log("erro ao criar arquivo para salvar comportamento.")
					end
				end
			end
		end
	else
		DefaultBeha = Beha_Defend
		if     HomunType ~= nil then
			if FileExists(File_Beha_H) then
				os.remove(File_Beha_H)
			end
		elseif MercType ~= nil then
			if FileExists(File_Beha_M) then
				os.remove(File_Beha_M)
			end
		end
		Log("comportamento de DEFENSIVO ativado.")
	end
	if (MyState ~= FOLLOW_CMD_ST) then
		Log("Aguardar.")
		ClearPatrolDests()
		Log("desativar patrulha.")
		MyState = FOLLOW_CMD_ST
		MyEnemy = 0
		MySkill = 0
		local x, y = OwnerX, OwnerY
		if GetDistance(x, y, MyDestX, MyDestY) > 3 then
			MyDestX, MyDestY = BestMovementToOwner()
			Move(MyID, MyDestX, MyDestY)
			return;
		end
	else
		Log("no Aguardar.")
		Log("limpar as habilidades salvas por tipo de inimigo.")
		if not LongRangeShooter then
			LongRangeShooter = true
			Log("ativar ataque  distncia.")
		end
		MyState = IDLE_ST
		MyEnemy = 0
		MySkill = 0
	end
end
---------------------------------------------------------------------------
function ProcessCommand(msg)
---------------------------------------------------------------------------
	if     (msg[1] == MOVE_CMD) then
		OnMOVE_CMD(msg[2], msg[3])
	elseif (msg[1] == STOP_CMD) then
		OnSTOP_CMD()
	elseif (msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD(msg[2])
	elseif (msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD(msg[2], msg[3])
	elseif (msg[1] == PATROL_CMD) then
		OnPATROL_CMD(msg[2], msg[3])
	elseif (msg[1] == HOLD_CMD) then
		OnHOLD_CMD()
	elseif (msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD(msg[2], msg[3], msg[4], msg[5])
	elseif (msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD(msg[2], msg[3], msg[4], msg[5])
	elseif (msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD()
	end
end
-- ==========================
--  Processamento de Estados
-- ==========================
---------------------------------------------------------------------------
PvPHere                 = false
Interval_PvPDetect      = 0
-----------------------------
Timer_CleanUnreachable  = 0
-----------------------------
DelayAfterFollow        = 0
-----------------------------
function OnIDLE_ST()
---------------------------------------------------------------------------
	-----------------------------------------
	--  Timer para reverificar inalcanveis
	-----------------------------------------
	if Timer_CleanUnreachable == 0 then
		Timer_CleanUnreachable = GetTick() + 30000
	end
	-----------------------------------------
	--  Salvar e carregar 'Types'.
	-----------------------------------------
	if HomunType ~= nil then
		SaveTypes(false)
	else
		LoadTypes(false)
	end
	-----------------------------------------
	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand(cmd)
		return 
	end
	-----------------------------
	--  Usar skills de recuperao
	-----------------------------
	if HomunType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
		for i, v in pairs (Skills_Homun) do
			if Skills_Homun[i].Engaged then
				if GetTick() > Skills_Homun[i].TimeOut then
					Skills_Homun[i].Engaged = false
				end
			end
		end
		----------------------
		--  Emergencial Skills
		----------------------
		if EmergencyVerify == 1 then
			for i, v in ipairs(Screen_Actors) do
				if SkillsTurn == 6 then
				if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
				and IsMonster(v) == 1 then
					DoSkill(8026, 5, v)
					break
				elseif Friends[v] ~= nil and GetV(V_MOTION, v) == MOTION_SIT and math.random(0, 100) <= 15 then
					DoSkill(8026, 5, v)
					break
				end
				end
				if SkillsTurn == 5 then
				if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
				and IsMonster(v) == 1 then
					DoSkill(8019, 5, v)
					break
				end
				end
			end
		end
		if SkillsTurn == 1 then
		if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < Configuration[Eu].CB.Idle.MyMinHP
		or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < Configuration[Eu].CB.Idle.MastMinH then
			if not Skills_Homun[8013].Engaged and not Skills_Homun[8014].Engaged then
				if math.random(1, 100) <= Configuration[Eu].CB.Idle.PChance then
					--Log("Sorteio de Habilidade: usar AS_VAN_BLES.")
					local bles_level = 5
					if math.random(1, 100) > 50 then
						if math.random(1, 100) <= 40 then
							bles_level = 4
						elseif math.random(1, 100) <= 30 then
							bles_level = 3
						elseif math.random(1, 100) <= 20 then
							bles_level = 2
						elseif math.random(1, 100) <= 10 then
							bles_level = 1
						end
					end
					DoSkill(8014, bles_level, MyID)
				end
			end
		end
		end
		if SkillsTurn == 6 then
			if SkillsNotEngaged("Eira") then
				if (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95 
				and math.random(1, 100) <= 50 then
					--Log("Sorteio de Habilidade: usar MH_EIR_SILENT_BREEZE.")
					DoSkill(8026, 5, OwnerID)
				elseif (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 95 
				and math.random(1, 100) <= 50 then
					--Log("Sorteio de Habilidade: usar MH_EIR_SILENT_BREEZE.")
					DoSkill(8026, 5, MyID)
				end
			end
		end
		if SkillsTurn == 9 then
			if SkillsNotEngaged("Dieter") then
				if math.random(1, 100) <= 50 then
					--Log("Sorteio de Habilidade: usar MH_DIE_MAGMA_FLOW.")
					DoSkill(8039, 5, MyID)
				end
			end
		end
	elseif MercType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
		for i, v in pairs (SkillSlot) do
			if SkillSlot[i].Engaged then
				if GetTick() > SkillSlot[i].TimeOut then
					SkillSlot[i].Engaged = false
				end
			end
		end
		for i, v in pairs (SkillSlot) do
			---------------
			--  Defensiva
			---------------
			if SkillSlot[i].Type == 4 then
				if not SkillSlot[i].Engaged then
					if math.random(1, 100) <= 50 then
						if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyID, i) then
							break
						end
						
					end
				end
			end
			---------------
			--  Buff
			---------------
			if SkillSlot[i].Type == 5 then
				if not SkillSlot[i].Engaged then
					if (SkillSlot[i].SkillID == 8224) then
						if GetV(V_SP, MyID) >= math.floor((SkillsMinSP / 100) * GetV(V_MAXSP, MyID)) + SkillSlot[i].MinSP and math.random(1, 100) <= 10 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyID, i) then
								break
							end
						end
					elseif (math.random(1, 100) <= 50) then
						if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyID, i) then
							break
						end
						
					end
				end
			end
		end
	end
	-----------------------------
	if UseIdleMovement then
		OnPATROL_CMD(PatrolDests[PatrolDests_IndexOfUse][1], PatrolDests[PatrolDests_IndexOfUse][2])
		return
	end
	local object = GetEnemyOf(OwnerID)
	if (object > 0) then
		MyState = CHASE_ST
		MyEnemy = object
		if HomunType ~= nil then
			Log("perseguir o inimigo do mestre, "..MyEnemy..", do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
		else
			Log("perseguir o inimigo do mestre, "..MyEnemy..".")
		end
		return 
	end
	for i, v in pairs (Friends) do
		if GetEnemyOf(v) > 0 then
			object = GetEnemyOf(v)
			break
		end
	end
	if (object > 0) then
		MyState = CHASE_ST
		MyEnemy = object
		if HomunType ~= nil then
			Log("perseguir o inimigo do aliado, "..MyEnemy..", do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
		else
			Log("perseguir o inimigo do aliado, "..MyEnemy..".")
		end
		return 
	end
	object = GetMyEnemy(MyID)
	if (object > 0) then
		MyState = CHASE_ST
		MyEnemy = object
		if HomunType ~= nil then
			Log("perseguir meu inimigo "..MyEnemy..", do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
		else
			Log("perseguir meu inimigo "..MyEnemy..".")
		end
		return
	end
	if not LongRangeShooter then		
		if ShouldFollow() then --  Se  hora de seguir...
			Log("mestre distante: seguir.")
			MyDestX, MyDestY = BestMovementToOwner()
			Move(MyID, MyDestX, MyDestY)
			MyState = FOLLOW_ST
			return
		end
		if GetTick() > Timer_Delay and (GetV(V_MOTION, MyID) == MOTION_HIT or HPLostOrGain < 0) and MyEnemy <= 0 then
			Log("perdi "..HPLostOrGain.." de HP ou levei dano sem ter inimigos: mover para prximo ao Dono. Pode estar fora da tela.")
			if GetDistanceFromOwner(MyID) >= 3 then
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY)
			else
				MoveToOwner(MyID)
			end
			MyState = FOLLOW_ST
			return;
		end
	else
		local distance = GetDistanceFromOwner(MyID)
		if (distance > 1) then
			local x, y = OwnerX, OwnerY
			if GetDistance(x, y, MyDestX, MyDestY) > 1 or 
			(GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) or OwnerPosChanged then
				MyDestX, MyDestY = OwnerX, OwnerY
				Move(MyID, MyDestX, MyDestY)
			end
			return;
		end
	end
end
---------------------------------------------------------------------------
LastOwner_X_FD, LastOwner_Y_FD       = -1, -1
------------
--  Para verificar a direo de movimentao:
LastOwner_X, LastOwner_Y             = -1, -1
X_Mark = 0
Y_Mark = 0
RandomTries = 0
TryCount_Follow = 1
-----------------------------
function OnFOLLOW_ST()
---------------------------------------------------------------------------
	Log("...")
	---------------------------------------
	--  Usar skills para movimentao.
	---------------------------------------
	if HomunType ~= nil then
		if SkillsTurn == 3 then
		if not Skills_Homun[8001].Engaged and not Skills_Homun[8002].Engaged then
			if GetV(V_MOTION, OwnerID) == MOTION_MOVE or GetV(V_MOTION, OwnerID) == MOTION_HIT then
				if math.random(1, 100) <= 30 and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 > 95 then
					--Log("Sorteio de Habilidade: usar AS_LIF_ESCP.")
					if DoSkill(8002, 5, MyID) then
						if (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) then
							Timer_ToMove = 0
							MyDestX, MyDestY = BestMovementToOwner()
							Move(MyID, MyDestX, MyDestY, true)
							Move(MyID, MyDestX, MyDestY, true)
						end
					end
				end
			end
		end
		end
	end
	------------------------------------
	--  Atacar inimigo enquanto seguir.
	------------------------------------
	local enemy = EnemyOnFollow(MyDestX, MyDestY)
	if enemy > 0 then
		if IsInAttackSight(MyID, enemy) and (GetDistance2(MyID, OwnerID) < MaxDistance - 6 or GetV(V_MOTION, OwnerID) ~= MOTION_MOVE) then
			if (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) then
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY, true)
				Move(MyID, MyDestX, MyDestY, true)
			end
			Log("...atacar "..enemy.." enquanto segue.")
			AttackAnyNearMe()
			if (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) then
				Timer_ToMove = 0
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY, true)
				Move(MyID, MyDestX, MyDestY, true)
			end
		end
	elseif MyEnemy > 0 then
		if IsInAttackSight(MyID, MyEnemy) and (GetDistance2(MyID, OwnerID) < MaxDistance - 6 or GetV(V_MOTION, OwnerID) ~= MOTION_MOVE) then
			if (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) then
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY, true)
				Move(MyID, MyDestX, MyDestY, true)
			end
			Log("...atacar "..MyEnemy.." enquanto segue.")
			AttackAnyNearMe()
			if (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) then
				Timer_ToMove = 0
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY, true)
				Move(MyID, MyDestX, MyDestY, true)
			end
		end
	end
	------------------------------------
	local x, y            = OwnerX, OwnerY
	local moveNow         = false
	------------------------------------
	--  Movimentao do Usurio.
	------------------------------------
	if     GetDistance(x, y, LastOwner_X_FD, LastOwner_Y_FD) >= 3 then
		Timer_ToMove = 0
		moveNow = true
		LastOwner_X_FD, LastOwner_Y_FD = x, y
	end
	------------------------------------
	if (x ~= LastOwner_X or y ~= LastOwner_Y) or FirstFollow then
		if GetDistance(x, y, LastOwner_X, LastOwner_Y) >= 3 or FirstFollow then
			moveNow = true
		end
		--Log("...")
		--Log("--------------------------------------------------------------")
		--Log("o usurio se moveu...")
		if x == -1 or LastOwner_X == -1 then
			X_Mark = 0
		elseif x < LastOwner_X then
			if X_Mark ~= -1 then
				X_Mark = -1
				if ((MyX <= OwnerX or GetDistance2(MyID, OwnerID) <= 6) and MyDestX >= OwnerX) or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8  then
					--Timer_ToMove = 0
					moveNow = true
				end
			end
		elseif x > LastOwner_X then
			if X_Mark ~= 1 then
				X_Mark = 1
				if ((MyX >= OwnerX or GetDistance2(MyID, OwnerID) <= 6) and MyDestX <= OwnerX) or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8 then
					--Timer_ToMove = 0
					moveNow = true
				end
			end
		else
			if Y_Mark ~= 0 then
				if X_Mark ~= 0 then
					X_Mark = 0
					if GetDistance2(MyID, OwnerID) > 6 or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8 then
						--Timer_ToMove = 0
						moveNow = true
					end
				end
			end
		end
		--Log("movimentao do usurio pelo eixo X: "..X_Mark..".")
		if y == -1 or LastOwner_Y == -1 then
			Y_Mark = 0
		elseif y < LastOwner_Y then
			if Y_Mark ~= -1 then
				Y_Mark = -1
				if ((MyY <= OwnerY or GetDistance2(MyID, OwnerID) <= 6) and MyDestY >= OwnerY) or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8 then
					--Timer_ToMove = 0
					moveNow = true
				end
			end
		elseif y > LastOwner_Y then
			if Y_Mark ~= 1 then
				Y_Mark = 1
				if ((MyY >= OwnerY or GetDistance2(MyID, OwnerID) <= 6) and MyDestY <= OwnerY) or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8 then
					--Timer_ToMove = 0
					moveNow = true
				end
			end
		else
			if X_Mark ~= 0 then
				if Y_Mark ~= 0 then
					Y_Mark = 0
					if GetDistance2(MyID, OwnerID) > 6 or GetDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= 8 then
						--Timer_ToMove = 0
						moveNow = true
					end
				end
			end
		end
		--Log("movimentao do usurio pelo eixo Y: "..Y_Mark..".")
		--Log("--------------------------------------------------------------")
		LastOwner_X, LastOwner_Y = OwnerX, OwnerY
	end

	if     (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) and (moveNow or GetDistance2(MyID, OwnerID) > MaxDistance - 4) then
		if UseIdleMovement then
			UseIdleMovement = false
			ClearPatrolDests()
		end
		MyDestX, MyDestY = BestMovementToOwner()
		Move(MyID, MyDestX, MyDestY)
		RandomTries = 0
		return;
	
	elseif (GetV(V_MOTION, OwnerID) ~= MOTION_MOVE and not OwnerPosChanged) 
	and not ShouldFollow() then
		---------------------------------------
		--  Manter o inimigo depois de seguir.
		---------------------------------------
		if enemy > 0 then
			MyEnemy = enemy
			ClearVariables()
			if not LongRangeShooter and GetDistance2(OwnerID, MyEnemy) <= MaxDistance - 4
			and (GetTick() >= DelayAfterFollow_ToChase) then
				MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
				Move(MyID, MyDestX, MyDestY)
			end
			MyState = CHASE_ST
		elseif MyEnemy > 0 then
			ClearVariables()
			if not LongRangeShooter and GetDistance2(OwnerID, MyEnemy) <= MaxDistance - 4
			and (GetTick() >= DelayAfterFollow_ToChase) then
				MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
				Move(MyID, MyDestX, MyDestY)
			end
			MyState = CHASE_ST
		else
			MyState = IDLE_ST
			-----------
			ClearVariables()
			-----------
			MyEnemy        = 0
			MyEnemy_Strong = 0
			-----------
			MySkill = 0
		end
		Log("mestre alcanado: parar de seguir.")
		return;
	elseif (GetV(V_MOTION, MyID) ~= MOTION_MOVE and GetV(V_MOTION, OwnerID) ~= MOTION_MOVE and not OwnerPosChanged) then
		if TryCount_Follow <= 15 then
			MyDestX, MyDestY = BestMovementToOwner()
			Move(MyID, MyDestX, MyDestY)
			TryCount_Follow = TryCount_Follow + 1
		else
			-----------------------------------------
			--  Atacar inimigo se no pode se mover.
			-----------------------------------------
			if enemy > 0 and not IsOutOfSight(MyID, enemy) then
				Log("... falha ao seguir (1).")
				MyEnemy = enemy
				ClearVariables()
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY)
				MyState = CHASE_ST
				return
			elseif MyEnemy > 0 and not IsOutOfSight(MyID, MyEnemy) then
				Log("... falha ao seguir (2).")
				ClearVariables()
				MyDestX, MyDestY = BestMovementToOwner()
				Move(MyID, MyDestX, MyDestY)
				MyState = CHASE_ST
				return
			else
				if RandomTries <= math.random(10, 20) then
					Log("... falha ao seguir (3).")
					MyDestX, MyDestY = BestMovementToOwner()
					Move(MyID, MyDestX, MyDestY)
					RandomTries = RandomTries + 1
					return
				end
				for i, v in ipairs (Screen_Actors) do
					if HPLostOrGain < 0 or (GetV(V_MOTION, v) ~= MOTION_STAND and GetV(V_MOTION, v) ~= MOTION_DEAD and GetV(V_MOTION, v) ~= MOTION_SIT and GetV(V_MOTION, v) ~= MOTION_TK_LEAP_LAND) then
						local x2, y2 = GetV(V_POSITION, OwnerID)
						if (MyX == MyDestX and MyY == MyDestY) then
							MyDestX, MyDestY = BestMovementToOwner()
							Move(MyID, MyDestX, MyDestY)
							return
						elseif     GetV(V_MOTION, MyID) ~= MOTION_MOVE then
							local x2 = (OwnerX + math.random(-(MaxDistance - 1), (MaxDistance - 1)))
							local y2 = (OwnerY + math.random(-(MaxDistance - 1), (MaxDistance - 1)))
							if x2 ~= MyDestX or y2 ~= MyDestY then
								MyDestX, MyDestY = x2, y2
								Move(MyID, MyDestX, MyDestY)
								return
							end
						end
						return
					end
				end
			end
		end
	end
end
---------------------------------------------------------------------------
TryCount_Chase = 0
TryCount_ChaseMove = 0
----------
CanMove        = true
Moved          = false
Timer_ChaseStart         = 0
DelayAfterFollow_ToChase = 0
-----------------------------
function OnCHASE_ST()
---------------------------------------------------------------------------
	if Timer_ChaseStart == 0 then
		Timer_ChaseStart = GetTick() + 5000
	end
	local x, y = 0, 0
	if TryCount_Chase > math.random(43, 53) or (LongRangeShooter and TryCount_Chase > math.random(23, 33)) then
		Log("cancelar perseguio (1).")
		------------------
		Unreachable[MyEnemy] = 1
		------------------
		OnSTOP_CMD()
		return
	elseif IsOutOfSight(MyID, MyEnemy) then
		Log("cancelar perseguio (2).")
		OnSTOP_CMD()
		return
	elseif GetV(V_MOTION, MyEnemy) == MOTION_DEAD then
		Log("cancelar perseguio (3).")
		OnSTOP_CMD()
		return
	elseif IsKS(MyEnemy) then
		Log("cancelar perseguio (4).")
		OnSTOP_CMD()
		return
	-----------------------------
	--  Prevenir de sair da tela
	-----------------------------
	elseif ShouldFollow() then
		Log("cancelar perseguio (5).")
		MyState = FOLLOW_ST
		return
	end
	-----------------------------
	if IsNotEnemyAnymore(MyEnemy) then --  Colocar o IsNotEnemyAnymore(myEnemy): 29/06/2011.
		Log("cancelar perseguio (7).")
		Unreachable[MyEnemy] = 1
		OnSTOP_CMD()
		return
	end
	--------------------------------------------------------------------------------
	if not LongRangeShooter then
		if IsInAttackSight(MyID, MyEnemy) then
			Log("ID "..MyEnemy.." dentro do alcance de ataque: usar golpes.")
			ClearVariables()
			Attack(MyID, MyEnemy)
			MyState = ATTACK_ST
			return
		end
	end
	--------------------------------------------------------------------------------
	if GetV(V_MOTION, MyID) == MOTION_MOVE and not Moved then --  Data: 22/06/2011.
		Moved = true
	elseif GetV(V_MOTION, MyID) ~= MOTION_MOVE and Moved then
		-------------------------------------------
		--  Anti Bug Position
		-------------------------------------------
		AttackAnyNearMe()
		-------------------------------------------
	end
	--------------------------------------------------------------------------------
	-----------------------------
	--  Tirar obsesso por alvo
	-----------------------------
	if CanDoKS ~= MyEnemy then
		local object = 0
		if (GetV(V_TARGET, MyEnemy) ~= OwnerID and Friends[GetV(V_TARGET, MyEnemy)] == nil) 
		or IsMonster(MyEnemy) == 0 then
			object = GetEnemyOf(OwnerID)
			if not ShouldChangeToTargetOf(OwnerID, object) then
				object = 0
			end
			if object <= 0 then
				if Friends[GetV(V_TARGET, MyEnemy)] == nil then
					local temp_id = 0
					for i, v in pairs (Friends) do
						if GetEnemyOf(v) > 0 then
							object  = GetEnemyOf(v)
							temp_id = v
							break
						end
					end
					if not ShouldChangeToTargetOf(temp_id, object) then
						object = 0
					end
					if object <= 0 then
						if GetV(V_TARGET, MyEnemy) ~= MyID then
							object = GetMyEnemyA(MyID)
							if object <= 0 then
								object = GetMyEnemy(MyID)
								if object > 0 and object ~= MyEnemy then
									local dis_object = GetDistance2(MyID, object)
									local dis_enemy  = GetDistance2(MyID, MyEnemy)
									if (dis_enemy <= dis_object or GetV(V_MOTION, object) == MOTION_MOVE) and IsMonster(MyEnemy) ~= 0 then
										object = 0
									end
								end
							end
						end
					end
				end
			end
		end
		if object > 0 and object ~= MyEnemy then
			MyEnemy = object
			if HomunType ~= nil then
				Log("trocar para o inimigo "..MyEnemy.." do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
			else
				Log("trocar para o inimigo "..MyEnemy..".")
			end
			ClearVariables()
			return
		end
	end
	-----------------------------
	if (MySkill == 0) then
		-----------------------------
		--  Usar skills ofensivas
		-----------------------------
		if HomunType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
			for i, v in pairs (Skills_Homun) do
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
					end
				end
			end
			----------------------
			--  Emergencial Skills
			----------------------
			if EmergencyVerify == 1 then
				for i, v in ipairs(Screen_Actors) do
					if SkillsTurn == 6 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 15 then
							if DoSkill(8026, 5, v) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
								or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
							end
							break
						end
					elseif Friends[v] ~= nil and GetV(V_MOTION, v) == MOTION_SIT and math.random(0, 100) <= 15 then
						if math.random(1, 100) <= 95 then
							if DoSkill(8026, 5, v) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
								or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
							end
							break
						end
					end
					end
					if SkillsTurn == 5 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 95 then
							if DoSkill(8019, 5, v) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
								or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
							end
							break
						end
					end
					end
					if SkillsTurn == 8 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 95 then
							if DoSkill(8033, 5, OwnerID) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
								or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
							end
							break
						end
					end
					end
				end
			end
			if SkillsTurn == 4 then
			if not Skills_Homun[8005].Engaged and not Skills_Homun[8006].Engaged then
				if ((CountEnemiesCloseTo(MyID) == 0 or GetDistance2(MyID, OwnerID) <= 3 or CountEnemiesCloseTo(OwnerID) > CountEnemiesCloseTo(MyID)) 
				and (GetV(V_MOTION, OwnerID) == MOTION_HIT or OwnerHit > 0)
				and CanDoKS ~= MyEnemy and Configuration[Eu].CT.Chase.Active) or (DoAgain and DoAgain_Skill == 8005) then
					--Log("Sorteio de Habilidade: usar AS_AMI_CAST.")
					if DoSkill(8005, 5, OwnerID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				end
			end
			end
			if SkillsTurn == 3 then
			if not Skills_Homun[8002].Engaged then
				if math.random(1, 100) <= 30 and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 > 90 
				and CountEnemiesCloseTo(MyID) == 0 then
					--Log("Sorteio de Habilidade: usar AS_LIF_ESCP.")
					if DoSkill(8002, 5, MyID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				elseif (GetV(V_HP, MyID) <= 100 or MVP_KS_OK[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil) and math.random(1, 100) <= 90 then
					--Log("recebendo dano alto: usar AS_LIF_CHNG.")
					if DoSkill(8004, 3, MyID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				end
			end
			end
			if SkillsTurn == 2 then
			if not Skills_Homun[8009].Engaged and not Skills_Homun[8010].Engaged and not Skills_Homun[8011].Engaged then
				if (((math.random(1, 100) <= 90 and ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP + 20 or LongRangeShooter)) or math.random(1, 100) <= 30) or (GetV(V_MOTION, MyEnemy) == MOTION_MOVE)) and IsValidSkillTarget(MyEnemy, 8009) then
					Log("Sorteio de Habilidade: usar AS_FIL_MOON.")
					local moon_level = 5
					if SkillToType[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil then
						moon_level = SkillToType[GetV(V_HOMUNTYPE, MyEnemy)].Level
					elseif math.random(1, 100) > 50 then
						moon_level = math.random(1, 5)
					end
					if DoSkill(8009, moon_level, MyEnemy) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				elseif (math.random(1, 100) <= 10 or (not IsValidSkillTarget(MyEnemy, 8009) and math.random(1, 100) <= 30)
				or ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 <= SkillsMinSP + 20 and math.random(1, 100) <= 80))
				and not LongRangeShooter then
					--Log("Sorteio de Habilidade: usar AS_FIL_FLTT.")
					if DoSkill(8010, 5, MyID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				elseif (math.random(1, 100) <= 10 or ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 <= SkillsMinSP + 20 and math.random(1, 100) <= 80)) 
				and not LongRangeShooter and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < AggroHP then
					--Log("Sorteio de Habilidade: usar AS_FIL_ACCL.")
					if DoSkill(8011, 5, MyID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				end
			end
			end
			if SkillsTurn == 1 then
			if not Skills_Homun[8013].Engaged and not Skills_Homun[8014].Engaged then
				if (not (((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 70 or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95)) or math.random(1, 100) <= 25 or (LongRangeShooter and math.random(1, 100) <= 95))
				and (math.random(1, 100) <= 95 or (GetV(V_MOTION, MyEnemy) == MOTION_MOVE)) and IsValidSkillTarget(MyEnemy) then
					--Log("Sorteio de Habilidade: usar AS_VAN_CAPR.")
					local capr_level = 5
					if SkillToType[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil then
						capr_level = SkillToType[GetV(V_HOMUNTYPE, MyEnemy)].Level
					elseif math.random(1, 100) > 50 then
						if math.random(1, 100) <= 40 then
							capr_level = 4
						elseif math.random(1, 100) <= 30 then
							capr_level = 3
						elseif math.random(1, 100) <= 20 then
							capr_level = 2
						elseif math.random(1, 100) <= 10 then
							capr_level = 1
						end
					end
					if DoSkill(8013, capr_level, MyEnemy) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				elseif math.random(1, 100) <= Configuration[Eu].CB.Chase.PChance
				and ((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < Configuration[Eu].CB.Chase.MyMinHP
				or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < Configuration[Eu].CB.Chase.MastMinH) then
					--Log("Sorteio de Habilidade: usar AS_VAN_BLES.")
					local bles_level = 5
					if math.random(1, 100) <= 90 then
						if (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95 then
							bles_level = 3
						elseif (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 95 then
							bles_level = 4
						elseif math.random(1, 100) <= 40 then
							bles_level = 4
						elseif math.random(1, 100) <= 30 then
							bles_level = 3
						elseif math.random(1, 100) <= 20 then
							bles_level = 2
						elseif math.random(1, 100) <= 10 then
							bles_level = 1
						end
					end
					if DoSkill(8014, bles_level, MyID) then
						if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
						or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
						or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
							if not LongRangeShooter then
								if CanMove then
									MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
									Move(MyID, MyDestX, MyDestY)
								end
							end
						end
					end
				end
			end
			end
			if SkillsTurn == 5 then
				if SkillsNotEngaged("Sera") then
					if math.random(1, 100) <= 65 then
						--Log("Sorteio de Habilidade: usar MH_SER_POISON_MIST.")
						local x_area, y_area = GetV(V_POSITION, MyEnemy)
						OnSKILL_AREA_CMD(5, 8020, x_area, y_area)
					end
				end
			end
			if SkillsTurn == 6 then
				if SkillsNotEngaged("Eira") then
					if math.random(1, 100) <= 95 then
						if     (CountEnemiesCloseTo(OwnerID) >= 2) and math.random(1, 100) <= 50 then
							--Log("Sorteio de Habilidade: usar MH_EIR_XENO_SLASHER.")
							local x_area, y_area = GetV(V_POSITION, MyID)
							OnSKILL_AREA_CMD(5, 8025, x_area, y_area)
						elseif (CountEnemiesCloseTo(MyID) >= 2) and math.random(1, 100) <= 50 then
							--Log("Sorteio de Habilidade: usar MH_EIR_XENO_SLASHER.")
							local x_area, y_area = GetV(V_POSITION, OwnerID)
							OnSKILL_AREA_CMD(5, 8025, x_area, y_area)
						else
							if DoSkill(8024, math.random(4, 5), MyEnemy) then
								--Log("Sorteio de Habilidade: usar MH_EIR_ERASE_CUTTER.")
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
								or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
							end
						end
					end
				end
			end
			if SkillsTurn == 8 then
				if SkillsNotEngaged("Bayeri") then
					if math.random(1, 100) <= 95 then
						if DoSkill(8031, 5, MyEnemy) then
							Log("Sorteio de Habilidade: usar MH_BAY_STAHL_HORN.")
							if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
							or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)
							or  (GetV(V_MOTION, MyID) ~= MOTION_STAND)) then
								if not LongRangeShooter then
									if CanMove then
										MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
										Move(MyID, MyDestX, MyDestY)
									end
								end
							end
						end
					end
				end
			end
			if SkillsTurn == 9 then
				if SkillsNotEngaged("Dieter") then
					if math.random(1, 100) <= 65 then
						--Log("Sorteio de Habilidade: usar MH_DIE_VOLCANIC_ASH.")
						local x_area, y_area = GetV(V_POSITION, MyEnemy)
						OnSKILL_AREA_CMD(5, 8043, x_area, y_area)
					end
				end
			end
		elseif MercType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
			for i, v in ipairs (SkillSlot) do
				if SkillSlot[i].Engaged then
					if GetTick() > SkillSlot[i].TimeOut then
						SkillSlot[i].Engaged = false
						-- Log("Delay de "..i.." acabou.")
					end
				end
			end
			for i, v in ipairs (SkillSlot) do
				---------------
				--  Ofensiva
				---------------
				if SkillSlot[i].Type == 2 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND) 
								or   GetV(V_MOTION, MyID) ~= MOTION_STAND)
								and not IsInAttackSight(MyID, MyEnemy) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
								break
							end
						end
					end
				end
				------------------------
				--  Ataque  distncia
				------------------------
				--  Ofensiva (curto alcance)
				---------------
				if LongRangeShooter and IsInAttackSight(MyID, MyEnemy) and SkillSlot[i].Type == 1 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								break
							end
						end
					end
				end
				---------------
				--  Ofensiva (de rea)
				---------------
				if LongRangeShooter and IsInAttackSight(MyID, MyEnemy) and SkillSlot[i].Type == 3 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								break
							end
						end
					end
				end
				---------------
				--  Ofensiva (de rea com alvo no cho)
				---------------
				if SkillSlot[i].Type == 10 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							local x_area, y_area = GetV(V_POSITION, MyEnemy)
							OnSKILL_AREA_CMD(SkillSlot[i].Level, SkillSlot[i].SkillID, x_area, y_area)
							break
						end
					end
				end
				---------------
				--  Debuff
				---------------
				if SkillSlot[i].Type == 6 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 10 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND) 
								or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND) 
								or   GetV(V_MOTION, MyID) ~= MOTION_STAND)
								and not IsInAttackSight(MyID, MyEnemy) then
									if not LongRangeShooter then
										if CanMove then
											MyDestX, MyDestY = GetV(V_POSITION, MyEnemy)
											Move(MyID, MyDestX, MyDestY)
										end
									end
								end
								break
							end
						end
					end
				end
			end
		end
		-----------------------------
	end
	if not LongRangeShooter then
		if IsInAttackSight(MyID, MyEnemy) then
			ClearVariables()
			MyState = ATTACK_ST
			x, y = GetV(V_POSITION, MyEnemy)
			local random_x = x + math.random(- AttackRange, AttackRange)
			local random_y = y + math.random(- AttackRange, AttackRange)
			--if GetV(V_MOTION, MyID) ~= MOTION_MOVE then
				AttackAnyNearMe()
			--end
			if (MyDestX ~= random_x or MyDestY ~= random_y) 
			or (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND)
			or GetV(V_MOTION, MyID) ~= MOTION_STAND 
			or GetV(V_MOTION, MyEnemy) ~= MOTION_STAND
			then
				MyDestX, MyDestY = random_x, random_y
				Move(MyID, MyDestX, MyDestY)
			end
			Log("parar perseguio... ID "..MyEnemy.." dentro do alcance de ataque.")
			return
		end
		--------------------------------------------------------------------------------
		if CanMove then
			x, y           = GetV(V_POSITION, MyEnemy)
			local x_best, y_best = BestMovementTo(MyEnemy)
			if ((MyDestX ~= x or MyDestY ~= y or GetV(V_MOTION, MyID) == MOTION_MOVE) and (LstDestX ~= x_best or LstDestY ~= y_best)) 
			then
				Log("perseguir em ("..x.."; "..y..").")
				MyDestX, MyDestY = GetV(V_POSITION, MyEnemy);
				Move(MyID, MyDestX, MyDestY)
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					Timer_ToMove = 0
				end
			elseif (((MyDestX ~= x_best or MyDestY ~= y_best) and (LstDestX == x and LstDestY == y) 
			and GetV(V_MOTION, MyID)    == MOTION_STAND
			and GetV(V_MOTION, MyEnemy) ~= MOTION_MOVE) or TryCount_ChaseMove <= 1)
			and GetTick() > Timer_ToMove
			then
				TryCount_ChaseMove = TryCount_ChaseMove + 1
				Log("...perseguio falhou (1). Tentando proximidades.")
				MyDestX, MyDestY = x_best, y_best;
				Move(MyID, MyDestX, MyDestY)
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					Timer_ToMove = 0
				end
			elseif GetV(V_MOTION, MyID) == MOTION_STAND 
			and (MyX ~= MyDestX or MyY ~= MyDestY)
			and GetTick() > Timer_ToMove
			then
				Log("...perseguio falhou (2). Tentando proximidades.")
				CanMove = false
				Time_ToGetAct = Time_ToGetAct + 1000
			end
		else
			if GetV(V_TARGET, MyEnemy) ~= OwnerID and GetV(V_TARGET, MyEnemy) ~= MyID and Friends[GetV(V_TARGET, MyEnemy)] == nil
			and CanDoKS ~= MyEnemy then
				Log("cancelar perseguio (8).")
				if MOTION_MOVE ~= GetV(V_MOTION, MyID) then
					Unreachable[MyEnemy] = 1
				end
				OnSTOP_CMD()
				return
			else
				if ((GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_MOVE and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND)
				or  (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_MOVE)
				or  (GetV(V_MOTION, GetV(V_TARGET, MyEnemy)) ~= MOTION_STAND
				and GetV(V_MOTION, GetV(V_TARGET, MyEnemy)) ~= MOTION_DEAD
				and GetV(V_MOTION, GetV(V_TARGET, MyEnemy)) ~= MOTION_MOVE
				and GetV(V_TARGET, MyEnemy) >= 0))
				and GetTick() > Timer_ToMove
				then
					if MyX == MyDestX and MyY == MyDestY then
						Log("...sucesso! Tentando posio do inimigo.")
						CanMove = true
						return
					end
					if Friends[GetV(V_TARGET, MyEnemy)] == nil then
						x, y = GetV(V_POSITION, MyEnemy)
						if   GetV(V_MOTION, MyID) ~= MOTION_MOVE and (MyDestX == x and MyDestY == y)
						and GetTick() > Timer_ToMove then
							local x2 = (OwnerX + math.random(-(MaxDistance - 1), (MaxDistance - 1)))
							local y2 = (OwnerY + math.random(-(MaxDistance - 1), (MaxDistance - 1)))
							if x2 ~= MyDestX or y2 ~= MyDestY then
								MyDestX, MyDestY = x2, y2
								Move(MyID, MyDestX, MyDestY)
								Time_ToGetAct = Time_ToGetAct + 1000
							end
						elseif GetV(V_MOTION, MyID) ~= MOTION_MOVE and (MyDestX ~= x or MyDestY ~= y)
						and GetTick() > Timer_ToMove then
							MyDestX, MyDestY = GetV(V_POSITION, MyEnemy);
							Move(MyID, MyDestX, MyDestY)
							Time_ToGetAct = Time_ToGetAct + 1000
						end
					else
						x, y = BestMovementTo(MyEnemy)
						if GetV(V_MOTION, MyID) ~= MOTION_MOVE and (MyDestX ~= x or MyDestY ~= y)
						and GetTick() > Timer_ToMove then
							MyDestX, MyDestY = BestMovementTo(MyEnemy);
							Move(MyID, MyDestX, MyDestY)
							Time_ToGetAct = Time_ToGetAct + 1000
						end
					end
				end
			end
		end
		TryCount_Chase = TryCount_Chase + 1
	else
		if GetV(V_MOTION, MyID) ~= MOTION_MOVE then
			if MySkill == 0 then
				-------------------------------------------
				--  Anti Bug Position
				-------------------------------------------
				AttackAnyNearMe()
				-------------------------------------------
			else
				DoSkill(MySkill, MySkillLevel, MyEnemy)
				MySkill = 0
				SkillTarget = 0
				AttackAnyNearMe()
			end
		end
		if GetV(V_TARGET, MyID) == 0 and GetV(V_TARGET, MyEnemy) == 0 and TryCount_Chase > 4 then
			Log("cancelar perseguio (9).")
			Unreachable_IsNPC[MyEnemy] = 1
			OnSTOP_CMD()
			return
		end
		if (GetV(V_MOTION, MyEnemy) ~= MOTION_HIT or EnemyNotChangingMotion) and GetDistance2(MyID, MyEnemy) > AttackRange then
			TryCount_Chase = TryCount_Chase + 1
		else
			TryCount_Chase = 0
		end
		local distance = GetDistanceFromOwner(MyID)
		if ((distance > 1) and (GetV(V_TARGET, MyEnemy) ~= MyID) or GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) then
			x, y = OwnerX, OwnerY
			MyDestX, MyDestY = OwnerX, OwnerY
			Move(MyID, MyDestX, MyDestY)
			return;
		end
	end
	-----------------------------------------------------
	--  Sistema de andar para longe com Mob.
	-----------------------------------------------------
	if not LongRangeShooter then
	if Step ~= 0 then
		if GetV(V_MOTION, MyID) ~= MOTION_STAND then 
			StdMove(MyID, MyDestX, MyDestY)
		else
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 0 and GetTick() > LastSnipeMove

	and ((GetV(V_MOTION, MyID) == MOTION_HIT 
	and math.random(1, 100) <= 15)

	or ((GetV(V_MOTION, MyID) == MOTION_HIT or GetV(V_MOTION, MyEnemy) ~= MOTION_STAND) and CountEnemiesCloseTo(MyID) > 1 
	and math.random(1, 100) <= 75)) then
		
		if GetTick() > Timer_ToMove then
			--  Mover-se para uma posio aleatria.
			Step = 1
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 1 and ((MyDestX == MyX and MyDestY == MyY) or (GetV(V_MOTION, MyID) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)) then
		if GetTick() > Timer_ToMove then
			Step = 2
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 2 and ((MyDestX == MyX and MyDestY == MyY) or (GetV(V_MOTION, MyID) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)) then
		if GetTick() > Timer_ToMove then
			Step = 0
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)

			LastSnipeMove = GetTick() + (math.random(20, 25) * 1000)
		end
	end
	else
	if Step ~= 0 then
		Step = 0 
	end
	end
end
---------------------------------------------------------------------------
TryCount_Attack = 0
Timer_ToAntiBug = 0
LastSnipeMove   = 0
Step            = 0
-----------------------------
function OnATTACK_ST()
---------------------------------------------------------------------------
	if Timer_ToAntiBug == 0 then
		Timer_ToAntiBug = GetTick() + 5000
	end
	local x, y = -1, -1
	if GetTick() > Timer_ToAntiBug and not LongRangeShooter then
		Log("sistema contra bug: mover para mais perto do inimigo.")
		Timer_ToAntiBug = 0
		x, y = GetV(V_POSITION, MyEnemy)
		local random_x = x + math.random(- AttackRange, AttackRange)
		local random_y = y + math.random(- AttackRange, AttackRange)
		if GetV(V_MOTION, MyID) ~= MOTION_MOVE then
			AttackAnyNearMe()
		end
		if (MyDestX ~= random_x or MyDestY ~= random_y) 
		or (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND)
		or GetV(V_MOTION, MyID) ~= MOTION_STAND 
		or GetV(V_MOTION, MyEnemy) ~= MOTION_STAND
		then
			MyDestX, MyDestY = random_x, random_y
			Move(MyID, MyDestX, MyDestY)
		end
		return
	elseif TryCount_Attack > math.random(33, 43) then
		if ((GetV(V_TARGET, MyEnemy) ~= MyID and GetV(V_TARGET, MyEnemy) ~= OwnerID and Friends[GetV(V_TARGET, MyEnemy)] == nil) or EnemyNotChangingMotion)
		and CanDoKS ~= MyEnemy then
			Log("cancelar ataque (1).")
			Unreachable[MyEnemy] = 1
			OnSTOP_CMD()
			return
		else
			x, y = RemoveBugMovement()
			if GetV(V_MOTION, MyID) ~= MOTION_MOVE then
				AttackAnyNearMe()
			end
			if (MyDestX ~= x or MyDestY ~= y) 
			or (GetV(V_MOTION, OwnerID) ~= MOTION_STAND and GetV(V_MOTION, OwnerID) ~= MOTION_TK_LEAP_LAND)
			or GetV(V_MOTION, MyID) ~= MOTION_STAND 
			or GetV(V_MOTION, MyEnemy) ~= MOTION_STAND
			then
				MyDestX, MyDestY = x, y
				Move(MyID, x, y)
			end
			ClearVariables()
			return
		end
	elseif IsOutOfSight(MyID, MyEnemy) then
		Log("cancelar ataque (2).")
		OnSTOP_CMD()
		return
	elseif GetV(V_MOTION, MyEnemy) == MOTION_DEAD then
		Log("cancelar ataque (3).")
		OnSTOP_CMD()
		return
	elseif IsKS(MyEnemy) then
		Log("cancelar ataque (4).")
		OnSTOP_CMD()
		return
	-----------------------------
	--  Prevenir de sair da tela
	-----------------------------
	elseif ShouldFollow() then
		Log("cancelar ataque (5).")
		MyState = FOLLOW_ST
		return
	end
	----------------------------------------
	if IsNotEnemyAnymore(MyEnemy) then --  Colocar o IsNotEnemyAnymore(myEnemy): 29/06/2011.
		Log("cancelar ataque (6).")
		Unreachable[MyEnemy] = 1
		OnSTOP_CMD()
		return
	end
	-----------------------------
	--  Tirar obsesso por alvo
	-----------------------------
	if CanDoKS ~= MyEnemy and GetV(V_MOTION, MyID) ~= MOTION_MOVE then
		local object = 0
		if (GetV(V_TARGET, MyEnemy) ~= OwnerID and Friends[GetV(V_TARGET, MyEnemy)] == nil) 
		or IsMonster(MyEnemy) == 0 then
			object = GetEnemyOf(OwnerID)
			if not ShouldChangeToTargetOf(OwnerID, object) then
				object = 0
			end
			if object <= 0 then
				if Friends[GetV(V_TARGET, MyEnemy)] == nil then
					local temp_id = 0
					for i, v in pairs (Friends) do
						if GetEnemyOf(v) > 0 then
							object  = GetEnemyOf(v)
							temp_id = v
							break
						end
					end
					if not ShouldChangeToTargetOf(temp_id, object) then
						object = 0
					end
					if object <= 0 then
						if GetV(V_TARGET, MyEnemy) ~= MyID then
							object = GetMyEnemyA(MyID)
							if object <= 0 then
								object = GetMyEnemy(MyID)
								if object > 0 and object ~= MyEnemy then
									local dis_object = GetDistance2(MyID, object)
									local dis_enemy  = GetDistance2(MyID, MyEnemy)
									if dis_enemy <= dis_object and IsMonster(MyEnemy) ~= 0 then
										object = 0
									end
								end
							end
						end
					end
				end
			end
		end
		if object > 0 and object ~= MyEnemy then
			MyEnemy = object
			if HomunType ~= nil then
				Log("trocar para o inimigo "..MyEnemy.." do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
			else
				Log("trocar para o inimigo "..MyEnemy..".")
			end
			ClearVariables()
			return
		elseif MyEnemy_Strong > 0 and MyEnemy_Strong ~= MyEnemy then
			MyEnemy = MyEnemy_Strong
			if HomunType ~= nil then
				Log("trocar para o inimigo "..MyEnemy.." do tipo "..GetV(V_HOMUNTYPE, MyEnemy).." (verifique este valor num database).")
			else
				Log("trocar para o inimigo "..MyEnemy..".")
			end
			ClearVariables()
			return
		end
	end
	-----------------------------
	if (not IsInAttackSight(MyID, MyEnemy) or GetV(V_MOTION, MyEnemy) == MOTION_MOVE) and (Step == 0 or (MyX == MyDestX and MyY == MyDestY)) then
		ClearVariables()
		MyState = CHASE_ST
		MyDestX, MyDestY = GetV(V_POSITION, MyEnemy);
		Move(MyID, MyDestX, MyDestY)
		Log("o inimigo est a uma distncia maior que "..AttackRange..": perseguir.")
		return
	end
	-----------------------------
	if (MySkill == 0) then
		-----------------------------
		--  Usar skills ofensivas
		-----------------------------
		if HomunType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
			for i, v in pairs (Skills_Homun) do --  [No funciona por qu?]
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
					end
				end
			end
			for i, v in pairs(Skills_Homun) do
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
					end
				end
			end
			----------------------
			--  Emergencial Skills
			----------------------
			if EmergencyVerify == 1 then
				for i, v in ipairs(Screen_Actors) do
					if SkillsTurn == 6 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 15 then
							DoSkill(8026, 5, v)
							break
						end
					elseif Friends[v] ~= nil and GetV(V_MOTION, v) == MOTION_SIT and math.random(0, 100) <= 15 then
						if math.random(1, 100) <= 95 then
							DoSkill(8026, 5, v)
							break
						end
					end
					end
					if SkillsTurn == 5 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 95 then
							DoSkill(8019, 5, v)
							break
						end
					end
					end
					if SkillsTurn == 8 then
					if (GetV(V_TARGET, v) == OwnerID and (not IsPlayer(v) or (IsPlayer(v) and (GetV(V_MOTION, v) == MOTION_CAST or Had_MOTION_SKILL[v] ~= nil or Had_MOTION_PICKUP[v] ~= nil or math.random(1, 100) <= 25 or HasOfensiveMotion(MyEnemy, MyID))))) 
					and IsMonster(v) == 1 then
						if math.random(1, 100) <= 95 then
							DoSkill(8033, 5, OwnerID)
							break
						end
					end
					end
				end
			end
			----------------------
			if SkillsTurn == 3 then
			if not Skills_Homun[8001].Engaged and not Skills_Homun[8002].Engaged and not Skills_Homun[8004].Engaged then
				if (GetV(V_HP, MyID) <= 100 or (HPLostOrGain < -math.floor((32 / 100) * GetV(V_MAXHP, MyID)) and HPLostOrGain < 0) or MVP_KS_OK[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil) and math.random(1, 100) <= 90 then
					--Log("recebendo dano alto: usar AS_LIF_CHNG.")
					DoSkill(8004, 3, MyID)
				end
			end
			end
			if SkillsTurn == 4 then
			if not Skills_Homun[8005].Engaged and not Skills_Homun[8006].Engaged and not Skills_Homun[8008].Engaged then
				if ((CountEnemiesCloseTo(MyID) == 0 or GetDistance2(MyID, OwnerID) <= 3 or CountEnemiesCloseTo(OwnerID) > CountEnemiesCloseTo(MyID)) 
				and (GetV(V_MOTION, OwnerID) == MOTION_HIT or OwnerHit > 0)
				and CanDoKS ~= MyEnemy and Configuration[Eu].CT.Attack.Active) or (DoAgain and DoAgain_Skill == 8005) then
					--Log("Sorteio de Habilidade: usar AS_AMI_CAST.")
					DoSkill(8005, 5, OwnerID)
				elseif (MVP_KS_OK[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil 

				and math.random(1, 100) <= Configuration[Eu].BL.Attack.PChance_MVP)

				or (PvPHere 

				and math.random(1, 100) <= Configuration[Eu].BL.Attack.PChance_PVP)

				or ((HPLostOrGain < -math.floor((8 / 100) * GetV(V_MAXHP, MyID))  and HPLostOrGain < 0) 

				and math.random(1, 100) <= Configuration[Eu].BL.Attack.PChance_LHP)
				
				or math.random(1, 100) <= Configuration[Eu].BL.Attack.PChance_RND then

					--Log("Sorteio de Habilidade: usar AS_AMI_BLOO.")
					DoSkill(8008, 3, MyID)

				elseif math.random(1, 100) <= Configuration[Eu].BW.Attack.PChance 

				and ((CountEnemiesCloseTo(OwnerID) == 0) or (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 <= 50) then
					--Log("Sorteio de Habilidade: usar AS_AMI_BULW.")
					DoSkill(8006, 5, MyID)
				end
			end
			end
			if SkillsTurn == 2 then
			if not Skills_Homun[8009].Engaged and not Skills_Homun[8010].Engaged and not Skills_Homun[8011].Engaged then
				if (((math.random(1, 100) <= 90 and ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP + 20 or LongRangeShooter)) or math.random(1, 100) <= 30) or (GetV(V_MOTION, MyEnemy) == MOTION_MOVE)) and IsValidSkillTarget(MyEnemy, 8009) then
					Log("Sorteio de Habilidade: usar AS_FIL_MOON. (2)")
					local moon_level = 5
					if SkillToType[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil then
						moon_level = SkillToType[GetV(V_HOMUNTYPE, MyEnemy)].Level
					elseif math.random(1, 100) > 50 then
						moon_level = math.random(1, 5)
					end
					DoSkill(8009, moon_level, MyEnemy)
				elseif (math.random(1, 100) <= 10 or (not IsValidSkillTarget(MyEnemy, 8009) and math.random(1, 100) <= 30)
				or ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 <= SkillsMinSP + 20 and math.random(1, 100) <= 80))
				and not LongRangeShooter then
					--Log("Sorteio de Habilidade: usar AS_FIL_FLTT.")
					DoSkill(8010, 5, MyID)
				elseif (math.random(1, 100) <= 10 or ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 <= SkillsMinSP + 20 and math.random(1, 100) <= 80)) 
				and not LongRangeShooter and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < AggroHP then
					--Log("Sorteio de Habilidade: usar AS_FIL_ACCL.")
					DoSkill(8011, 5, MyID)
				end
			end
			end
			if SkillsTurn == 1 then
			if not Skills_Homun[8013].Engaged and not Skills_Homun[8014].Engaged then
				if (not (((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 70 or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95)) or math.random(1, 100) <= 25)
				and (math.random(1, 100) <= 95 or (GetV(V_MOTION, MyEnemy) == MOTION_MOVE)) and IsValidSkillTarget(MyEnemy) then
					--Log("Sorteio de Habilidade: usar AS_VAN_CAPR.")
					local capr_level = 5
					if SkillToType[GetV(V_HOMUNTYPE, MyEnemy)] ~= nil then
						capr_level = SkillToType[GetV(V_HOMUNTYPE, MyEnemy)].Level
					elseif math.random(1, 100) > 50 then
						if math.random(1, 100) <= 40 then
							capr_level = 4
						elseif math.random(1, 100) <= 30 then
							capr_level = 3
						elseif math.random(1, 100) <= 20 then
							capr_level = 2
						elseif math.random(1, 100) <= 10 then
							capr_level = 1
						end
					end
					DoSkill(8013, capr_level, MyEnemy)
				elseif math.random(1, 100) <= Configuration[Eu].CB.Attack.PChance 
				and ((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < Configuration[Eu].CB.Attack.MyMinHP
				or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < Configuration[Eu].CB.Attack.MastMinH) then
					--Log("Sorteio de Habilidade: usar AS_VAN_BLES.")
					local bles_level = 5
					if math.random(1, 100) <= 90 then
						if (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95 then
							bles_level = 3
						elseif (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 95 then
							bles_level = 4
						elseif math.random(1, 100) <= 40 then
							bles_level = 4
						elseif math.random(1, 100) <= 30 then
							bles_level = 3
						elseif math.random(1, 100) <= 20 then
							bles_level = 2
						elseif math.random(1, 100) <= 10 then
							bles_level = 1
						end
					end
					DoSkill(8014, bles_level, MyID)
				end
			end
			end
			if SkillsTurn == 5 then
				if SkillsNotEngaged("Sera") then
					if math.random(1, 100) <= 65 then
						--Log("Sorteio de Habilidade: usar MH_SER_POISON_MIST.")
						local x_area, y_area = GetV(V_POSITION, MyEnemy)
						OnSKILL_AREA_CMD(5, 8020, x_area, y_area)
					end
				end
			end
			if SkillsTurn == 6 then
				if SkillsNotEngaged("Eira") then
					if GetV(V_MOTION, OwnerID) == MOTION_ATTACK
					and math.random(1, 100) <= 15 then
						--Log("Sorteio de Habilidade: usar MH_EIR_OVERED_BOOST.")
						DoSkill(8023, 5, OwnerID)
					elseif (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 95 
					and math.random(1, 100) <= 50 then
						--Log("Sorteio de Habilidade: usar MH_EIR_SILENT_BREEZE.")
						DoSkill(8026, 5, OwnerID)
					elseif (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 95 
					and math.random(1, 100) <= 50 then
						--Log("Sorteio de Habilidade: usar MH_EIR_SILENT_BREEZE.")
						DoSkill(8026, 5, MyID)
					elseif math.random(1, 100) <= 95 then
						if     (CountEnemiesCloseTo(OwnerID) >= 2) and math.random(1, 100) <= 50 then
							--Log("Sorteio de Habilidade: usar MH_EIR_XENO_SLASHER.")
							local x_area, y_area = GetV(V_POSITION, MyID)
							OnSKILL_AREA_CMD(5, 8025, x_area, y_area)
						elseif (CountEnemiesCloseTo(MyID) >= 2) and math.random(1, 100) <= 50 then
							--Log("Sorteio de Habilidade: usar MH_EIR_XENO_SLASHER.")
							local x_area, y_area = GetV(V_POSITION, OwnerID)
							OnSKILL_AREA_CMD(5, 8025, x_area, y_area)
						else
							Log("Sorteio de Habilidade: usar MH_EIR_ERASE_CUTTER.")
							DoSkill(8024, math.random(4, 5), MyEnemy)
						end
					end
				end
			end
			if SkillsTurn == 7 then
				if SkillsNotEngaged("Eleanor") then
					if math.random(1, 100) <= 95 then
						--Log("Sorteio de Habilidade: usar MH_ELE_SONIC_CLAW.")
						DoSkill(8028, 5, MyEnemy)
					end
				end
				if math.random(1, 100) <= 50 then
					StayOnSameSkillTurnForComboOrSkill = SkillsTurn
				end
			end
			if SkillsTurn == 8 then
				if SkillsNotEngaged("Bayeri") then
					if math.random(1, 100) <= 95 then
						Log("Sorteio de Habilidade: usar MH_BAY_STAHL_HORN.")
						DoSkill(8031, 5, MyEnemy)
					end
				end
			end
			if SkillsTurn == 9 then
				if SkillsNotEngaged("Dieter") then
					if     math.random(1, 100) <= 65 then
						--Log("Sorteio de Habilidade: usar MH_DIE_VOLCANIC_ASH.")
						local x_area, y_area = GetV(V_POSITION, MyEnemy)
						OnSKILL_AREA_CMD(5, 8043, x_area, y_area)
					elseif math.random(1, 100) <= 65 then
						--Log("Sorteio de Habilidade: usar MH_DIE_LAVA_SLIDE.")
						local x_area, y_area = GetV(V_POSITION, MyEnemy)
						OnSKILL_AREA_CMD(5, 8041, x_area, y_area)
					end
				end
			end
			-----------------------------
			AttackAnyNearMe()
		elseif MercType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
			for i, v in ipairs (SkillSlot) do
				if SkillSlot[i].Engaged then
					if GetTick() > SkillSlot[i].TimeOut then
						SkillSlot[i].Engaged = false
					end
				end
			end
			for i, v in ipairs (SkillSlot) do
				---------------
				--  Ofensiva (curto alcance)
				---------------
				if SkillSlot[i].Type == 1 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								break
							end
						end
					end
				end
				---------------
				--  Ofensiva
				---------------
				if SkillSlot[i].Type == 2 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								break
							end
						end
					end
				end
				---------------
				--  Ofensiva (de rea)
				---------------
				if SkillSlot[i].Type == 3 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							local befSkillX, befSkillY = GetV(V_POSITION, MyEnemy)
							local aftSkillX, aftSkillY
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								aftSkillX, aftSkillY = GetV(V_POSITION, MyEnemy)
								if GetV(V_MOTION, MyEnemy) ~= MOTION_STAND or GetV(V_MOTION, MyID) ~= MOTION_STAND or (befSkillX ~= aftSkillX or befSkillY ~= aftSkillY) then
									local bestX, bestY = GetV(V_POSITION, MyEnemy)
									if MyX < aftSkillX then
										bestX = bestX + math.random(0, AttackRange)
									elseif MyX > aftSkillX then
										bestX = bestX - math.random(0, AttackRange)
									else
										bestX = bestX + math.random(- AttackRange, AttackRange)
									end
									if MyY < aftSkillY then
										bestY = bestY + math.random(0, AttackRange)
									elseif MyY > aftSkillY then
										bestY = bestY - math.random(0, AttackRange)
									else
										bestY = bestY + math.random(- AttackRange, AttackRange)
									end
									Move(MyID, bestX, bestY)
								end
								break
							end
						end
					end
				end
				---------------
				--  Ofensiva (de rea com alvo no cho)
				---------------
				if SkillSlot[i].Type == 10 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 95 then
							local x_area, y_area = GetV(V_POSITION, MyEnemy)
							OnSKILL_AREA_CMD(SkillSlot[i].Level, SkillSlot[i].SkillID, x_area, y_area)
							break
						end
					end
				end
				---------------
				--  Debuff
				---------------
				if SkillSlot[i].Type == 6 then
					if not SkillSlot[i].Engaged then
						if math.random(1, 100) <= 10 then
							if DoSkill(SkillSlot[i].SkillID, SkillSlot[i].Level, MyEnemy, i) then
								break
							end
						end
					end
				end
			end
			-----------------------------
			AttackAnyNearMe()
		else
			-----------------------------
			AttackAnyNearMe()
		end
	else
		DoSkill(MySkill, MySkillLevel, SkillTarget)
		MySkill     = 0
		SkillTarget = 0
		AttackAnyNearMe()
	end
	if GetV(V_TARGET, MyID) == 0 and GetV(V_TARGET, MyEnemy) == 0 and TryCount_Attack > 4 then
		Log("cancelar ataque (7).")
		Unreachable_IsNPC[MyEnemy] = 1
		OnSTOP_CMD()
		return
	end
	if EnemyNotChangingMotion then
		-- Log("inimigo no levou dano.")
		-------------------------------------------
		--  Anti Bug Position
		-------------------------------------------
		AttackAnyNearMe()
		-------------------------------------------
		TryCount_Attack = TryCount_Attack + 1
		-- Log(TryCount_Attack.." tentativas de ataque falhas.")
	elseif NoOtherIsAttacking(MyEnemy, MyID) then
		TryCount_Attack = 0
	end
	-----------------------------------------------------
	--  Sistema de andar para longe com Mob.
	-----------------------------------------------------
	if not LongRangeShooter then
	if Step ~= 0 then
		if GetV(V_MOTION, MyID) ~= MOTION_STAND then 
			StdMove(MyID, MyDestX, MyDestY)
		else
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 0 and GetTick() > LastSnipeMove

	and ((GetV(V_MOTION, MyID) == MOTION_HIT 
	and math.random(1, 100) <= 15)

	or ((GetV(V_MOTION, MyID) == MOTION_HIT or (GetV(V_MOTION, MyEnemy) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_DEAD)) and CountEnemiesCloseTo(MyID) > 1 
	and math.random(1, 100) <= 75)) then
		
		if GetTick() > Timer_ToMove then
			--  Mover-se para uma posio aleatria.
			Log("Anti-Mob: mover-se para uma posio aleatria. (1)")
			Step = 1
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 1 and ((MyDestX == MyX and MyDestY == MyY) or (GetV(V_MOTION, MyID) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)) then
		if GetTick() > Timer_ToMove then
			Log("Anti-Mob: mover-se para uma posio aleatria. (2)")
			Step = 2
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)
		end
	end
	if Step == 2 and ((MyDestX == MyX and MyDestY == MyY) or (GetV(V_MOTION, MyID) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_STAND)) then
		if GetTick() > Timer_ToMove then
			Log("Anti-Mob: mover-se para uma posio aleatria. (3)")
			Step = 0
			MyDestX = OwnerX + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			MyDestY = OwnerY + math.random(-(MaxDistance - 3), (MaxDistance - 3))
			Move(MyID, MyDestX, MyDestY)

			LastSnipeMove = GetTick() + (math.random(20, 25) * 1000)
		end
	end
	else
	if Step ~= 0 then
		Step = 0 
	end
	end
	return
end
---------------------------------------------------------------------------
function OnMOVE_CMD_ST()
---------------------------------------------------------------------------
	if GetTick() >= MoveTimeOut then
		Log("no  possvel chegar ao destino ("..MyDestX.."; "..MyDestY.."): parar.")
		OnSTOP_CMD()
		return
	end
	if IsPatrol then
		if GetV(V_MOTION, MyID) == MOTION_MOVE then
			Log("patrulhar: destino "..PatrolDests_Index.." ("..MyDestX.."; "..MyDestY..") salvo.")
			PatrolDests[PatrolDests_Index] = {MyDestX, MyDestY}
			PatrolDests_Index = PatrolDests_Index + 1
		end
	end
	local x, y = MyX, MyY
	if (x == MyDestX and y == MyDestY) then
		OnSTOP_CMD()
	else
		Move(MyID, MyDestX, MyDestY)
	end
end
---------------------------------------------------------------------------
function OnSTOP_CMD_ST()
---------------------------------------------------------------------------
--  No utilizado.
end
---------------------------------------------------------------------------
function OnATTACK_OBJECT_CMD_ST ()
---------------------------------------------------------------------------
--  No utilizado.
end
---------------------------------------------------------------------------
function OnATTACK_AREA_CMD_ST()
---------------------------------------------------------------------------	
	local x, y = GetV (V_POSITION, MyID)
	if (x == MyDestX and y == MyDestY) then
		local object = GetEnemyOf(OwnerID)
		
		if (object <= 0) then							
			object = GetMyEnemy(MyID) 
		end
		
		if (object > 0) then
			MyState = CHASE_ST
			MyEnemy = object
			return
		end
		
		OnSTOP_CMD()
	else
		if GetTick() >= CommandTimeOut[ATTACK_AREA_CMD_ST] then
			OnSTOP_CMD()
		elseif (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION, MyID)) then
			Move(MyID, MyDestX, MyDestY)	
		end
	end
end
---------------------------------------------------------------------------
function OnPATROL_CMD_ST()
---------------------------------------------------------------------------
	local distance = GetDistanceFromOwner(MyID)
	if (distance > 8) and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) and NearerOrFarther == 1 then
		MyState = FOLLOW_ST
		Log("parar patrulha: o dono est indo para longe.")
		return
	end
	local object = GetEnemyOf(OwnerID)
	if (object <= 0) then							
		object = GetMyEnemy(MyID) 
		if (object <= 0) then	
			for i, v in pairs (Friends) do
				if GetEnemyOf(v) > 0 then
					object = GetEnemyOf(v)
					break
				end
			end
		end
	end
	if (object > 0) then
		MyState = CHASE_ST
		MyEnemy = object
		Log("ao patrulhar, o inimigo: "..MyEnemy.." foi encontrado: perseguir.")
		return
	end
	--------------------------------------------
	if GetV(V_MOTION, MyID) ~= MOTION_MOVE then
	--------------------------------------------
		--------------------------------
		--  Usar skills de recuperao
		--------------------------------
		if HomunType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > 95 then
			for i, v in pairs (Skills_Homun) do
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
						-- Log("Delay de "..i.." acabou.")
					end
				end
			end
			for i, v in pairs(Skills_Homun) do
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
					end
				end
			end
			if SkillsTurn == 1 then
			if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 100 or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 100 then
				if not Skills_Homun[8013].Engaged and not Skills_Homun[8014].Engaged then
					if math.random(1, 100) <= Configuration[Eu].CB.Patrol.PChance
					and ((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < Configuration[Eu].CB.Patrol.MyMinHP 
					or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < Configuration[Eu].CB.Patrol.MastMinH) then
						--Log("Sorteio de Habilidade: usar AS_VAN_BLES.")
						local bles_level = 5
						if math.random(1, 100) > 50 then
							if math.random(1, 100) <= 40 then
								bles_level = 4
							elseif math.random(1, 100) <= 30 then
								bles_level = 3
							elseif math.random(1, 100) <= 20 then
								bles_level = 2
							elseif math.random(1, 100) <= 10 then
								bles_level = 1
							end
						end
						DoSkill(8014, bles_level, MyID)
					end
				end
			end
			end
		end
		-----------------------------
		if ((GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 == 100 
		and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 == 100) 
		or GetV(V_MOTION, MyID) == MOTION_HIT
		then
			MyPatrolX, MyPatrolY = PatrolDests[PatrolDests_IndexOfUse][1], PatrolDests[PatrolDests_IndexOfUse][2]
			PatrolDests_IndexOfUse = PatrolDests_IndexOfUse + 1
			if PatrolDests[PatrolDests_IndexOfUse] == nil then
				PatrolDests_IndexOfUse = 1
			end
			MyDestX = MyPatrolX
			MyDestY = MyPatrolY
			Move(MyID, MyDestX, MyDestY)
			Timer_ToMove = 0
		else
			local distance = GetDistanceFromOwner(MyID)
			if (distance > 1) then
				local x, y = OwnerX, OwnerY
				MyDestX, MyDestY = OwnerX, OwnerY
				Move(MyID, MyDestX, MyDestY)
				return;
			end
		end
	end
end
---------------------------------------------------------------------------
function OnHOLD_CMD_ST()
---------------------------------------------------------------------------	
	if (MyEnemy > 0) then
		local d = GetDistance(MyEnemy, MyID)
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE, MyID)) then
			Attack(MyID, MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end
	local object = GetEnemyOf(OwnerID)
	if (object <= 0) then
		object = GetMyEnemy(MyID)
		if (object <= 0) then
			MyState = IDLE_ST
			return
		end
	end
	MyEnemy = object
end
---------------------------------------------------------------------------
function OnSKILL_OBJECT_CMD_ST()
---------------------------------------------------------------------------

	local x, y = GetV(V_POSITION, SkillTarget)
	if GetDistance2(MyID, SkillTarget) <= GetV(V_SKILLATTACKRANGE, MyID, MySkill) then
		Log("alvo "..SkillTarget.." dentro do alcance "..GetV(V_SKILLATTACKRANGE, MyID, MySkill).." ladrilhos. J posso usar a habilidade "..MySkill..".")
		if DoSkill(MySkill, MySkillLevel, SkillTarget) then
			MySkill = 0
			SkillTarget = 0
		end
		MyState = SavedMyState
	else
		DoSkill(MySkill, MySkillLevel, SkillTarget)
	end
	if MyEnemy > 0 then
		if IsInAttackSight(MyID, MyEnemy) then
			Attack(MyID, MyEnemy)
		end
	end
	if GetTick() >= CommandTimeOut[SKILL_OBJECT_CMD_ST] then
		DoSkill(MySkill, MySkillLevel, SkillTarget)
		OnSTOP_CMD()	
	elseif (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION, MyID)) then
		MyDestX = x
		MyDestY = y
		Move(MyID, MyDestX, MyDestY)
	end
end
---------------------------------------------------------------------------
function OnSKILL_AREA_CMD_ST()
---------------------------------------------------------------------------
	local x, y = GetV (V_POSITION, MyID)
	if (GetDistance(x, y, MySkillDestX, MySkillDestY) <= GetV(V_SKILLATTACKRANGE, MyID, MySkill)) then
		SkillGround(MyID, MySkillLevel, MySkill, MySkillDestX, MySkillDestY)
		MyState = SavedMyState
		MySkill = 0
	else
		SkillGround(MyID, MySkillLevel, MySkill, MySkillDestX, MySkillDestY)
	end
	if MyEnemy > 0 then
		if IsInAttackSight(MyID, MyEnemy) then
			Attack(MyID, MyEnemy)
		end
	end
	if GetTick() >= CommandTimeOut[SKILL_AREA_CMD_ST] then
		SkillGround(MyID, MySkillLevel, MySkill, x, y)
		OnSTOP_CMD()
	elseif (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION, MyID)) then
		MyDestX = MySkillDestX
		MyDestY = MySkillDestY
		Move(MyID, MyDestX, MyDestY)	
	end
end
---------------------------------------------------------------------------
function OnFOLLOW_CMD_ST()
---------------------------------------------------------------------------	
	local d = GetDistance(OwnerX, OwnerY, MyX, MyY)
	
	if (d <= 3) then
		------------------------------------
		--  Usar skills de recuperao.
		------------------------------------
		if HomunType ~= nil and (GetV(V_SP, MyID) / GetV(V_MAXSP, MyID)) * 100 > SkillsMinSP then
			for i, v in pairs (Skills_Homun) do
				if Skills_Homun[i].Engaged then
					if GetTick() > Skills_Homun[i].TimeOut then
						Skills_Homun[i].Engaged = false
						-- Log("Delay de "..i.." acabou.")
					end
				end
			end
			if SkillsTurn == 1 then
			if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < 100 or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < 100 then
				if not Skills_Homun[8013].Engaged and not Skills_Homun[8014].Engaged then
					if math.random(1, 100) <= Configuration[Eu].CB.FollowCMD.PChance
					and ((GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 < Configuration[Eu].CB.FollowCMD.MyMinHP 
					or (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 < Configuration[Eu].CB.FollowCMD.MastMinH) then
						--Log("Sorteio de Habilidade: usar AS_VAN_BLES.")
						local bles_level = 5
						if math.random(1, 100) > 50 then
							if math.random(1, 100) <= 40 then
								bles_level = 4
							elseif math.random(1, 100) <= 30 then
								bles_level = 3
							elseif math.random(1, 100) <= 20 then
								bles_level = 2
							elseif math.random(1, 100) <= 10 then
								bles_level = 1
							end
						end
						if DoSkill(8014, bles_level, MyID) then
							Timer_ToMove = 0
						end
					end
				end
			end
			end
			if SkillsTurn == 3 then
			if not Skills_Homun[8001].Engaged and not Skills_Homun[8002].Engaged then
				if math.random(1, 100) <= 30 and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 > 90 then
					--Log("Sorteio de Habilidade: usar AS_LIF_ESCP.")
					if DoSkill(8002, 5, MyID) then
						Timer_ToMove = 0
					end
				end
			end
			end
			if SkillsTurn == 4 then
			if not Skills_Homun[8005].Engaged and not Skills_Homun[8006].Engaged and not Skills_Homun[8008].Engaged then
				if (Configuration[Eu].CT.FollowCMD.Active and (GetV(V_MOTION, OwnerID) == MOTION_HIT or OwnerHit > 0)) or (DoAgain and DoAgain_Skill == 8005) then
					--Log("Sorteio de Habilidade: usar AS_AMI_CAST.")
					if DoSkill(8005, 5, OwnerID) then
						Timer_ToMove = 0
					end
				end
			end
			end
		end
		return
	end
	
	d = GetDistance(OwnerX, OwnerY, MyDestX, MyDestY)
	if (d > 3) then
		MyDestX, MyDestY = BestMovementToOwner()
		Move(MyID, MyDestX, MyDestY)
		return;
	end
end
-- ==========================
--  Outras Funes
-- ==========================
---------------------------------------------------------------------------
LstDeadEnemy = 0
-----------------------------
function GetEnemyOf(id, getList)
---------------------------------------------------------------------------
	if getList == nil then --  Data: 22/06/2011.
		getList = false
	end
	if GetV(V_MOTION, MyEnemy) == MOTION_DEAD and MyEnemy ~= LstDeadEnemy then
		LstDeadEnemy = MyEnemy
		Time_CanTakeDeadDmg = GetTick() + 1000
	end
	local result = 0
	local actors = GetActors()
-----------------------------
	local enemies = {}
	local index   = 1
	local enemies_notmonster = {}
	local index_notmonster   = 1
-----------------------------
	local target, motion_v, motion_id
-----------------------------
	for i, v in ipairs(actors) do
		if v > 0 and not IsOutOfSight(MyID, v) and (v ~= OwnerID and v ~= MyID and v ~= id) and GetV(V_MOTION, v) ~= MOTION_DEAD then
			if ((HasOfensiveMotion(v, id) or HasOfensiveMotion(id, v, false)) or AreaSkill(id, v) or AreaSkill(v, id)) 
			--and Unreachable[v]       == nil 
			then
				enemies[index] = v
				index = index + 1
			end
		end
	end
	if getList == true then
		return enemies
	end
	local dis_min = 27
	local dis
	local enemy_type
	for i, v in ipairs(enemies) do
		if HomunType ~= nil then
			enemy_type = GetV(V_HOMUNTYPE, v)
		else
			enemy_type = GetTypeFromID(v)
		end
		if  not IsMonster(v) then
			enemies_notmonster[index_notmonster] = v
			index_notmonster = index_notmonster + 1
		else
			--  Atacar MVPs primeiro, antes do seu Mob:
			if MVP_KS_OK[enemy_type] ~= nil then
				if GetV(V_TARGET, v) == id then
					result = v
					break
				end
			end
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	if result == 0 then
		dis_min = 27
		for i, v in ipairs(enemies_notmonster) do
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	return result
end
---------------------------------------------------------------------------
function GetMyEnemy(myid, getList)
---------------------------------------------------------------------------
	if getList == nil then
		getList = false
	end
	if GetV(V_MOTION, MyEnemy) == MOTION_DEAD and MyEnemy ~= LstDeadEnemy then
		LstDeadEnemy = MyEnemy
		Time_CanTakeDeadDmg = GetTick() + 1000
	end
	local enemyList = {}
	local result    = 0
	if getList then
		--if     DefaultBeha == Beha_Defend then
		--	enemyList = GetMyEnemyA(myid, getList)
		--elseif DefaultBeha == Beha_Attack then
			enemyList = GetMyEnemyA(myid, getList)
			if enemyList == {} and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 > AggroHP then
				local file_detect
				if     HomunType ~= nil then
					file_detect = io.open("AI/USER_AI/ID DATA/LowHP_A.txt", "r")
				elseif MercType  ~= nil then
					file_detect = io.open("AI/USER_AI/ID DATA/LowHP_H.txt", "r")
				end
				if not file_detect then
					enemyList = GetMyEnemyB(myid, getList)
				else
					local ln, nbr
					ln = file_detect:read()
					while ln ~= nil do
						if ln ~= nil then
							nbr = tonumber(ln) 
							if nbr == Ally_AI then
								ln = file_detect:read()
								nbr = tonumber(ln) --  Detectar se  o mesmo OwnerID para verificar se o HP est baixo.
								if nbr == OwnerID then
									break --  Mesmo OwnerID!
								end
							end
							ln = file_detect:read()
						end
					end
					if nbr ~= OwnerID then --  Se no for o mesmo OwnerID.
						enemyList = GetMyEnemyB(myid, getList)
					end
					file_detect:close()
				end
			end
		--end
		return enemyList
	else
		--if     DefaultBeha == Beha_Defend then
		--	result = GetMyEnemyA(myid)
		--elseif DefaultBeha == Beha_Attack then
			result = GetMyEnemyA(myid)
			if result <= 0 and (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 > AggroHP then
				local file_detect
				if     HomunType ~= nil then
					file_detect = io.open("AI/USER_AI/ID DATA/LowHP_A.txt", "r")
				elseif MercType  ~= nil then
					file_detect = io.open("AI/USER_AI/ID DATA/LowHP_H.txt", "r")
				end
				if not file_detect then
					result = GetMyEnemyB(myid)
				else
					local ln, nbr
					ln = file_detect:read()
					while ln ~= nil do
						if ln ~= nil then
							nbr = tonumber(ln) 
							if nbr == Ally_AI then
								ln = file_detect:read()
								nbr = tonumber(ln) --  Detectar se  o mesmo OwnerID para verificar se o HP est baixo.
								if nbr == OwnerID then
									break --  Mesmo OwnerID!
								end
							end
							ln = file_detect:read()
						end
					end
					if nbr ~= OwnerID then --  Se no for o mesmo OwnerID.
						result = GetMyEnemyB(myid)
					end
					file_detect:close()
				end
			end
		--end
	end
	return result
end
-----------------------------
--  GetMyEnemy Defensivo
-----------------------------
---------------------------------------------------------------------------
function GetMyEnemyA(myid, getList)
---------------------------------------------------------------------------
	if getList == nil then
		getList = false
	end
-----------------------------
	local result = 0
	local actors = GetActors()
-----------------------------
	local enemies = {}
	local index = 1
	local enemies_notmonster = {}
	local index_notmonster   = 1
-----------------------------
	local target, motion_v, motion_myid
-----------------------------
	for i, v in ipairs(actors) do
		if v > 0 and not IsOutOfSight(MyID, v) and (v ~= OwnerID and v ~= MyID and v ~= myid) and GetV(V_MOTION, v) ~= MOTION_DEAD then
			target = GetV(V_TARGET, v)
			if (HasOfensiveMotion(v, myid) or AreaSkill(myid, v)) 
			--and Unreachable[v]       == nil 
			then
				enemies[index] = v
				index = index + 1
			end
		end
	end
	if getList == true then
		return enemies
	end
	local dis_min = 27
	local dis
	local enemy_type
	for i, v in ipairs(enemies) do
		if HomunType ~= nil then
			enemy_type = GetV(V_HOMUNTYPE, v)
		else
			enemy_type = GetTypeFromID(v)
		end
		if  not IsMonster(v) then
			enemies_notmonster[index_notmonster] = v
			index_notmonster = index_notmonster + 1
		else
			--  Atacar MVPs primeiro, antes do seu Mob:
			if MVP_KS_OK[enemy_type] ~= nil then
				if GetV(V_TARGET, v) == myid then
					result = v
					break
				end
			end
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	if result == 0 then
		dis_min = 27
		for i, v in ipairs(enemies_notmonster) do
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	return result
end
-----------------------------
--  GetMyEnemy Agressivo
-----------------------------
---------------------------------------------------------------------------
function GetMyEnemyB(myid, getList)
---------------------------------------------------------------------------
	if getList == nil then
		getList = false
	end
-----------------------------
	local result = 0
	local actors = GetActors()
-----------------------------
	local enemies = {}
	local index = 1
	local enemies_last = {}
	local index_last = 1
	local enemies_notmonster = {}
	local index_notmonster   = 1
-----------------------------
	local v_x, v_y
	local enemy_type = 0
	for i, v in ipairs(actors) do
		if v > 0 and not IsOutOfSight(MyID, v) and (v ~= OwnerID and v ~= MyID and v ~= myid) and GetV(V_MOTION, v) ~= MOTION_DEAD
		and (GetV(V_MOTION, v) == MOTION_STAND or GetV(V_MOTION, v) == MOTION_MOVE) then
			v_x, v_y = GetV(V_POSITION, v)
			if (1 == IsMonster(v)) and not IsKS(v) 
			and Unreachable[v]       == nil 
			and Unreachable_IsNPC[v] == nil 
			and BlockDistance(OwnerX, OwnerY, v_x, v_y) < MaxDistance - 1
			then
				if HomunType ~= nil then
					enemy_type = GetV(V_HOMUNTYPE, v)
				else
					enemy_type = GetTypeFromID(v)
				end
				if  enemy_type ~= 1555
				and enemy_type ~= 1575
				and enemy_type ~= 1579
				and enemy_type ~= 1589
				and enemy_type ~= 1590
				and (enemy_type < 2114 or enemy_type > 2125)
				and (DefaultBeha == Beha_Attack 
				  or GetBehavToID_or_Type(v) == "Aggressive")
				then
					enemies[index] = v
					index = index + 1
				end
			end
		end
	end
	if getList == true then
		return enemies
	end
	local dis_min = 27
	local dis
	for i, v in ipairs(enemies) do
		if HomunType ~= nil then
			enemy_type = GetV(V_HOMUNTYPE, v)
		else
			enemy_type = GetTypeFromID(v)
		end
		if  enemy_type >= 1078 and enemy_type <= 1085 then
			enemies_last[index_last] = v
			index_last = index_last + 1
		else
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	if result == 0 then
		dis_min = 27
		for i, v in ipairs(enemies_last) do
			dis = GetDistance2(MyID, v)
			if (dis < dis_min) then
				result = v
				dis_min = dis
			end
		end
	end
	return result
end
---------------------------------------------------------------------------
function EnemyOnFollow(destX, destY)
---------------------------------------------------------------------------
	if destX == nil or destY == nil then --  Data: 22/06/2011
		destX, destY = MyX, MyY
	elseif destX < 0 or destY < 0 then
		destX, destY = MyX, MyY
	end
	local objects = GetEnemyOf(OwnerID, true)
	if objects == {} then
		for i, v in pairs (Friends) do
			if GetEnemyOf(v, true) ~= {} then
				objects = GetEnemyOf(v, true)
				break
			end
		end
		if objects == {} then
			objects = GetMyEnemy(MyID, true)
		end
	end
	local object  = 0
	local dis_min = 27
	local dis
	local x, y = -1, -1
	for i, v in ipairs(objects) do
		x, y = GetV(V_POSITION, v)
		dis = GetDistance(destX, destY, x, y)
		if (dis < dis_min) then
			object  = v
			dis_min = dis
		end
	end
	return object
end
---------------------------------------------------------------------------
function StdMove(myid, x, y)
---------------------------------------------------------------------------
	if x == -1 or y == -1 then
		return;
	end
	if x == OwnerX and y == OwnerY then
		if     (MyX < x) then
			x = x -  1
		elseif (MyX > x) then
			x = x + 1
		end
		if     (MyY < y) then
			y = y - 1
		elseif (MyY > y) then
			y = y + 1
		end
	end
	local actual_ownerx, actual_ownery = GetV(V_POSITION, OwnerID)
	if (GetDistance(OwnerX, OwnerY, x, y) >= 0 and BlockDistance(OwnerX, OwnerY, x, y) < MaxDistance - 1
	and GetDistance(actual_ownerx, actual_ownery, x, y) >= 0 and BlockDistance(actual_ownerx, actual_ownery, x, y) < MaxDistance - 1) 
	or MyState == MOVE_CMD_ST then
		CallMove(myid, x, y)
	else
		MyDestX, MyDestY = MyX, MyY
	end
end
---------------------------------------------------------------------------
LstDestX, LstDestY      = -1, -1
ShortX, ShortY = -1, -1
-----------------------------
TryCount_SameDest = 0
-----------------------------
function LimMove(myid, x, y, emergency_move)
---------------------------------------------------------------------------
	if emergency_move == nil then
		emergency_move = false
	end
	if x == OwnerX and y == OwnerY then
		if     (MyX < x) then
			x = x -  1
		elseif (MyX > x) then
			x = x + 1
		end
		if     (MyY < y) then
			y = y - 1
		elseif (MyY > y) then
			y = y + 1
		end
	end
	if MyDestX ~= x or MyDestY ~= y then
		MyDestX, MyDestY = x, y
	end
	Log("...")
	Log("-------------------  Mover  --------------------------")
	Log("meu estado: "..MyState..", meu inimigo: "..MyEnemy..".")
	if PosChangeSkill then Log("...cancelar: perigo de Bug Position.") return; end
	---------------------
	local ex, ey = -1, -1
	if MyEnemy > 0 then
		ex, ey = GetV(V_POSITION, MyEnemy)
	end
	---------------------
	if ((GetTick() > Timer_ToMove 
	or ((x == ShortX and y == ShortY) or (x ~= LstDestX or y ~= LstDestY) or GetV(V_MOTION, MyID) ~= MOTION_STAND))
	and GetTick() > (Timer_ToMove - Time_BetweenMoveCmd) + 750) 
	or MyState == MOVE_CMD_ST 
	or emergency_move == true
	or ((MyState == FOLLOW_ST or MyState == FOLLOW_CMD_ST) and ((GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) or (FirstFollow and GetV(V_MOTION, MyID) ~= MOTION_MOVE and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged))))
	or (MyState == CHASE_ST and (GetV(V_MOTION, MyID) ~= MOTION_MOVE or BlockDistance(MyDestX, MyDestY, ex, ey) >= AttackRange) and MyEnemy > 0 and GetV(V_MOTION, MyEnemy) == MOTION_MOVE) then
		Timer_ToMove = GetTick() + Time_BetweenMoveCmd
	else
		Log("...invlido. (6).")
		return
	end
	if not emergency_move then
		if MyState == CHASE_ST and DelayAfterFollow_ToChase > 0 and GetTick() < DelayAfterFollow_ToChase then
			Log("...invlido. Esperando delay de depois de seguir acabar antes.")
			return;
		end
	end
	Log("mover para ("..x.."; "..y..")...")
	-----------------------------------------------
	--  Impedir Sobrecarga de Comandos.
	-----------------------------------------------
	if x == -1 or y == -1 then
		Log("...invlido. (1).")
		return;
	end
	-----------------------------------------------
	if x == LstDestX and y == LstDestY and GetV(V_MOTION, MyID) == MOTION_MOVE and (x ~= ShortX or y ~= ShortY) then Log("...invlido. (2).") return; end
	-----------------------------------------------
	if x == MyX      and y == MyY      and GetV(V_MOTION, MyID) ~= MOTION_MOVE then Log("...invlido. (3).") return; end
	-----------------------------------------------
	if x == LstDestX and y == LstDestY and GetV(V_MOTION, MyID) == MOTION_STAND then
		TryCount_SameDest = TryCount_SameDest + 1
	else
		TryCount_SameDest = 0
	end
	-----------------------------------------------
	LstDestX, LstDestY = x, y
	-----------------------------------------------
	if TryCount_SameDest > 4 then
		Log("...invlido. (7).")
		return
	end
	-----------------------------------------------
	local curx, cury = MyX, MyY
	-----------------------------------------------
	--  Movimentao para distncias muito grandes.
	-----------------------------------------------
	if (math.abs(x - curx) + math.abs(y - cury) > 10) then
		local tempx, tempy = curx, cury
		local while_rounds = 24
		while while_rounds > 0 and math.abs(x - tempx) + math.abs(y - tempy) > 10 do
			while_rounds = while_rounds - 1
			tempx, tempy = math.floor((x + curx) / 2), math.floor((y + cury) / 2)
			if (math.abs(x- tempx) + math.abs(y - tempy) <= 15 and math.random(1, 100) <= 25) then
				while_rounds = 0
			end
		end
		if (GetDistance(OwnerX, OwnerY, tempx, tempy) >= 0 and BlockDistance(OwnerX, OwnerY, tempx, tempy) < MaxDistance - 1) then
			if (x == ShortX and y == ShortY) or (ShortX == LstDestX and ShortY == LstDestY) then
				Log("...encurtar para ("..tempx.."; "..tempy..").")
				StdMove(myid, tempx, tempy)
			elseif BlockDistance(OwnerX, OwnerY, x, y) < MaxDistance - 1 then
				Log("...sucesso!")
				StdMove(myid, x, y)
			else
				Log("...invlido. (nearerOut).")
			end
			Timer_ToMove = 0
			-------------------------------------------------------
			ShortX, ShortY = x, y
			if GetV(V_MOTION, MyID) == MOTION_MOVE and MyState ~= MOVE_CMD_ST then
				MyDestX, MyDestY = tempx, tempy
			end
			-------------------------------------------------------
			return
		elseif BlockDistance(OwnerX, OwnerY, tempx, tempy) == MaxDistance - 1 then
			if     tempx > OwnerX then
				tempx = tempx - 1
			elseif tempx < OwnerX then
				tempx = tempx + 1
			end
			if     tempy > OwnerY then
				tempy = tempy - 1
			elseif tempy < OwnerY then
				tempy = tempy + 1
			end
			if (x == ShortX and y == ShortY) or (ShortX == LstDestX and ShortY == LstDestY) then
				Log("...encurtar para ("..tempx.."; "..tempy..").")
				StdMove(myid, tempx, tempy)
			elseif BlockDistance(OwnerX, OwnerY, x, y) < MaxDistance - 1 then
				Log("...sucesso!")
				StdMove(myid, x, y)
			else
				Log("...invlido. (nearerOut).")
			end
			Timer_ToMove = 0
			-------------------------------------------------------
			ShortX, ShortY = x, y
			if GetV(V_MOTION, MyID) == MOTION_MOVE and MyState ~= MOVE_CMD_ST then
				MyDestX, MyDestY = tempx, tempy
			end
			-------------------------------------------------------
			return
		else
			Log("...invlido. (4).")
			return
		end
	end
	if (GetDistance(OwnerX, OwnerY, x, y) >= 0 and BlockDistance(OwnerX, OwnerY, x, y) < MaxDistance - 1) or MyState == MOVE_CMD_ST then
		Log("...sucesso!")
		StdMove(myid, x, y)
		return
	elseif BlockDistance(OwnerX, OwnerY, x, y) == MaxDistance - 1 then
		if     x > OwnerX then
			x = x - 1
		elseif x < OwnerX then
			x = x + 1
		end
		if     y > OwnerY then
			y = y - 1
		elseif y < OwnerY then
			y = y + 1
		end
		Log("...sucesso!")
		StdMove(myid, x, y)
		return
	else
		Log("...invlido. (5).")
		return
	end
end
---------------------------------------------------------------------------
Screen_Actors = {} --  Pode ser utilizado em funes auxiliares em Util.lua... (21:57 18/07/2011).
-----------------------------
Initialized_Screen  = false
LastActorChk              = 0
Time_ToGetAct             = 5000
GetAct_X, GetAct_Y  = -1, -1
-----------------------------
function GetActors_Sec(force)
---------------------------------------------------------------------------
	if force == nil then
		force = false
	end
	local time_now = GetTick()
	local delta    = time_now - LastActorChk
	---
	if not force then
	---
	local attackingFriend = false
	if (((GetV(V_MOTION, MyID) == MOTION_HIT 
	or    GetV(V_MOTION, MyID) == MOTION_ATTACK
	or    GetV(V_MOTION, MyID) == MOTION_ATTACK2)  and NoOtherIsAttacking(MyID))
	or  ((GetV(V_MOTION, OwnerID) == MOTION_HIT 
	or    GetV(V_MOTION, OwnerID) == MOTION_ATTACK 
	or    GetV(V_MOTION, OwnerID) == MOTION_ATTACK2 
	or    GetV(V_MOTION, OwnerID) == MOTION_SKILL) and NoOtherIsAttacking(OwnerID))) then
		attackingFriend = true
	else
		for i, v in pairs (Friends) do
			if (GetV(V_MOTION, v) == MOTION_HIT 
			or  GetV(V_MOTION, v) == MOTION_ATTACK 
			or  GetV(V_MOTION, v) == MOTION_ATTACK2 
			or  GetV(V_MOTION, v) == MOTION_SKILL) and NoOtherIsAttacking(v) then
				attackingFriend = true
				break
			end
		end
	end
	-------------------------------
	if Time_ToGetAct > 15000 then
		Time_ToGetAct = 15000
	end
	-------------------------------
	local noneOrFewHere = false
	local noneOrFewHere_count = 0
	local totalCount          = 0
	for i, v in ipairs (Screen_Actors) do
		if IsMonster(v) == 1 then
			if GetV(V_MOTION, v) == MOTION_DEAD or IsOutOfSight(MyID, v) or GetDistance2(OwnerID, v) >= MaxDistance then
				noneOrFewHere_count = noneOrFewHere_count + 1
			end
			totalCount = i
		end
	end
	if noneOrFewHere_count > totalCount / 3 then
		noneOrFewHere = true
	end
	if (GetAct_X == -1 or GetAct_Y == -1) then
		GetAct_X, GetAct_Y = OwnerX, OwnerY
	end
	if LastActorChk == 0 and (GetV(V_MOTION, OwnerID) == MOTION_STAND) and GetTick() < Timer_Delay then
		return Screen_Actors
	elseif LastActorChk == 0 then
		Log("...")
		Log("imunidade inicial cancelada.")
	end
	--Log("...")
	--Log("-------------------  Detectar IDs  --------------------------")
	if  (delta < 1000) then
		--Log("...GetActors falhou (1).")
		return Screen_Actors
	elseif attackingFriend then
		LastActorChk = time_now
	elseif (delta < Time_ToGetAct / 5) then
		--Log("...GetActors falhou (2).")
		return Screen_Actors
	elseif (MyEnemy > 0 and GetV(V_MOTION, MyEnemy) ~= MOTION_HIT) then
		--Log("...GetActors falhou (3).")
		return Screen_Actors
	elseif ((MyState == FOLLOW_ST or MyState == FOLLOW_CMD_ST) and GetDistance(GetAct_X, GetAct_Y, OwnerX, OwnerY) <= 15 and (GetV(V_MOTION, MyID) == MOTION_MOVE or GetV(V_MOTION, OwnerID) == MOTION_MOVE)) then
		--Log("...GetActors falhou (4).")
		return Screen_Actors
	elseif (GetDistance(GetAct_X, GetAct_Y, OwnerX, OwnerY) > 15 and (MyState == IDLE_ST or ((MyState == FOLLOW_ST or MyState == FOLLOW_CMD_ST) and GetV(V_MOTION, OwnerID) ~= MOTION_MOVE))) or noneOrFewHere then
		LastActorChk = time_now
	elseif (delta < Time_ToGetAct) --  Anti-Lag que funciona... (20:42 18/07/2011). Aperfeioado em 21:42 18/07/2011. Correo 21:33 20/07/2011, para homnculos no ficar "esperando um monstro causar dano".
	then
		--Log("...GetActors falhou (5).")
		return Screen_Actors
	else
		LastActorChk  = time_now
	end
	---
	else
	---
		LastActorChk  = time_now
	---
	end
	---
	-------------------------------
	GetAct_X, GetAct_Y  = -1, -1
	-------------------------------
	local temp_register = {}
	local index = 1
	-------------------------------
	temp_register   = Screen_Actors
	Screen_Actors = {}
	Time_ToGetAct = 0
	for i, v in ipairs(StdGetActors()) do --  Evitar Lag...
		if  v > 0 then
			Screen_Actors[i] = v
		end
		if IsMonster(v) == 1 then
			Time_ToGetAct = Time_ToGetAct + 250
		else
			Time_ToGetAct = Time_ToGetAct + 50
		end
		index = i
	end
	--
	if Time_ToGetAct > 15000 then
		Time_ToGetAct = 15000
	end
	--Log("...sucesso!")
	--Log("delay: "..Time_ToGetAct.." ms.")
	local file_dis_max
	local ln, nbr
	local dis_max = 15
	if not Initialized_Screen then
		Initialized_Screen = true
		Log("...")
		Log("------------------  rea de Alcance  ------------------")
		Log("...ver valor no arquivo 'ID DATA/Screen_Dist.txt' ...")
		file_dis_max = io.open("AI/USER_AI/ID DATA/Screen_Dist.txt", "r")
		if not file_dis_max then 
			Log("...no encontrado!")
			Log("manter distncia mxima 15.")
		else
			ln = file_dis_max:read()
			if ln ~= nil then
				nbr = tonumber(ln)
				if nbr ~= nil then
					dis_max = nbr
				end
			end
			file_dis_max:close()
		end
		if dis_max ~= MaxDistance then
			Log("...detectado!")
			Log("alterar distncia mxima para "..dis_max..".")
			MaxDistance = dis_max
		end
	end
	file_dis_max = io.open("AI/USER_AI/ID DATA/Screen_Dist.txt", "r")
	if file_dis_max then
		ln = file_dis_max:read()
		if ln ~= nil then
			nbr = tonumber(ln)
			if nbr ~= nil then
				dis_max = nbr
			end
		end
		file_dis_max:close()
	end
	if dis_max ~= MaxDistance then
		Log("...")
		Log("------------------  rea de Alcance  ------------------")
		Log("arquivo 'ID DATA/Screen_Dist.txt' mudou...")
		Log("...alterar para "..dis_max..".")
		MaxDistance = dis_max
	end
	local f_out
	if     HomunType ~= nil then
		f_out = io.open("AI/USER_AI/TEMP/Screen_Actors_H.txt", "w")
		if not f_out then 
			Log("Falha ao abrir o arquivo 'TEMP/Screen_Actors_H.txt' para registrar os 'Atores' detectados na tela.")
			return Screen_Actors
		end
	elseif MercType ~= nil then
		f_out = io.open("AI/USER_AI/TEMP/Screen_Actors_A.txt", "w")
		if not f_out then 
			Log("Falha ao abrir o arquivo 'TEMP/Screen_Actors_A.txt' para registrar os 'Atores' detectados na tela.")
			return Screen_Actors
		end
	else
		return Screen_Actors
	end
	f_out:write("'Atores' detectados na tela ("..GetTick().." ms):\n")
	for i, v in ipairs (Screen_Actors) do
			f_out:write("Screen_Actors["..i.."] = "..v.."\n")
	end
	f_out:write("Distncia mxima de deteco de 'Atores': "..MaxDistance.."\n")
	f_out:close()
	return Screen_Actors
end
---------------------------------------------------------------------------
LstID_Attack   = 0
-----------------------------
Timer_ToAttack       = 0
TryCount_CauseDamage = 0
-----------------------------
function Attack_Sec(id, enemy)
---------------------------------------------------------------------------
	--if GetTick() > Timer_ToAttack then
	--	Timer_ToAttack = GetTick() + 1
	--else
	--	return
	--end
	if GetV(V_MOTION, enemy) ~= MOTION_DEAD then
		if enemy ~= LstID_Attack then
			Log("...")
			Log("-------------------  Atacar --------------------------")
			Log("meu estado: "..MyState..".")
			Log("...atacar ("..enemy..")!")
			LstID_Attack = enemy
		end
		StdAttack(id, enemy)
	end
end
---------------------------------------------------------------------------
Delay_ProtectionMoveOnHit = 0
------------------------------
function OutOfRange_Verify()
---------------------------------------------------------------------------
	local distance
	-----------------------------------------
	distance = GetDistanceFromOwner(MyID)
	if (BlockDistance(OwnerX, OwnerY, MyX, MyY) > MaxDistance - 1) then
		Timer_ToMove = 0
		MyDestX, MyDestY = OwnerX, OwnerY
		Move(MyID, MyDestX, MyDestY, true)
		Timer_ToMove = 0
		Log("sa da tela: seguir imediatamente!")	
	elseif (BlockDistance(OwnerX, OwnerY, MyDestX, MyDestY) >= MaxDistance - 1) 
	and MyState ~= MOVE_CMD_ST then
		if MyState == CHASE_ST or MyState == ATTACK_ST then
			Timer_ToMove = 0
			MyDestX, MyDestY = MyX, MyY
			Move(MyID, MyDestX, MyDestY, true)
		elseif (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) and NearerOrFarther == 1 and MyState ~= FOLLOW_ST and MyState ~= FOLLOW_CMD_ST then
			MyState = FOLLOW_ST
			Timer_ToMove = 0
			MyDestX, MyDestY = OwnerX, OwnerY
			Move(MyID, MyDestX, MyDestY, true)
		else
			OnSTOP_CMD()
		end
		Log("para no sair da tela: seguir imediatamente! Indo para longe!")	
	elseif (BlockDistance(OwnerX, OwnerY, MyX, MyY) >= MaxDistance - 1) and (MyState == IDLE_ST or (GetV(V_MOTION, MyID) == MOTION_MOVE 
	and MyEnemy == 0)) and MyState ~= MOVE_CMD_ST then
		OnSTOP_CMD()
		if MyState ~= FOLLOW_ST and MyState ~= FOLLOW_CMD_ST then
			MyState = FOLLOW_ST
		end
		Timer_ToMove = 0
		MyDestX, MyDestY = OwnerX, OwnerY
		Move(MyID, MyDestX, MyDestY, true)
		Timer_ToMove = 0
		Log("para no sair da tela: seguir imediatamente! Quase saindo!")	
	elseif (((distance > MaxDistance - 6) and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged or MyState == IDLE_ST) and NearerOrFarther == 1) or ((distance > MaxDistance - 3) and (GetV(V_MOTION, OwnerID) == MOTION_MOVE))) and MyState ~= FOLLOW_ST and MyState ~= FOLLOW_CMD_ST 
	and MyState ~= MOVE_CMD_ST then
		MyState = FOLLOW_ST
		Timer_ToMove = 0
		MyDestX, MyDestY = OwnerX, OwnerY
		Move(MyID, MyDestX, MyDestY, true)
		Timer_ToMove = 0
		Log("para no sair da tela: seguir.")	
	elseif CheckFollowFirstTime == true and ((distance > MaxDistance - 6) and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged or MyState == IDLE_ST) and MyState ~= FOLLOW_ST and MyState ~= FOLLOW_CMD_ST 
	and MyState ~= MOVE_CMD_ST) then
		Timer_ToMove = 0
		MyDestX, MyDestY = OwnerX, OwnerY
		Move(MyID, MyDestX, MyDestY, true)
		Timer_ToMove = 0
		Log("para no sair da tela: seguir, a AI iniciou o processamento com o homunculus j longe do Mestre.")	
	elseif GetV(V_MOTION, MyID) == MOTION_HIT and GetTick() > Timer_Delay then
		if math.random(1, 100) <= 10 and GetTick() > Delay_ProtectionMoveOnHit then
			Delay_ProtectionMoveOnHit = GetTick() + 10000
			StdMove(MyID, MyDestX, MyDestY, true)
		end	
	end
	CheckFollowFirstTime = false
end
---------------------------------------------------------------------------
function protectedrandom(n1, n2)
---------------------------------------------------------------------------
	if n1 == n2 then
		n1 = n2 - 1
	end
	return stdrandom(n1, n2)
end
---------------------------------------------------------------------------
MyID                    = 0
OwnerID                 = 0
---------------
LstMyX, LstMyY          = -1, -1
MyX, MyY                = -1, -1
OwnerX, OwnerY          = -1, -1
LstOwnerX, LstOwnerY    = -1, -1
---------------
NearerOrFarther = 0
---------------
PosChangeSkill_Before_OwnerX, PosChangeSkill_Before_OwnerY = -1, -1
---------------
MyHP    = 0
LstMyHP = 0
HPLostOrGain    = 0
LstHPLostOrGain = 0
MyEnemy_Strong  = 0
---------------
LstMyEnemy_CanAttack = 0
MyEnemy_CanAttack    = false
---------------
Last_EnemyMotion            = 0
Count_NotChangingMotion     = 0
Last_MyEnemyMotionDetection = 0
---------------
OwnerHit = 0
DoAgain  = false
DoAgain_Skill        = 0
DonePosChangeSkill   = 0
---------------
SavedMyState = IDLE_ST
-----------------------------
AlternateDancingX = 0
AlternateDancingY = 0
DancingMoves = 0
FirstDancingMove = true
DanceTries   = 0
---------------
Loops                   = 0
Redirected_Homun        = 0
-----------------------------
CheckFollowFirstTime    = false
-----------------------------
LastUsedAutoDancingTime = 0
-----------------------------
Eu                      = 3
-----------------------------
StayOnSameSkillTurnForComboOrSkill = 0
Timer_StayOnSameSkillTurn          = 0
-----------------------------
function AI_Sec(myid)
---------------------------------------------------------------------------
	MyID = myid
	--Log("...... "..MyID.."; "..OwnerID.."; "..MyEnemy.."; "..MyX.."; "..MyY.."; "..MyDestX.."; "..MyDestY.."; "..MyState.."; "..GetV(V_MOTION, MyID).."; "..MySkill..".")
	-----------------------
	if not Initialized then
	-----------------------
		Log("...")
		Log("-------------------------  Inicializao  -------------------------------")
		Log("minha ID: "..MyID.."...")
		-----------------------
		if not FileExists("AI/USER_AI/TEMP/Friends.txt") then
			local create_friendsfile = io.open("AI/USER_AI/TEMP/Friends.txt", "w")
			create_friendsfile:close()
		end
		---------------------------------------------
		--  [Configurao.] Carregar Configuraes. 
		---------------------------------------------
		if     HomunType ~= nil then
			Eu = Config_Types.Homunculus
		elseif MercType ~= nil then
			Eu = Config_Types.Assistente
		else
			Eu = Config_Types.Desconhece
		end
		Log("Meu valor numrico para as configuraes: "..Eu..".")

		local savemyid
		if     HomunType ~= nil then
			savemyid = io.open("AI/USER_AI/TEMP/ID_H.txt", "w")
			-------
			if FileExists("AI/USER_AI/TEMP/TypeUpdate.txt") then
				os.remove("AI/USER_AI/TEMP/TypeUpdate.txt")
			end
			-------
			if FileExists("AI/USER_AI/TEMP/Screen_Actors_H.txt") then
				os.remove("AI/USER_AI/TEMP/Screen_Actors_H.txt")
			end
			-------
			if FileExists("AI/USER_AI/ID DATA/LowHP_A.txt") then
				os.remove("AI/USER_AI/ID DATA/LowHP_A.txt")
			end
		elseif MercType ~= nil then
			savemyid = io.open("AI/USER_AI/TEMP/ID_A.txt", "w")
			-------
			if FileExists("AI/USER_AI/TEMP/Screen_Actors_A.txt") then
				os.remove("AI/USER_AI/TEMP/Screen_Actors_A.txt")
			end
			-------
			if FileExists("AI/USER_AI/ID DATA/LowHP_H.txt") then
				os.remove("AI/USER_AI/ID DATA/LowHP_H.txt")
			end
		end
		Log("...salvar ID...")
		if savemyid ~= nil then
			if HomunType ~= nil then
				Log("...sucesso em 'AI/USER_AI/TEMP/ID_H.txt'.")
			elseif MercType ~= nil then
				Log("...sucesso em 'AI/USER_AI/TEMP/ID_A.txt'.")
			end
			savemyid:write(MyID.."\n"..GetV(V_OWNER, MyID).."\n")
			savemyid:close()
		else
			Log("...erro (1).")
		end
		-----------------------
		OwnerID      = GetV(V_OWNER, MyID)
		Log("ID do usurio: "..OwnerID.."...")
		StartTime    = GetTick()
		CallMove     = Move; Move = LimMove                 --  Substituir Move      pela verso protegida.
		StdGetActors = GetActors; GetActors = GetActors_Sec --  Substituir GetActors pela verso protegida.
		StdAttack    = Attack; Attack = Attack_Sec          --  Substituir Move      pela verso protegida.
		stdrandom    = random; random = protectedrandom
		-------------------------------------------
		OwnerX, OwnerY = GetV(V_POSITION, OwnerID)
		Log("...posio inicial do Usurio: ("..OwnerX.."; "..OwnerY..").")
		-------------------------------------------
		if     HomunType ~= nil then
			if FileExists(File_Beha_H) then
				DefaultBeha = Beha_Attack
			end
		elseif MercType ~= nil then
			if FileExists(File_Beha_M) then
				DefaultBeha = Beha_Attack
			end
		end
		-----------------------
		if AddAllyAIToFriends(true) then
			FriendList_Load(true)
		else
			FriendList_Load()
		end

		LoadSkillToType()
		LoadBehavToID_or_Type()

		-------------------------------------------
		--  [Configurao.] Opes do Painel
		-------------------------------------------
		if ConfigError ~= nil then
			if ConfigError == false then
				local config_success
				local config_error
				config_success, config_error = pcall(LoadConfig)
				if not config_success then
					ConfigError = true
					if config_error ~= LstError then
						TraceAI(config_error)
						LstError = config_error
						file_temp = io.open(File_Error, "a+")
						if not file_temp then 
							file_temp = io.open(File_Error, "w")
							if not file_temp then 
								return
							end
						end
						file_temp:write(config_error.."\n")
						file_temp:close()
					end
				end
			end
		end
		-------------------------------------------
		Initialized  = true
		Log("-------------------------------------------------------------------------")
		CheckFollowFirstTime = true
	end

	-----------------------
	--  Atualizar Configuraes.
	-----------------------
	if ConfigError ~= nil then
		if ConfigError == false then
			local config_success
			local config_error
			config_success, config_error = pcall(UpdateConfig)
			if not config_success then
				ConfigError = true
				if config_error ~= LstError then
					TraceAI(config_error)
					LstError = config_error
					file_temp = io.open(File_Error, "a+")
					if not file_temp then 
						file_temp = io.open(File_Error, "w")
						if not file_temp then 
							return
						end
					end
					file_temp:write(config_error.."\n")
					file_temp:close()
				end
			end
		end
	end
	-----------------------

	----------------------------------------------------
	--  Reparar Arquivo "Friends.txt"
	----------------------------------------------------
	local repair_friendsfile
	if not FileExists("AI/USER_AI/TEMP/Friends.txt") then
		local repair_friendsfile = io.open("AI/USER_AI/TEMP/Friends.txt", "w")
		if repair_friendsfile then
			repair_friendsfile:close()
		end
	else
		FriendList_Clear(true)
	end
	----------------------------------------------------
	--  Atualizao de Variveis de Status
	----------------------------------------------------
	-------------------------------
	--  Detectar uso de habilidades
	-------------------------------
	if not PosChangeSkill then
		DonePosChangeSkill   = 0
	end
	if DoneSkill == 1 then
		DoneSkill = 0
	end
	if MySkill_SPVarDetect ~= 0 then
		if SPBeforeSkillUse > GetV(V_SP, MyID) or GetV(V_MOTION, MyID) == MOTION_SKILL then
			DelaySum            = 0
			SPBeforeSkillUse    = 0
			DoneSkill           = 1
			if     HomunType ~= nil then
				if Skills_Homun[MySkill_SPVarDetect] ~= nil then
					Log("habilidade "..Skills_Homun[MySkill_SPVarDetect].String.." utilizada com sucesso. Deteco depois de "..Loops.." loopings da programao.")
					Skills_Homun[MySkill_SPVarDetect].Engaged = true
				else
					Log("habilidade "..MySkill_SPVarDetect.." utilizada com sucesso.")
				end
			elseif MercType ~= nil then
				if SkillSlot[MySkill_SPVarDetect] ~= nil then
					Log("habilidade "..SkillSlot[MySkill_SPVarDetect].SkillID.." utilizada com sucesso. Deteco depois de "..Loops.." looping(s) da programao.")
					SkillSlot[MySkill_SPVarDetect].Engaged = true
				else
					Log("habilidade "..MySkill_SPVarDetect.." utilizada com sucesso.")
				end
			else
				Log("habilidade "..MySkill_SPVarDetect.." utilizada com sucesso.")
			end
			MySkill_SPVarDetect = 0
			Loops               = 0
			if MyState == SKILL_OBJECT_CMD_ST or MyState == SKILL_AREA_CMD_ST then
				MyState = SavedMyState --  Isso causou alguns erros... Adicionei para ser s para os 'CMD_ST' de habilidades.
			end
		elseif Loops > 2 then
			Log("falha no uso da habilidade "..MySkill_SPVarDetect..".")
			DelaySum = DelaySum + 1
			if DelaySum >= 3 or Timer_ToUseSkill - GetTick() >= 2000 then
				DelaySum = 0
				Timer_ToUseSkill = 0
			end
			Timer_ToUseSkill = Timer_ToUseSkill + DelaySum * 500
			SPBeforeSkillUse    = 0
			DoneSkill           = 0
			MySkill_SPVarDetect = 0
			Loops               = 0
		elseif GetV(V_MOTION, MyID) ~= MOTION_CAST then
			--Log("Loop: "..Loops..".")
			Loops = Loops + 1
		else
			Log("Conjurando habilidade.")
		end
	else
		if SPBeforeSkillUse ~= 0 then
			SPBeforeSkillUse    = 0
		end
		if Loops ~= 0 then
			Loops               = 0
		end
	end
	if MySkill_SPVarDetect == 0 then
		if EmergencyVerify == 1 then
			EmergencyVerify = 0
		else
			EmergencyVerify = 1

			if StayOnSameSkillTurnForComboOrSkill ~= 0 then
				if Timer_StayOnSameSkillTurn == 0 then
					Timer_StayOnSameSkillTurn          = GetTick() + 10000
				elseif GetTick() > Timer_StayOnSameSkillTurn then
					Timer_StayOnSameSkillTurn          = 0
					StayOnSameSkillTurnForComboOrSkill = 0
				end
			else
				SkillsTurn = SkillsTurn + 1
				if SkillsTurn > 9 or Redirected_Homun ~= 0 then
					SkillsTurn = 1
					Redirected_Homun = 0
				end
			end
		end
	end
	--Log("ID do tipo de homunculus: "..HomunType.Value..".")
	if HomunType ~= nil then
		if     HomunType.Value == 4 or HomunType.Value == 8 or HomunType.Value == 12 or HomunType.Value == 16 then --  Vanilmirth.
			--Log("Redirecionar para o tipo: Vanilmirth (rodada 1).")
			SkillsTurn = 1
		elseif HomunType.Value == 3 or HomunType.Value == 7 or HomunType.Value == 11 or HomunType.Value == 15 then --  Filir.
			--Log("Redirecionar para o tipo: Filir (rodada 2).")
			SkillsTurn = 2
		elseif HomunType.Value == 1 or HomunType.Value == 5 or HomunType.Value == 9  or HomunType.Value == 13 then --  Lif.
			--Log("Redirecionar para o tipo: Lif (rodada 3).")
			SkillsTurn = 3
		elseif HomunType.Value == 2 or HomunType.Value == 6 or HomunType.Value == 10 or HomunType.Value == 14 then --  Amistr.
			--Log("Redirecionar para o tipo: Amistr (rodada 4).")
			SkillsTurn = 4
		end
		if Redirected_Homun == 0 then
			if SkillsTurn > 4 and SkillsTurn <= 9 then
				if     HomunType.Value == 50 then --  Sera.
					--Log("Redirecionar para o tipo: Sera (rodada 5).")
					SkillsTurn = 5
					Redirected_Homun = SkillsTurn
				elseif HomunType.Value == 48 then --  Eira.
					--Log("Redirecionar para o tipo: Eira (rodada 6).")
					SkillsTurn = 6
					Redirected_Homun = SkillsTurn
				elseif HomunType.Value == 52 then --  Eleanor.
					--Log("Redirecionar para o tipo: Eleanor (rodada 7).")
					SkillsTurn = 7
					Redirected_Homun = SkillsTurn
				elseif HomunType.Value == 49 then --  Bayeri.
					--Log("Redirecionar para o tipo: Bayeri (rodada 8).")
					SkillsTurn = 8
					Redirected_Homun = SkillsTurn
				elseif HomunType.Value == 51 then --  Dieter.
					--Log("Redirecionar para o tipo: Dieter (rodada 9).")
					SkillsTurn = 9
					Redirected_Homun = SkillsTurn
				end
			end
		end
		if DoAgain then
			Log("Uma habilidade especfica precisa de ser utilizada novamente.")
			if DoAgain_Skill == 8005 then
				Log("Redirecionar para o tipo: Amistr (rodada 4).")
				SkillsTurn = 4
			end
		end
		--Log("habilidades por tipo, rodada nmero: "..SkillsTurn..".")
	end
	---------------------------------
	--  Deteco para uso de Castling
	---------------------------------
	if GetV(V_MOTION, OwnerID) == MOTION_HIT then
		OwnerHit = OwnerHit + 1
		if OwnerHit > 3 then
			OwnerHit = 3
		end
	end
	-----------------------
	--  Minha Posio
	-----------------------
	LstMyX, LstMyY                = MyX, MyY
	MyX, MyY                      = GetV(V_POSITION, MyID)
	if LstMyX <= -1 then
		LstMyX, LstMyY = MyX, MyY
	end
	-----------------------
	--  Posio do Dono
	-----------------------
	local temp_OwnerX, temp_OwnerY = GetV(V_POSITION, OwnerID)
	if (OwnerX == -1) or ((temp_OwnerX ~= OwnerX or temp_OwnerY ~= OwnerY) 
	and (PosChangeSkill_Before_OwnerX == -1 
	or   PosChangeSkill_Before_OwnerX ~= temp_OwnerX or PosChangeSkill_Before_OwnerY ~= temp_OwnerY)) then
		OwnerX, OwnerY = temp_OwnerX, temp_OwnerY
		DoAgain        = false
		PosChangeSkill = false
	elseif PosChangeSkill then
		if DoneSkill == 1 then
			DonePosChangeSkill = 1
			if (temp_OwnerX ~= MyX_BefSkill or temp_OwnerY ~= MyY_BefSkill) and not PvPHere then
				Log("uma habilidade posicionou o Mestre em ("..MyX_BefSkill.."; "..MyY_BefSkill.."),")
				Log("porm ele ainda aparece em ("..OwnerX.."; "..OwnerY.."). Usar de novo para remover Bug Position.")
				PosChangeSkill_Before_OwnerX, PosChangeSkill_Before_OwnerY = OwnerX, OwnerY
				OwnerX, OwnerY = MyX_BefSkill, MyY_BefSkill
				DoAgain = true
			else
				Log("uma habilidade posicionou corretamente o Mestre em ("..OwnerX.."; "..OwnerY..").")
				OwnerX, OwnerY = temp_OwnerX, temp_OwnerY
				DoAgain        = false
				PosChangeSkill = false
			end
		end
		if DoAgain and (DonePosChangeSkill) then
			DoAgain_Skill = 8005
			DoSkill(8005, 5, OwnerID)
		elseif MySkill_SPVarDetect == 0 then
			OwnerX, OwnerY = temp_OwnerX, temp_OwnerY
			DoAgain        = false
			PosChangeSkill = false
			DonePosChangeSkill = 0
		end
	end
	if OwnerX ~= -1 then
		if LstOwnerX ~= OwnerX or LstOwnerY ~= OwnerY then
			OwnerPosChanged = true
		else
			OwnerPosChanged = false
		end
		if GetDistance(LstOwnerX, LstOwnerY, MyX, MyY) < GetDistance(OwnerX, OwnerY, MyX, MyY) then
			NearerOrFarther = 1  --  Est se afastando.
		elseif GetDistance(LstOwnerX, LstOwnerY, MyX, MyY) > GetDistance(OwnerX, OwnerY, MyX, MyY) then
			NearerOrFarther = -1 --  Aproximando-se.
		else
			NearerOrFarther = 0
		end
		LstOwnerX, LstOwnerY = OwnerX, OwnerY
	else
		OwnerPosChanged = false
		OwnerX, OwnerY = LstOwnerX, LstOwnerY
		Log("posio do usurio invlida: usando a anterior ("..LstOwnerX.."; "..LstOwnerY..").")
	end

	-----------------------
	--  Limpeza
	-----------------------
	if CanDoKS ~= MyEnemy then 
		CanDoKS = 0
	end
	-----------------------
	--  Deteco de HP Cooperativa
	-----------------------
	local file_detect
	if     HomunType ~= nil then
		if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 <= AggroHP then
			file_detect = io.open("AI/USER_AI/ID DATA/LowHP_H.txt", "a+")
			if not file_detect then
				file_detect = io.open("AI/USER_AI/ID DATA/LowHP_H.txt", "w")
			end
			if file_detect then
				local ln, nbr
				nbr = 0
				ln = file_detect:read()
				while ln ~= nil do
					nbr = tonumber(ln)
					if nbr == MyID then
						ln = file_detect:read()
						nbr = tonumber(ln)
						if nbr == OwnerID then
							break
						end
					end
					ln = file_detect:read()
				end
				if nbr ~= OwnerID then
					file_detect:write(MyID.."\n"..OwnerID.."\n")
				end
				file_detect:close()
			else
				Log("erro ao criar arquivo para deteco de baixo HP.")
			end
		else
			file_detect = io.open("AI/USER_AI/ID DATA/LowHP_H.txt", "r")
			if file_detect then
				local ln, nbr
				nbr = 0
				ln = file_detect:read()
				while ln ~= nil do
					nbr = tonumber(ln)
					if nbr == MyID then
						ln = file_detect:read()
						nbr = tonumber(ln)
						if nbr == OwnerID then
							break
						end
					end
					ln = file_detect:read()
				end
				file_detect:close()
				if nbr == OwnerID then
					os.remove("AI/USER_AI/ID DATA/LowHP_H.txt")
				end
			end
		end
	elseif MercType  ~= nil then
		if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 <= AggroHP then
			file_detect = io.open("AI/USER_AI/ID DATA/LowHP_A.txt", "a+")
			if not file_detect then
				file_detect = io.open("AI/USER_AI/ID DATA/LowHP_A.txt", "w")
			end
			if file_detect then
				local ln, nbr
				nbr = 0
				ln = file_detect:read()
				while ln ~= nil do
					nbr = tonumber(ln)
					if nbr == MyID then
						ln = file_detect:read()
						nbr = tonumber(ln)
						if nbr == OwnerID then
							break
						end
					end
					ln = file_detect:read()
				end
				if nbr ~= OwnerID then
					file_detect:write(MyID.."\n"..OwnerID.."\n")
				end
				file_detect:close()
			else
				Log("erro ao criar arquivo para deteco de baixo HP.")
			end
		else
			file_detect = io.open("AI/USER_AI/ID DATA/LowHP_A.txt", "r")
			if file_detect then
				local ln, nbr
				nbr = 0
				ln = file_detect:read()
				while ln ~= nil do
					nbr = tonumber(ln)
					if nbr == MyID then
						ln = file_detect:read()
						nbr = tonumber(ln)
						if nbr == OwnerID then
							break
						end
					end
					ln = file_detect:read()
				end
				file_detect:close()
				if nbr == OwnerID then
					os.remove("AI/USER_AI/ID DATA/LowHP_A.txt")
				end
			end
		end
	end
	----------------------------------------
	--  Deteco de Inimigos que no atacam
	----------------------------------------
	if MyEnemy > 0 then
		if not MyEnemy_CanAttack and GetV(V_MOTION, MyEnemy) ~= MOTION_STAND then
			LstMyEnemy_CanAttack = MyEnemy
			MyEnemy_CanAttack    = true
		elseif MyEnemy ~= LstMyEnemy_CanAttack then
			MyEnemy_CanAttack    = false
		end
	----------------------------------------------------
		if MyEnemy ~= Last_MyEnemyMotionDetection then
			Last_MyEnemyMotionDetection = MyEnemy
			EnemyNotChangingMotion = false
			Count_NotChangingMotion = 0
		elseif GetV(V_MOTION, MyEnemy) == Last_EnemyMotion then
			Last_MyEnemyMotionDetection = MyEnemy
			Count_NotChangingMotion = Count_NotChangingMotion + 1
		else
			Last_EnemyMotion = GetV(V_MOTION, MyEnemy)
			EnemyNotChangingMotion = false
			Count_NotChangingMotion = 0
		end
		if Count_NotChangingMotion > 13 then
			-- Log("o inimigo no est mudando gesto.")
			EnemyNotChangingMotion = true
		end
	end
	----------------------------------------------------
	--  Limpar a lista de inimigos inacessveis se eles j morreram ou saram da tela para o caso de seu ID ser reutilizado.
	--  Caso seja um ovo ou uma planta, limpar mesmo assim a cada 30 segundos, para tentar denovo.
	----------------------------------------------------
	if Timer_CleanUnreachable ~= 0 and GetTick() >= Timer_CleanUnreachable then
		for k, v in ipairs(Unreachable) do
			Unreachable[k] = nil
		end
		Timer_CleanUnreachable = 0
	end
	----------------------------------------------------
	-- Tentar novamente caso o gesto do "inalcanvel" mude.
	----------------------------------------------------
	for k, v in ipairs(Unreachable) do
		Unreachable_Motion[k] = GetV(V_MOTION, k)
		if Unreachable_LastMotion[k] == nil then
			Unreachable_LastMotion[k] = Unreachable_Motion[k]
		end
		if Unreachable_Motion[k] ~= Unreachable_LastMotion[k] 
		and Unreachable_Motion[k] ~= MOTION_MOVE 
		and (Unreachable_LastMotion[k] ~= MOTION_MOVE or Unreachable_Motion[k] ~= MOTION_STAND) then
			Unreachable[k] = nil
		end
		Unreachable_LastMotion[k] = Unreachable_Motion[k]
	end
	----------------------------------------------------
	-- Detectar gesto de Habilidade.
	----------------------------------------------------
	if Had_MOTION_Timer == 0 then
		Had_MOTION_Timer = GetTick() + (math.random(2, 5) * 1000)
	elseif GetTick() >= Had_MOTION_Timer then
		Had_MOTION_SKILL        = {}
		Had_MOTION_PICKUP       = {}
		Had_MOTION_detect_count = 0
		Had_MOTION_Timer = 0
	end
	for i, v in ipairs(Screen_Actors) do
		if Had_MOTION_detect_count <= 5 then
			if GetV(V_MOTION, v) == MOTION_SKILL and not Had_MOTION_SKILL[v] then
				Log(v.." teve gesto MOTION_SKILL.")
				Had_MOTION_SKILL[v] = 1
				Had_MOTION_detect_count = Had_MOTION_detect_count + 1
			end
			if GetV(V_MOTION, v) == MOTION_PICKUP and not Had_MOTION_PICKUP[v] then
				Had_MOTION_PICKUP[v] = 1
				Had_MOTION_detect_count = Had_MOTION_detect_count + 1
			end
		else
			break
		end
	end
	----------------------------------------------------
	local msg	= GetMsg(myid)       --  Command.
	local rmsg	= GetResMsg(myid)    --  Reserved Command.
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright(ResCmdList, rmsg)
			end
		end
	else
		List.clear(ResCmdList) 
		ProcessCommand(msg)
	end
	-----------------------------------------
	--  Adicionar AI aliada como protegida.
	-----------------------------------------
	AddAllyAIToFriends(false)
	-----------------------------------------
	--  Adicionar amigos temporrios.
	-----------------------------------------
	TempFriendSearch(false)
	-----------------------------------------
	if HomunType ~= nil then
		------------------
		DetectDC_ID()
		------------------
	end
	-----------------------------------------
	--  Manter na tela
	-----------------------------------------
	OutOfRange_Verify()
	-----------------------------------------
	--  Detectar alvo forte
	-----------------------------------------
	MyHP    = GetV(V_HP, MyID)
	if LstMyHP == 0 then
		LstMyHP = MyHP
	end
	HPLostOrGain = MyHP - LstMyHP
	if LstHPLostOrGain == 0 then
		LstHPLostOrGain = HPLostOrGain
	end
	if MyState == ATTACK_ST and (MyEnemy_Strong == 0 or MyEnemy ~= MyEnemy_Strong) then
		if  CanDoKS ~= MyEnemy 
		and not IsPlayer(MyEnemy) 
		and CountEnemiesCloseTo(MyID) > 1 
		and HPLostOrGain < 0 
		then
			if HPLostOrGain < LstHPLostOrGain * 2 then
				MyEnemy_Strong = GetActorAttacking(MyID)
				if MyEnemy_Strong > 0 then
					Log("perdi muito dano para "..MyEnemy_Strong..": marc-lo como alvo principal.")
					MyEnemy = MyEnemy_Strong
				end
			end
		end
	end
	LstHPLostOrGain = HPLostOrGain
	LstMyHP         = MyHP
	-----------------------------------------
	--  Primeiro movimento ao seguir
	-----------------------------------------
	if MyState ~= FOLLOW_ST and not FirstFollow then
		FirstFollow = true
	end
	-----------------------------------------
        -----------------------------
	--  Detectar se  PvP.
        -----------------------------
	if GetTick() > Interval_PvPDetect or Interval_PvPDetect == 0 then
		Interval_PvPDetect = GetTick() + 2000
		for i, v in ipairs(GetActors()) do
			if not PvPHere and IsPlayer(v) and IsMonster(v) == 1 then
				PvPHere	= true
				Log("cuidado, aqui  PvP! O jogador "..v.."  um alvo vlido.")
				break
			elseif PvPHere and IsPlayer(v) and IsMonster(v) ~= 1 and v ~= OwnerID and v ~= MyID then
				PvPHere	= false
				Log("O jogador "..v.." no  um alvo vlido: cancelar bandeira de PvP.")
				break
			end
		end
	end
        -----------------------------
	local lstEnemy = MyEnemy
        -----------------------------
 	if     (MyState == IDLE_ST             ) then
		lstEnemy = MyEnemy
		OnIDLE_ST()
		if MyEnemy ~= lstEnemy then
			Time_CanTakeDeadDmg = GetTick() + 1000
		end
	elseif (MyState == CHASE_ST            ) then
		lstEnemy = MyEnemy
		OnCHASE_ST()
		if MyEnemy ~= lstEnemy then
			Time_CanTakeDeadDmg = GetTick() + 1000
		end
	elseif (MyState == ATTACK_ST           ) then
		local canUseAutoDancing = false;
		if GetTick() > LastUsedAutoDancingTime then
			canUseAutoDancing  = true;
		end
		if canUseAutoDancing and not ForceDancing and MyEnemy_CanAttack and ((HPLostOrGain < -math.floor((8 / 100) * GetV(V_MAXHP, MyID))  and HPLostOrGain < 0)) and ((not IsPlayer(MyEnemy) and math.random(1, 100) <= 10) or (IsPlayer(MyEnemy) and math.random(1, 100) <= 50))  then
			DancingMoves = DancingMoves + 30
			FirstDancingMove = true
			DanceTries   = 0
			LastUsedAutoDancingTime = GetTick() + 10000;
		end
		lstEnemy = MyEnemy
		OnATTACK_ST()
		if (DancingMoves >= 1 or ForceDancing) and MyState == ATTACK_ST then

			local ex, ey = GetV(V_POSITION, MyEnemy)
			if  (MyX == MyDestX and MyY == MyDestY) or FirstDancingMove or (GetV(V_MOTION, MyID) ~= MOTION_MOVE) then

				DancingMoves = DancingMoves - 1
				local random_direction = math.random(0, 1)
				if (MyX ~= MyDestX or MyY ~= MyDestY) and not FirstDancingMove then
					if DanceTries > 10 then
						if GetV(V_MOTION, MyEnemy) ~= MOTION_STAND and GetV(V_MOTION, MyEnemy) ~= MOTION_TK_LEAP_LAND then
							DanceTries = 0
						end
					elseif DanceTries >= 5 then
						local ex_near = ex + math.random(-AttackRange, AttackRange)
						local ey_near = ey + math.random(-AttackRange, AttackRange)
						
						Timer_ToMove = 0
						Move(MyID, -ex_near, -ey_near)
						Timer_ToMove = 0
						Move(MyID, -ex_near, -ey_near)
						Attack(MyID, MyEnemy)
						Timer_ToMove = 0
						Move(MyID, ex_near, ey_near)
						Timer_ToMove = 0
						Move(MyID, ex_near, ey_near)
						Attack(MyID, MyEnemy)

					elseif (MyDestX == ex + (1) and MyDestY == MyY) then
						
						
						AlternateDancingX = 0
						Timer_ToMove = 0 --  Tirar Delay entre comandos de movimento para o dancing...
						Move(MyID, ex - (1), MyY)
						Timer_ToMove = 0
						Move(MyID, ex - (1), MyY)
						Attack(MyID, MyEnemy)
						Timer_ToMove = 0
						Move(MyID, ex + (1), MyY)
						Timer_ToMove = 0
						Move(MyID, ex + (1), MyY)
						Attack(MyID, MyEnemy)
						
					elseif (MyDestX == ex - (1) and MyDestY == MyY) then
						
						
						AlternateDancingX = 1
						Timer_ToMove = 0
						Move(MyID, ex + (1), MyY)
						Timer_ToMove = 0
						Move(MyID, ex + (1), MyY)
						Attack(MyID, MyEnemy)
						Timer_ToMove = 0
						Move(MyID, ex - (1), MyY)
						Timer_ToMove = 0
						Move(MyID, ex - (1), MyY)
						Attack(MyID, MyEnemy)
						
					elseif (MyDestX == MyX and MyDestY == ey + (1)) then
						
						
						AlternateDancingY = 0
						Timer_ToMove = 0
						Move(MyID, MyX, ey - (1))
						Timer_ToMove = 0
						Move(MyID, MyX, ey - (1))
						Attack(MyID, MyEnemy)
						Timer_ToMove = 0
						Move(MyID, MyX, ey + (1))
						Timer_ToMove = 0
						Move(MyID, MyX, ey + (1))
						Attack(MyID, MyEnemy)
						
					elseif (MyDestX == MyX and MyDestY == ey - (1)) then
						
						
						AlternateDancingY = 1
						Timer_ToMove = 0
						Move(MyID, MyX, ey + (1))
						Timer_ToMove = 0
						Move(MyID, MyX, ey + (1))
						Attack(MyID, MyEnemy)
						Timer_ToMove = 0
						Move(MyID, MyX, ey - (1))
						Timer_ToMove = 0
						Move(MyID, MyX, ey - (1))
						Attack(MyID, MyEnemy)
						
						
					end
					DanceTries = DanceTries + 1
				else
					DanceTries = 0
					if random_direction == 1 then
						if AlternateDancingX == 1 then
							AlternateDancingX = 0
							Timer_ToMove = 0 --  Tirar Delay entre comandos de movimento para o dancing...
							Move(MyID, ex - (1), MyY)
							Timer_ToMove = 0
							Move(MyID, ex - (1), MyY)
							Attack(MyID, MyEnemy)
							Timer_ToMove = 0
							Move(MyID, ex + (1), MyY)
							Timer_ToMove = 0
							Move(MyID, ex + (1), MyY)
							Attack(MyID, MyEnemy)
						elseif AlternateDancingX == 0 then
							AlternateDancingX = 1
							Timer_ToMove = 0
							Move(MyID, ex + (1), MyY)
							Timer_ToMove = 0
							Move(MyID, ex + (1), MyY)
							Attack(MyID, MyEnemy)
							Timer_ToMove = 0
							Move(MyID, ex - (1), MyY)
							Timer_ToMove = 0
							Move(MyID, ex - (1), MyY)
							Attack(MyID, MyEnemy)
						end
					elseif random_direction == 0 then
						if AlternateDancingY == 1 then
							AlternateDancingY = 0
							Timer_ToMove = 0
							Move(MyID, MyX, ey - (1))
							Timer_ToMove = 0
							Move(MyID, MyX, ey - (1))
							Attack(MyID, MyEnemy)
							Timer_ToMove = 0
							Move(MyID, MyX, ey + (1))
							Timer_ToMove = 0
							Move(MyID, MyX, ey + (1))
							Attack(MyID, MyEnemy)
						elseif AlternateDancingY == 0 then
							AlternateDancingY = 1
							Timer_ToMove = 0
							Move(MyID, MyX, ey + (1))
							Timer_ToMove = 0
							Move(MyID, MyX, ey + (1))
							Attack(MyID, MyEnemy)
							Timer_ToMove = 0
							Move(MyID, MyX, ey - (1))
							Timer_ToMove = 0
							Move(MyID, MyX, ey - (1))
							Attack(MyID, MyEnemy)
						end
					end
				end
				if DanceTries > 10 then
					DancingMoves = 0
				end
			elseif GetV(V_MOTION, MyID) == MOTION_MOVE then
				DanceTries = 0
			
				Timer_ToMove = 0
				StdMove(MyID, MyDestX, MyDestY)
				Timer_ToMove = 0
				StdMove(MyID, MyDestX, MyDestY)
				Attack(MyID, MyEnemy)
				Timer_ToMove = 0
				StdMove(MyID, MyDestX, MyDestY)
				Timer_ToMove = 0
				StdMove(MyID, MyDestX, MyDestY)
				Attack(MyID, MyEnemy)
			end
			if FirstDancingMove then
				FirstDancingMove = false
			end	
		end
		if MyEnemy ~= lstEnemy then
			Time_CanTakeDeadDmg = GetTick() + 1000
		end
	elseif (MyState == FOLLOW_ST           ) then
		OnFOLLOW_ST()
		if FirstFollow then
			FirstFollow = false
		end
		if GetV(V_MOTION, OwnerID) == MOTION_MOVE then 
		--   isto que est causando erro? X.X"
			DelayAfterFollow         = GetTick() + (math.random(1, 3) * 1000)
			DelayAfterFollow_ToChase = GetTick() + (math.random(1, 2) * 1000)
		end
	elseif (MyState == MOVE_CMD_ST         ) then
		OnMOVE_CMD_ST()
	elseif (MyState == STOP_CMD_ST         ) then
		OnSTOP_CMD_ST()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST()
	elseif (MyState == ATTACK_AREA_CMD_ST  ) then
		OnATTACK_AREA_CMD_ST()
	elseif (MyState == PATROL_CMD_ST       ) then
		OnPATROL_CMD_ST()
	elseif (MyState == HOLD_CMD_ST         ) then
		OnHOLD_CMD_ST()
	elseif (MyState == SKILL_OBJECT_CMD_ST ) then
		OnSKILL_OBJECT_CMD_ST()
	elseif (MyState == SKILL_AREA_CMD_ST   ) then
		OnSKILL_AREA_CMD_ST()
	elseif (MyState == FOLLOW_CMD_ST       ) then
		OnFOLLOW_CMD_ST()
	else
		OnIDLE_ST()
	end		
	-----------------------------------------
	-- Manter na tela (verificao 2)
	-----------------------------------------
	OutOfRange_Verify()
end
