--------------------------------------------------
--
-- Homunculus Type Library - Monster Data
--
--	mobdata2.lua
--
--	var.2006/03/17
--	translated by Doddler
--
--------------------------------------------------
--
--	ver.2007/12/01
--      Used by TNT.Nitro
--	Para verificar monstros perigosos de 
--      Galho Seco e fechar o Rag imediatamente
--      para no perder XP
--
--------------------------------------------------
--
-- Usage
-- local mobname = MOBDATA[id][M_V_NAME] -- Gets the monster name
-- local mobspec = MOBDATA[id][M_V_SPEC] -- Gets the monster race
--
--
-- Comments with '/' in it are either 0 or 1 values
--
-- Comments with '#' in it are options listed farther in the file.
--
-- Unknown Data is listed as 0
--
--------------------------------------------------
-- # constants #
--------------------------------------------------
M_V_NAME	= 1	-- Monster Name
M_V_LV		= 2	-- Level
M_V_MAXHP	= 3	-- Monster Max HP
M_V_BASEEXP	= 4	-- Base Exp for killing
M_V_JOBEXP	= 5	-- Job Exp for killing
M_V_SPEC	= 6	-- # Race #
M_V_ATT		= 7	-- # Element #
M_V_ATTLV	= 8	-- Element Level
M_V_SIZE	= 9	-- # Size #
M_V_LOOT	= 10	-- /Loot
M_V_LINK	= 11	-- /Link
M_V_ACTIVE	= 12	-- /Active
M_V_SPELL	= 13	-- /Caster
M_V_MOVE	= 14	-- /Move?
M_V_SPLASH	= 15	-- /Splash Damage
M_V_LONG	= 16	-- /Long Range (Blockable by Pneuma)
M_V_ATKMIN	= 17	-- Minimum Attack
M_V_ATKMAX	= 18	-- Maximum Attack
M_V_DEFDIV	= 19	-- Armor DEF
M_V_DEFSUB	= 20	-- Vit DEF
M_V_MATKMIN	= 21	-- Minimum MATK
M_V_MATKMAX	= 22	-- Maximum MATK
M_V_MDEFDIV	= 23	-- Armor MDEF
M_V_MDEFSUB	= 24	-- Int MDEF
M_V_MOVESPD	= 25	-- # Move Speed # (In relation to player movespeed)
M_V_ASPD	= 26	-- Attack Speed
M_V_RANGE	= 27	-- Range
M_V_HIT		= 28	-- Perfect HIT
M_V_FLEE	= 29	-- Perfect FLEE

--------------------------------------------------
-- # Race #
--------------------------------------------------
M_SPAC_NONE	= 0	-- Formless
M_SPAC_UNDEAD	= 1	-- Undead
M_SPAC_ANIMAL	= 2	-- Brute
M_SPAC_PLANT	= 3	-- Plant
M_SPAC_BUG	= 4	-- Insect
M_SPAC_FISH	= 5	-- Fish
M_SPAC_DEVIL	= 6	-- Demon
M_SPAC_PEOPLE	= 7	-- Demihuman
M_SPAC_ANGEL	= 8	-- Angel
M_SPAC_DRAGON	= 9	-- Dragon

--------------------------------------------------
-- # Element #
--------------------------------------------------
M_ATT_NONE	= 0	-- Neutral
M_ATT_WATER	= 1	-- Water
M_ATT_GROUND	= 2	-- Earth
M_ATT_FIRE	= 3	-- Fire
M_ATT_WIND	= 4	-- Wind
M_ATT_POISON	= 5	-- Poison
M_ATT_HOLY	= 6	-- Holy
M_ATT_DARK	= 7	-- Dark
M_ATT_SENSE	= 8	-- Ghost
M_ATT_UNDEAD	= 9	-- Undead

--------------------------------------------------
-- # TCY #
--------------------------------------------------
M_SIZE_SMALL	= 1	-- Small
M_SIZE_MIDDLE	= 2	-- Medium
M_SIZE_LARGE	= 3	-- Large

--------------------------------------------------
-- # Movementspeed #
--------------------------------------------------
M_MOVESPD_SLOW	= 1	-- Slow Move Speed
M_MOVESPD_SAME	= 2	-- Normal Movement speed
M_MOVESPD_FAST	= 3	-- Fast Movement Speed
--------------------------------------------------

-- ACRESCENTE/REMOVA o comantario na frente da linha para:
--             COM COMENTARIO = inativo para SHUTDOWN
--             SEM COMENTARIO = ATIVO para SHUTDOWN

MOBDATA = { }

-- MOBDATA[1001] = {'Scorpion'}
-- MOBDATA[1002] = {'Poring'}
-- MOBDATA[1004] = {'Hornet'}
-- MOBDATA[1005] = {'Familiar'}
-- MOBDATA[1007] = {'Fabre'}
-- MOBDATA[1008] = {'Pupa'}
-- MOBDATA[1009] = {'Condor'}
-- MOBDATA[1010] = {'Willow'}
-- MOBDATA[1011] = {'Chonchon'}
-- MOBDATA[1012] = {'Roda Frog'}
-- MOBDATA[1013] = {'Wolf'}
-- MOBDATA[1014] = {'Spore'}
-- MOBDATA[1015] = {'Zombie'}
-- MOBDATA[1016] = {'Archer Skeleton'}
-- MOBDATA[1017] = {'Thief Bug Female'}
-- MOBDATA[1018] = {'Creamy'}
-- MOBDATA[1019] = {'Peco Peco'}
-- MOBDATA[1020] = {'Mandragora'}
-- MOBDATA[1021] = {'Thief Bug Male'}
-- MOBDATA[1022] = {'Werewolf'}
-- MOBDATA[1023] = {'Orc Warrior'}
-- MOBDATA[1024] = {'Wormtail'}
-- MOBDATA[1025] = {'Boa / Snake'}
-- MOBDATA[1025] = {'Snake / Boa'}
-- MOBDATA[1026] = {'Munak'}
-- MOBDATA[1027] = {'Raptice'}
-- MOBDATA[1028] = {'Soldier Skeleton'}
-- MOBDATA[1029] = {'Isis'}
-- MOBDATA[1030] = {'Anacondaq'}
-- MOBDATA[1031] = {'Poporing'}
-- MOBDATA[1032] = {'Verit'}
-- MOBDATA[1033] = {'Elder Willow'}
-- MOBDATA[1034] = {'Thara Frog'}
-- MOBDATA[1035] = {'Hunter Fly'}
-- MOBDATA[1036] = {'Ghoul'}
-- MOBDATA[1037] = {'Side Winder'}
MOBDATA[1038] = {'Osiris'}
MOBDATA[1039] = {'Baphomet'}
-- MOBDATA[1040] = {'Golem'}
-- MOBDATA[1041] = {'Mummy'}
-- MOBDATA[1042] = {'Steel Chonchon'}
-- MOBDATA[1043] = {'Seahorse'}
-- MOBDATA[1044] = {'Obeaune'}
-- MOBDATA[1045] = {'Marc'}
MOBDATA[1046] = {'Doppelganger'}
-- MOBDATA[1047] = {'Peco Peco Egg'}
-- MOBDATA[1048] = {'Thief Bug Egg'}
-- MOBDATA[1049] = {'Picky'}
-- MOBDATA[1050] = {'Picky (Shell)'}
-- MOBDATA[1051] = {'Thief Bug'}
-- MOBDATA[1052] = {'Rocker'}
-- MOBDATA[1055] = {'Muka'}
-- MOBDATA[1056] = {'Smokie'}
-- MOBDATA[1057] = {'Yoyo'}
-- MOBDATA[1058] = {'Metaller'}
MOBDATA[1059] = {'Mistress'}
-- MOBDATA[1060] = {'Bigfoot'}
-- MOBDATA[1061] = {'Nightmare'}
-- MOBDATA[1062] = {'Santa Poring'}
-- MOBDATA[1063] = {'Lunatic'}
-- MOBDATA[1064] = {'Megalodon'}
-- MOBDATA[1065] = {'Strouf'}
-- MOBDATA[1066] = {'Vadon'}
-- MOBDATA[1067] = {'Cornutus'}
-- MOBDATA[1068] = {'Hydra'}
-- MOBDATA[1069] = {'Swordfish'}
-- MOBDATA[1070] = {'Kukre'}
-- MOBDATA[1071] = {'Pirate Skeleton'}
-- MOBDATA[1072] = {'Kaho'}
-- MOBDATA[1073] = {'Crab'}
-- MOBDATA[1074] = {'Shellfish'}
-- MOBDATA[1076] = {'Skeleton'}
-- MOBDATA[1077] = {'Poison Spore'}
-- MOBDATA[1078] = {'Red Plant'}
-- MOBDATA[1079] = {'Blue Plant'}
-- MOBDATA[1080] = {'Green Plant'}
-- MOBDATA[1081] = {'Yellow Plant'}
-- MOBDATA[1082] = {'White Plant'}
-- MOBDATA[1083] = {'Shining Plant'}
-- MOBDATA[1084] = {'Black Mushroom'}
-- MOBDATA[1085] = {'Red Mushroom'}
MOBDATA[1086] = {'Golden Thief Bug'}
MOBDATA[1087] = {'Orc Hero'}
-- MOBDATA[1088] = {'Vocal'}
-- MOBDATA[1089] = {'Toad'}
-- MOBDATA[1090] = {'Mastering'}
-- MOBDATA[1091] = {'Dragon Fly'}
-- MOBDATA[1092] = {'Vagabond Wolf'}
-- MOBDATA[1093] = {'Eclipse'}
-- MOBDATA[1094] = {'Ambernite'}
-- MOBDATA[1095] = {'Andre'}
-- MOBDATA[1096] = {'Angeling'}
-- MOBDATA[1097] = {'Ant Egg'}
-- MOBDATA[1099] = {'Argiope'}
-- MOBDATA[1100] = {'Argos'}
-- MOBDATA[1101] = {'Baphomet Jr.'}
-- MOBDATA[1102] = {'Bathory'}
-- MOBDATA[1103] = {'Caramel'}
-- MOBDATA[1104] = {'Coco'}
-- MOBDATA[1105] = {'Deniro'}
-- MOBDATA[1106] = {'Desert Wolf'}
-- MOBDATA[1107] = {'Desert Wolf Baby / Baby Desert Wolf'}
-- MOBDATA[1108] = {'Deviace'}
-- MOBDATA[1109] = {'Deviruchi'}
-- MOBDATA[1110] = {'Dokebi'}
-- MOBDATA[1111] = {'Drainliar'}
MOBDATA[1112] = {'Drake'}
-- MOBDATA[1113] = {'Drops'}
-- MOBDATA[1114] = {'Dustiness'}
MOBDATA[1115] = {'Eddga'}
-- MOBDATA[1116] = {'Eggyra'}
-- MOBDATA[1117] = {'Evil Druid'}
-- MOBDATA[1118] = {'Flora'}
-- MOBDATA[1119] = {'Frilldora'}
-- MOBDATA[1120] = {'Ghostring'}
-- MOBDATA[1121] = {'Giearth'}
-- MOBDATA[1122] = {'Goblin (Dagger/Wind)'}
-- MOBDATA[1123] = {'Goblin (Flail/Fire)'}
-- MOBDATA[1124] = {'Goblin (Axe/Poison)'}
-- MOBDATA[1125] = {'Goblin (Mace/Earth)'}
-- MOBDATA[1126] = {'Goblin (Morning Star/Water)'}
-- MOBDATA[1127] = {'Hode'}
-- MOBDATA[1128] = {'Horn'}
-- MOBDATA[1129] = {'Horong'}
-- MOBDATA[1130] = {'Jakk'}
-- MOBDATA[1131] = {'Joker'}
-- MOBDATA[1132] = {'Khalitzburg'}
-- MOBDATA[1133] = {'Kobold (Axe/Wind)'}
-- MOBDATA[1134] = {'Kobold (Mace/Poison)'}
-- MOBDATA[1135] = {'Kobold (Morning Star/Fire)'}
-- MOBDATA[1138] = {'Magnolia'}
-- MOBDATA[1139] = {'Mantis'}
-- MOBDATA[1140] = {'Marduk'}
-- MOBDATA[1141] = {'Marina'}
-- MOBDATA[1142] = {'Marine Sphere'}
-- MOBDATA[1143] = {'Marionette'}
-- MOBDATA[1144] = {'Marse'}
-- MOBDATA[1145] = {'Martin'}
-- MOBDATA[1146] = {'Matyr'}
MOBDATA[1147] = {'Maya'}
-- MOBDATA[1148] = {'Medusa'}
-- MOBDATA[1149] = {'Minorous'}
MOBDATA[1150] = {'Moonlight Flower'}
-- MOBDATA[1151] = {'Myst'}
-- MOBDATA[1152] = {'Orc Skeleton'}
-- MOBDATA[1153] = {'Orc Zombie'}
-- MOBDATA[1154] = {'Pasana'}
-- MOBDATA[1155] = {'Petit (Earth)'}
-- MOBDATA[1156] = {'Petit (Wind)'}
MOBDATA[1157] = {'Pharaoh'}
-- MOBDATA[1158] = {'Phen'}
MOBDATA[1159] = {'Phreeoni'}
-- MOBDATA[1160] = {'Piere'}
-- MOBDATA[1161] = {'Plankton'}
-- MOBDATA[1162] = {'Rafflesia'}
-- MOBDATA[1163] = {'Raydric'}
-- MOBDATA[1164] = {'Requiem'}
-- MOBDATA[1165] = {'Sandman'}
-- MOBDATA[1166] = {'Savage'}
-- MOBDATA[1167] = {'Savage Babe'}
-- MOBDATA[1168] = {'Scorpion King'}
-- MOBDATA[1169] = {'Skeleton Worker'}
-- MOBDATA[1170] = {'Sohee'}
-- MOBDATA[1171] = {'Soldier Andre'}
-- MOBDATA[1172] = {'Soldier Deniro'}
-- MOBDATA[1173] = {'Soldier Piere'}
-- MOBDATA[1174] = {'Stainer'}
-- MOBDATA[1175] = {'Tarou'}
-- MOBDATA[1176] = {'Vitata'}
-- MOBDATA[1177] = {'Zenorc'}
-- MOBDATA[1178] = {'Zerom'}
-- MOBDATA[1179] = {'Whisper'}
-- MOBDATA[1180] = {'Nine Tail'}
-- MOBDATA[1182] = {'Thief Mushroom'}
-- MOBDATA[1185] = {'Whisper (Immobile)'}
-- MOBDATA[1186] = {'Giant Whisper'}
-- MOBDATA[1188] = {'Bongun'}
-- MOBDATA[1189] = {'Orc Archer'}
MOBDATA[1190] = {'Orc Lord'}
-- MOBDATA[1191] = {'Mimic'}
-- MOBDATA[1192] = {'Wraith'}
-- MOBDATA[1193] = {'Alarm'}
-- MOBDATA[1194] = {'Arclouze / Arclouse'}
-- MOBDATA[1195] = {'Rideword'}
-- MOBDATA[1196] = {'Skeleton Prisoner'}
-- MOBDATA[1197] = {'Zombie Prisoner'}
MOBDATA[1198] = {'Dark Priest'}
-- MOBDATA[1199] = {'Punk'}
MOBDATA[1200] = {'Zealotus / Zherlthsh'}
-- MOBDATA[1201] = {'Rybio'}
MOBDATA[1202] = {'Phendark'}
MOBDATA[1203] = {'Mysteltainn'}
MOBDATA[1204] = {'Tirfing / Ogretooth'}
MOBDATA[1205] = {'Executioner'}
-- MOBDATA[1206] = {'Anolian'}
-- MOBDATA[1207] = {'Sting'}
MOBDATA[1208] = {'Wanderer / Wander Man'}
-- MOBDATA[1209] = {'Cramp'}
-- MOBDATA[1210] = {'Filamentous'}
-- MOBDATA[1211] = {'Brilight'}
-- MOBDATA[1212] = {'Iron Fist'}
-- MOBDATA[1213] = {'High Orc'}
-- MOBDATA[1214] = {'Choco'}
-- MOBDATA[1215] = {'Stem Worm'}
-- MOBDATA[1216] = {'Penomena'}
MOBDATA[1219] = {'Abysmal Knight / Knight of Abyss'}
-- MOBDATA[1235] = {'Smoking Orc'}
-- MOBDATA[1242] = {'Marin'}
-- MOBDATA[1243] = {'Sasquatch'}
-- MOBDATA[1244] = {'Christmas Jakk'}
-- MOBDATA[1245] = {'Christmas Goblin'}
-- MOBDATA[1246] = {'Christmas Cookie'}
-- MOBDATA[1247] = {'Antonio'}
-- MOBDATA[1248] = {'Cruiser'}
-- MOBDATA[1249] = {'Myst Case'}
-- MOBDATA[1250] = {'Chepet'}
MOBDATA[1251] = {'Stormy Knight / Knight of Windstorm'}
MOBDATA[1252] = {'Garm'}
-- MOBDATA[1253] = {'Gargoyle'}
-- MOBDATA[1254] = {'Raggler'}
-- MOBDATA[1255] = {'Nereid / Neraid'}
-- MOBDATA[1256] = {'Pest'}
-- MOBDATA[1257] = {'Injustice'}
-- MOBDATA[1258] = {'Goblin Archer'}
MOBDATA[1259] = {'Gryphon'}
-- MOBDATA[1260] = {'Dark Frame'}
-- MOBDATA[1261] = {'Wild Rose'}
MOBDATA[1262] = {'Mutant Dragonoid / Mutant Dragon'}
MOBDATA[1263] = {'Wind Ghost'}
-- MOBDATA[1264] = {'Merman'}
-- MOBDATA[1265] = {'Cookie'}
-- MOBDATA[1266] = {'Aster'}
-- MOBDATA[1267] = {'Carat'}
MOBDATA[1268] = {'Bloody Knight'}
-- MOBDATA[1269] = {'Clock'}
-- MOBDATA[1270] = {'Clock Tower Manager'}
-- MOBDATA[1271] = {'Alligator'}
MOBDATA[1272] = {'Dark Lord'}
-- MOBDATA[1273] = {'Orc Lady'}
-- MOBDATA[1274] = {'Megalith'}
-- MOBDATA[1275] = {'Alice'}
-- MOBDATA[1276] = {'Raydric Archer'}
-- MOBDATA[1277] = {'Greatest General'}
-- MOBDATA[1278] = {'Stalactic Golem'}
-- MOBDATA[1279] = {'Tri Joint'}
-- MOBDATA[1280] = {'Goblin Steamrider / Steam Goblin'}
-- MOBDATA[1281] = {'Sage Worm'}
-- MOBDATA[1282] = {'Kobold Archer'}
MOBDATA[1283] = {'Chimera'}
-- MOBDATA[1285] = {'Archer Guardian'}
-- MOBDATA[1286] = {'Knight Guardian'}
-- MOBDATA[1287] = {'Soldier Guardian'}
-- MOBDATA[1288] = {'Emperium'}
MOBDATA[1289] = {'Maya Purple'}
MOBDATA[1290] = {'Skeleton General'}
MOBDATA[1291] = {'Wraith Dead'}
MOBDATA[1292] = {'Mini Demon'}
MOBDATA[1293] = {'Creamy Fear'}
-- MOBDATA[1294] = {'Killer Mantis'}
MOBDATA[1295] = {'Owl Baron'}
-- MOBDATA[1296] = {'Kobold Leader'}
-- MOBDATA[1297] = {'Ancient Mummy'}
-- MOBDATA[1298] = {'Zombie Master'}
-- MOBDATA[1299] = {'Goblin Leader'}
-- MOBDATA[1300] = {'Caterpillar'}
-- MOBDATA[1301] = {'Am Mut'}
MOBDATA[1302] = {'Dark Illusion'}
-- MOBDATA[1303] = {'Giant Hornet'}
-- MOBDATA[1304] = {'Giant Spider'}
-- MOBDATA[1305] = {'Ancient Worm'}
-- MOBDATA[1306] = {'Leib Olmai'}
MOBDATA[1307] = {'Cat o Nine Tails'}
-- MOBDATA[1308] = {'Panzer Goblin'}
-- MOBDATA[1309] = {'Gajomart'}
MOBDATA[1310] = {'Majoruros'}
-- MOBDATA[1311] = {'Gullinbursti'}
MOBDATA[1312] = {'Turtle General'}
MOBDATA[1313] = {'Mobster'}
-- MOBDATA[1314] = {'Permeter'}
-- MOBDATA[1315] = {'Assaulter'}
-- MOBDATA[1316] = {'Solider'}
-- MOBDATA[1317] = {'Fur Seal / Seal'}
-- MOBDATA[1318] = {'Heater'}
-- MOBDATA[1319] = {'Freezer'}
MOBDATA[1320] = {'Owl Duke'}
-- MOBDATA[1321] = {'Dragon Tail'}
-- MOBDATA[1322] = {'Spring Rabbit'}
-- MOBDATA[1323] = {'Sea Otter'}
MOBDATA[1365] = {'Apocalypse'}
MOBDATA[1366] = {'Lava Golem'}
-- MOBDATA[1367] = {'Blazer'}
-- MOBDATA[1368] = {'Geographer'}
-- MOBDATA[1369] = {'Grand Peco'}
MOBDATA[1370] = {'Succubus'}
MOBDATA[1371] = {'Fake Angel / False Angel'}
-- MOBDATA[1372] = {'Goat'}
MOBDATA[1373] = {'Lord of Death / Lord of the Dead'}
MOBDATA[1374] = {'Incubus'}
-- MOBDATA[1375] = {'The Paper'}
-- MOBDATA[1376] = {'Harpy'}
-- MOBDATA[1377] = {'Elder'}
-- MOBDATA[1378] = {'Demon Pungus'}
MOBDATA[1379] = {'Nightmare Terror'}
MOBDATA[1380] = {'Driller'}
MOBDATA[1381] = {'Grizzly'}
MOBDATA[1382] = {'Diabolic'}
MOBDATA[1383] = {'Explosion'}
MOBDATA[1384] = {'Deleter (Sky)'}
MOBDATA[1385] = {'Deleter (Earth)'}
-- MOBDATA[1386] = {'Rochoso'}
MOBDATA[1387] = {'Gig'}
MOBDATA[1388] = {'Archangeling / Arc Angeling'}
MOBDATA[1389] = {'Dracula'}
MOBDATA[1390] = {'Violy'}
-- MOBDATA[1391] = {'Galapago'}
-- MOBDATA[1392] = {'Rotar Zairo'}
MOBDATA[1395] = {'Wind Crystal'}
MOBDATA[1396] = {'Earth Crystal'}
MOBDATA[1397] = {'Fire Crystal'}
MOBDATA[1398] = {'Water Crystal'}
MOBDATA[1399] = {'Baphomet (Event)'}
-- MOBDATA[1400] = {'Karakasa'}
-- MOBDATA[1401] = {'Shinobi'}
-- MOBDATA[1402] = {'Poison Toad'}
-- MOBDATA[1403] = {'Firelock Soldier / Antique Firelock'}
-- MOBDATA[1404] = {'Miyabi Doll / Miyabi Ningyo'}
-- MOBDATA[1405] = {'Tengu'}
-- MOBDATA[1406] = {'Kapha'}
-- MOBDATA[1408] = {'Bloody Butterfly'}
-- MOBDATA[1409] = {'Dumpling Child / Rice Cake Boy'}
MOBDATA[1410] = {'Enchanted Peach Tree / Live Peach Tree'}
MOBDATA[1412] = {'Evil Cloud Hermit / Taoist Hermit'}
MOBDATA[1412] = {'Taoist Hermit / Evil Cloud Hermit'}
-- MOBDATA[1413] = {'Wild Ginseng / Hermit Plant'}
-- MOBDATA[1415] = {'Baby Leopard'}
MOBDATA[1416] = {'Evil Nymph / Wicked Nymph'}
-- MOBDATA[1417] = {'Zipper Bear'}
MOBDATA[1418] = {'Evil Snake Lord'}
MOBDATA[1492] = {'Incantation Samurai / Samurai Specter'}
-- MOBDATA[1493] = {'Dryad'}
-- MOBDATA[1494] = {'Beetle King'}
-- MOBDATA[1495] = {'Stone Shooter'}
-- MOBDATA[1497] = {'Wooden Golem'}
-- MOBDATA[1498] = {'Wootan Shooter'}
-- MOBDATA[1499] = {'Wootan Fighter'}
-- MOBDATA[1500] = {'Parasite'}
-- MOBDATA[1503] = {'Gibbet'}
-- MOBDATA[1504] = {'Dullahan'}
MOBDATA[1505] = {'Loli Ruri'}
-- MOBDATA[1506] = {'Disguise'}
MOBDATA[1507] = {'Bloody Murderer'}
-- MOBDATA[1508] = {'Quve'}
-- MOBDATA[1509] = {'Lude'}
-- MOBDATA[1510] = {'Heirozoist / Hylozoist'}
MOBDATA[1511] = {'Amon Ra'}
-- MOBDATA[1512] = {'Yao Jun / Hyegun'}
-- MOBDATA[1513] = {'Civil Servant / Mao Guai'}
-- MOBDATA[1514] = {'Dancing Dragon / Zhu Po Long'}
MOBDATA[1515] = {'Garm Baby'}
-- MOBDATA[1516] = {'Mi Gao / Increase Soil'}
MOBDATA[1517] = {'Li Me Mang Ryang / Jing Guai'}
MOBDATA[1518] = {'White Lady / Bacsojin'}
MOBDATA[1519] = {'Chung E / Green Maiden'}
MOBDATA[1520] = {'Boiled Rice'}
MOBDATA[1582] = {'Deviling'}
MOBDATA[1583] = {'Tao Gunka'}
-- MOBDATA[1584] = {'Tamruan'}
MOBDATA[1585] = {'Mime Monkey'}
-- MOBDATA[1586] = {'Leaf Cat'}
-- MOBDATA[1587] = {'Kraben'}
-- MOBDATA[1588] = {'Christmas Orc'}
-- MOBDATA[1613] = {'Metaling'}
MOBDATA[1614] = {'Mineral'}
MOBDATA[1615] = {'Obsidian'}
MOBDATA[1616] = {'Pitman'}
MOBDATA[1617] = {'Waste Stove / Old Stove'}
-- MOBDATA[1618] = {'Ungoliant'}
-- MOBDATA[1619] = {'Porcellio'}
MOBDATA[1620] = {'Noxious'}
MOBDATA[1621] = {'Venomous'}
MOBDATA[1622] = {'Teddy Bear'}
MOBDATA[1623] = {'RSX-0806 / RSX 0806'}
MOBDATA[1627] = {'Anopheles'}
--MOBDATA[1628] = {'Holden / Mole'}
MOBDATA[1629] = {'Hill Wind'}
-- MOBDATA[1632] = {'Gremlin'}
-- MOBDATA[1633] = {'Beholder'}
MOBDATA[1634] = {'Seyren Windsor / Seyren'}
MOBDATA[1635] = {'Eremes Guile / Eremes'}
MOBDATA[1636] = {'Harword / Howard Alt-Eisen'}
MOBDATA[1636] = {'Howard Alt-Eisen / Harword'}
MOBDATA[1637] = {'Margaretha Sorin / Magaleta'}
MOBDATA[1638] = {'Shecil / Cecil Damon'}
MOBDATA[1639] = {'Kathryne Keyron / Katrinn'}
MOBDATA[1646] = {'Lord Knight Seyren'}
MOBDATA[1647] = {'Assassin Cross Eremes'}
MOBDATA[1648] = {'Whitesmith Harword / Whitesmith Howard'}
MOBDATA[1649] = {'High Priest Margaretha / High Priest Magaleta'}
MOBDATA[1650] = {'Sniper Shecil / Sniper Cecil'}
MOBDATA[1651] = {'High Wizard Katrinn / High Wizard Kathryne'}
MOBDATA[1652] = {'Ygnizem / Egnigem Cenia'}
MOBDATA[1653] = {'Whikebain / Wickebine Tres'}
MOBDATA[1654] = {'Armeyer Dinze / Armaia'}
MOBDATA[1655] = {'Erend / Errende Ebecee'}
MOBDATA[1656] = {'Kavac / Kavach Icarus'}
MOBDATA[1657] = {'Laurell Weinder / Rawrel'}
MOBDATA[1658] = {'Egnigem Cenia (MVP) / Ygnizem (MVP)'}
MOBDATA[1664] = {'Photon Cannon (Lv 66)'}
MOBDATA[1665] = {'Photon Cannon (Lv 67)'}
MOBDATA[1666] = {'Photon Cannon (Lv 64)'}
MOBDATA[1667] = {'Photon Cannon (Lv 65)'}
MOBDATA[1668] = {'Archdam'}
MOBDATA[1670] = {'Dimik (Wind)'}
MOBDATA[1671] = {'Dimik (Water)'}
MOBDATA[1672] = {'Dimik (Earth)'}
MOBDATA[1673] = {'Dimik (Fire)'}
MOBDATA[1674] = {'Monemus'}
MOBDATA[1675] = {'Venatu (Fire)'}
MOBDATA[1676] = {'Venatu (Normal)'}
MOBDATA[1677] = {'Venatu (Wind)'}
MOBDATA[1678] = {'Venatu (Earth)'}
MOBDATA[1679] = {'Venatu (Water)'}
MOBDATA[1680] = {'Hill Wind'}
MOBDATA[1681] = {'Gemini-S58'}
--MOBDATA[1682] = {'Remover / Removal'}
MOBDATA[1685] = {'Vesper'}
-- MOBDATA[1686] = {'Orc Baby'}
-- MOBDATA[1687] = {'Green Iguana / Grove'}
MOBDATA[1688] = {'Lady Tanee'}
MOBDATA[1692] = {'Breeze'}
MOBDATA[1693] = {'Plasma (Ghost)'}
MOBDATA[1694] = {'Plasma (Fire)'}
MOBDATA[1695] = {'Plasma (Earth)'}
MOBDATA[1696] = {'Plasma (Shadow)'}
MOBDATA[1697] = {'Plasma (Water)'}
MOBDATA[1698] = {'Death Word / Deathword'}
MOBDATA[1699] = {'Ancient Mimic'}
MOBDATA[1700] = {'Observation / Dame of Sentinel'}
MOBDATA[1701] = {'Mistress of Shelter / Shelter'}
MOBDATA[1702] = {'Baroness of Retribution / Retribution'}
MOBDATA[1703] = {'Lady Solace / Solace'}
MOBDATA[1704] = {'Thanatos Odium / Odium of Thanatos'}
MOBDATA[1705] = {'Thanatos Despero / Despero of Thanatos'}
MOBDATA[1706] = {'Thanatos Maero / Maero of Thanatos'}
MOBDATA[1707] = {'Thanatos Dolor / Dolor of Thanatos'}
MOBDATA[1708] = {'Thanatos Phantom / Thanatos'}
MOBDATA[1713] = {'Acidus (Holy)'}
MOBDATA[1714] = {'Ferus (Fire)'}
MOBDATA[1715] = {'Novus'}
MOBDATA[1716] = {'Acidus (Water)'}
MOBDATA[1717] = {'Ferus (Earth)'}
MOBDATA[1718] = {'Novus'}
MOBDATA[1719] = {'Detardeurus / Detale'}
MOBDATA[1720] = {'Hydrolancer / Hydro'}
-- MOBDATA[1721] = {'Dragon Egg'}
MOBDATA[1733] = {'Kiel'}
MOBDATA[1734] = {'Kiel D-01'}
MOBDATA[1735] = {'Alicel'}
MOBDATA[1736] = {'Aliot'}
MOBDATA[1737] = {'Aliza'}
MOBDATA[1738] = {'Constant'}
MOBDATA[1751] = {'Valkyrie Randgris'}
MOBDATA[1752] = {'Skogul'}
MOBDATA[1753] = {'Frus'}
MOBDATA[1754] = {'Skeggiold (Black/Lv 81)'}
MOBDATA[1755] = {'Skeggiold (Cobaltblue/Lv 83)'}
-- MOBDATA[1772] = {'Isilla'}
-- MOBDATA[1774] = {'Seeker'}
-- MOBDATA[1771] = {'Vanberk'}
-- MOBDATA[1773] = {'Hodremlin'}

-----------------------------
-- Lista de MVP no tem KS --
-----------------------------
MVP_LIST = { }

MVP_LIST[1038] = {'Osiris'}
MVP_LIST[1039] = {'Baphomet'}
MVP_LIST[1046] = {'Doppelganger'}
MVP_LIST[1059] = {'Mistress'}
MVP_LIST[1086] = {'Golden Thief Bug'}
MVP_LIST[1087] = {'Orc Hero'}
MVP_LIST[1112] = {'Drake'}
MVP_LIST[1115] = {'Eddga'}
MVP_LIST[1147] = {'Maya'}
MVP_LIST[1150] = {'Moonlight Flower'}
MVP_LIST[1157] = {'Pharaoh'}
MVP_LIST[1159] = {'Phreeoni'}
MVP_LIST[1190] = {'Orc Lord'}
MVP_LIST[1252] = {'Garm'}
MVP_LIST[1272] = {'Dark Lord'}
MVP_LIST[1312] = {'Turtle General'}
MVP_LIST[1373] = {'Lord of Death / Lord of the Dead'}
MVP_LIST[1389] = {'Dracula'}
MVP_LIST[1399] = {'Baphomet (Event)'}
MVP_LIST[1418] = {'Evil Snake Lord'}
MVP_LIST[1492] = {'Incantation Samurai / Samurai Specter'}
MVP_LIST[1511] = {'Amon Ra'}
MVP_LIST[1518] = {'White Lady / Bacsojin'}
MVP_LIST[1583] = {'Tao Gunka'}
MVP_LIST[1623] = {'RSX-0806 / RSX 0806'}
MVP_LIST[1646] = {'Lord Knight Seyren'}
MVP_LIST[1647] = {'Assassin Cross Eremes'}
MVP_LIST[1648] = {'Whitesmith Harword / Whitesmith Howard'}
MVP_LIST[1649] = {'High Priest Margaretha / High Priest Magaleta'}
MVP_LIST[1650] = {'Sniper Shecil / Sniper Cecil'}
MVP_LIST[1651] = {'High Wizard Katrinn / High Wizard Kathryne'}
MVP_LIST[1658] = {'Egnigem Cenia (MVP) / Ygnizem (MVP)'}
MVP_LIST[1685] = {'Vesper'}
MVP_LIST[1688] = {'Lady Tanee'}
MVP_LIST[1708] = {'Thanatos Phantom / Thanatos'}
MVP_LIST[1719] = {'Detardeurus / Detale'}
--MVP_LIST[1733] = {'Kiel'}
MVP_LIST[1734] = {'Kiel D-01'}

MVP_LIST[1177] = {'Zenorc'}

--------------------------------------------------
function IsMVP(ID)
-- Verify if this monster is a MVP is NO KS
--------------------------------------------------
	if MVP_LIST[ID] == nil then -- Mostro no  MVP
		return False
	else
		TraceAI(string.format("MVP Monster detected ID(%d) [%s]: ", ID,MVP_LIST[ID][M_V_NAME]))
	end
	return True
end

--------------------------------------------------
function IsDangerousMonster(ID)
-- Verify if this monster is in DANGEROUS LIST
--------------------------------------------------
	if MOBDATA[ID] == nil then -- Ok mostro no classificado como perigoso
		return 0
	else
--		TraceAI(string.format("DANGEROUS Monster detected ID(%d) [%s]: Level %d - Atk Min: %d - Atk Max: %d", ID,MOBDATA[ID][M_V_NAME], MOBDATA[ID][M_V_LV], MOBDATA[ID][M_V_ATKMIN], MOBDATA[ID][M_V_ATKMAX]))
		TraceAI(string.format("DANGEROUS Monster detected ID(%d) [%s]: ", ID,MOBDATA[ID][M_V_NAME]))
	end
	return 1
end

--------------------------------------------------
function ShutDownRagnarok()  -- Exit from Ragnarok
--------------------------------------------------
	os.exit(0) -- Exit from the game
end
